

(define (conf-additional)
  
  ; var
  (define context 'admin)
  (define table '())
  (define status '())
  
  ; lib

  (define (list-valid n)
    (filter string?
      (map (lambda (x y)
             (cond
               ((not (cadr x))
                 #f)
               (else
                 (list-ref y n))))
        status
        table)))
  
  (define (have? x)
    (= 0 (sh "COLUMNS=130 dpkg -l | grep '^ii  ~a '" x)))
  
  
  ; method
  
  (define (init c cui?)
    (set! context c)
    (let ((r0 (ttable-read "/usr/lib/ogl/lib/additional"
               '((str str str sym bool str str str str str str))))
          (r1 (ttable-read "/var/lib/ogl/etc/pkgsel" '((sym)))))
      (cond
        ((eq? #f r0)
          (inst-log "could not read 'additional'.\n")
          #f)
        ((eq? #f r1)
          (inst-log "could not read 'pkgsel'.\n")
          #f)
        (else
          (set! table r0)
          (set! status
            (map (lambda (x)
                   (cons (car x)
                     (cond
                       ((have? (cadr x))
                         (list #f #t 'installed))
                       ((and (equal? (list-ref x 3) 'ws)
                             (not (ormap (lambda (x) (equal? 'ws x))
                                         (map car r1))))
                         (list #f #f 'not-pkg-selected))
                       ((not (have? (car x)))
                         (list #f #f 'not-selected))
                       ((not (= 0 (sh (list-ref x 8))))
                         (list #f #t 'not-ready))
                       ((and cui? (not (list-ref x 4)))
                         (list #f #t 'use-x))
                       (else
                         (list #t #t 'ready)))))
                 table))
          #t))))
  
  (define (desc)
    (map _ (list-valid 2)))
  
  (define (license) (list-valid 5))
  
  (define (asking)
    (map _ (list-valid 6)))
  
  (define (waiting)
    (map _ (list-valid 7)))
  
  (define (installer) (list-valid 9))
  
  (define (status-all)
    (filter (lambda (x) (not (boolean? x)))
      (map (lambda (x y)
             (cond
               ((not (caddr x))
                 #f)
               (else
                 (cons (caddr y)
                   (case (list-ref x 3)
                     ((installed)
                       (_ "installed"))
                     ((use-x)
                       (_ "installable under X"))
                     ((not-ready)
                       (_ "currently not installale"))
                     (ready
                       (if (have? (cadr y))
                         (_ "newly installed")
                         (_ "not installed"))))))))
         status
         table)))
  
  (define (status-it)
    (filter (lambda (x) (not (boolean? x)))
      (map (lambda (x y)
             (cond
               ((not (caddr x))
                 #f)
               (else
                 (case (list-ref x 3)
                   (ready
                     (if (have? (cadr y))
                       (_ "installed")
                       (_ "installable")))
                   (else
                     #f)))))
         status
         table)))
  
  ; $B$"$H(B remove $B$,I,MW$+!&!&(B
  
  (make-object
    'init            init
    'info            (lambda () status)
    'desc            desc
    'license         license
    'asking          asking
    'waiting         waiting
    'installer       installer
    'status          status-it
    'status-all      status-all
    'table           (lambda () table)
    ))

