;
;     New Autopart
;                           (C) 2002 Omoikane Inc.
;

(define (conf-autopart obj-part)
   
;  (define init-part '())         ; ѡƥνꥹ
  (define default-fs 'linux-xfs)
  
  (define region '())            ; (<did> <st> <ed>) Υꥹ
  (define (reg.did r) (car r))
  (define (reg.st r) (cadr r))
  (define (reg.ed r) (caddr r))
  
  ; lib
  (define (reg-size r)
    ;(inst-log "reg-size : ~a\n" r)
    (let* ((d (reg.did r))
           (u (obj-part 'unit-size d))
           (b (obj-part 'block-size d)))
      (i/ (* (1+ (- (reg.ed r) (reg.st r)))
             u b)
          (* 1024 1024))))
  ; MB ֤
  
  (define (cover? s0 e0 s1 e1)
    (and (not (< e0 s1))
         (not (< e1 s0))))
  
  (define (reg<=? s0 e0 s1 e1)
    (and (<= s1 s0) (<= e0 e1)))
  
  ; r ˤäƥѡƥ p Ȥʤ뤫ɤ
  (define (remove? r x)
    (and (equal? (cadr x) (reg.did r))
         (if (id-extended? (list-ref x 8))
           (and (<= (reg.st r) (list-ref x 5)) (<= (list-ref x 5) (reg.ed r)))
           (cover? (reg.st r) (reg.ed r) (list-ref x 5) (list-ref x 6)))))
  
  (define (split-gen new? r)
    (let* ((a (filter (lambda (x)
                        (and (not (equal? 'empty (car x)))
                             (not (remove? r x))))
                      (obj-part 'list-part (reg.did r))))
           (l (length (filter (lambda (x) (id-primary? (list-ref x 3)))
                              a)))
           (e (filter (lambda (x) (id-extended? (list-ref x 8)))
                      a)))
      (cond
        ((in-ext? r)
          #t)
        ((null? (filter (lambda (x) (id-extended? (list-ref x 8)))
                        a))
          (if new? (< 2 l) (< l 4)))
        (else
          (if new? #f (< l 3))))))
  ; ΰ <r> ⤽ĥΰˤ뤫
  ; ΰ <r> ֤ǡĥѡƥ󤬤ʤĥץ饤ޥ꤬Ƥ
  ; 礫뤤Ϥ⤽ܥѡƥ󤬣ĶƤ
  
  (define (split? r)
    (split-gen #f r))
  
  (define (split-prep? r)
    (let ((l (filter (lambda (x) (equal? (reg.did r) (reg.did x)))
                     region)))
      (cond
        ((null? l)
          (inst-log "requested region could not find in free list\n")
          #f)
        ((in-ext? r)
          (inst-log "does not need to split region.\n")
          #f)
        (else
          (and (equal? r (car l))
               (split-gen #t r))))))
  
  (define (reg-cover? r0 r1)
    (and (equal? (reg.did r0) (reg.did r1))
         (cover? (reg.st r0) (reg.ed r0) (reg.st r1) (reg.ed r1))))
  
  (define (reg-fit? r0 r1)
    (define (fit? s0 e0 s1 e1)
      (and (not (< (1+ e0) s1))
           (not (< (1+ e1) s0))))
    (and (equal? (reg.did r0) (reg.did r1))
         (fit? (reg.st r0) (reg.ed r0) (reg.st r1) (reg.ed r1))))
  
  (define (in-ext? r)
    (ormap (lambda (x)
             (and (not (equal? 'empty (car x)))
                  (id-extended? (list-ref x 8))
                  (reg<=? (reg.st r) (reg.ed r) (list-ref x 5) (list-ref x 6))))
           (obj-part 'list-part (reg.did r))))
  
  (define (reg-merge r0 r1)
    (let ((s (min (reg.st r0) (reg.st r1)))
          (e (max (reg.ed r0) (reg.ed r1))))
      (list (reg.did r0) s e)))
  
  ; <r>  region ˲ä
  (define (reg-add r)
    (inst-log "reg-add : ~a\n" r)
    (define (rep l)
      ;(inst-log "rep:~a\n" l)
      (cond
        ((null? l)
          (list r))
        (else
          (let ((x (car l)))
            (cond
              ((reg-fit? x r)
                (cons (reg-merge x r) (cdr l)))
              (else
                (cons x (rep (cdr l)))))))))
    (define (flat l)
      ;(inst-log "flat:~a\n" l)
      (cond
        ((or (null? l) (null? (cdr l)))
          l)
        (else
          (let ((x (car l))
                (y (cadr l)))
            (cond
              ((and (equal? (reg.did x) (reg.did y))
                    (= (1+ (reg.ed x)) (reg.st y)))
                (let ((s (reg.st x))
                      (e (reg.ed y)))
                  (cons
                    (list (reg.did x) s e)
                    (cddr l))))
              (else
                (cons x (flat (cdr l)))))))))
    
    (set! region (flat (rep region)))
    (inst-log "reg-added : ~a\n" region)
    #t)
  
  (define (part->reg x)
    (case (car x)
      ((dev)
        (let ((l (filter (lambda (y) (equal? (cadr x) (car y)))
                         (obj-part 'hw-info)))
              (u (obj-part 'unit-size (cadr x))))
          (cond
            ((= 1 (length l))
              (list (cadr x) 1 (i/ (caddr (car l)) u)))
            (else
              #f))))
      ((empty)
        (let ((s (list-ref x 4))
              (e (list-ref x 5)))
          (list (cadr x) s e)))
      (else
        (let ((s (list-ref x 5))
              (e (list-ref x 6)))
          (list (cadr x) s e)))))
  
  (define (region-sort)
    (set! region
          (easy-sort (lambda (x y) (> (reg-size x) (reg-size y)))
                     region))
    (inst-log "region sort : ~a\n" region))
  
  (define (assign r sz t mnt)
    (inst-log "assign ~a ~a ~a ~a\n" r sz t mnt)
    (let* ((d (reg.did r))
           (s (reg.st r))
           (e (if (equal? 'all sz)
                (reg.ed r)
                (min (reg.ed r)
                     (+ s (i/ (* sz 1024 1024)
                              (* (obj-part 'unit-size d)
                                 (obj-part 'block-size d)))))))
           (r' (list d s e))
           (make-ext? (split-prep? r)))
      (inst-log "a\n")
      (cond
        ; ѡƥκ
        ((not (andmap (lambda (x)
                        ;(inst-log "x:~a\n" x)
                        (cond
                          ((and (not (equal? 'empty (car x)))
                                (remove? r x))
                            (inst-log "del\n")
                            (let ((a (obj-part 'delete-part d (list-ref x 3))))
                              (if (not a) (inst-log "could note delete : ~a" x))
                              a))
                          (else
                            #t)))
                      (obj-part 'list-all-part #f)))
          #f)
        
        ((begin (inst-log "y\n") #f) #f)
        
        ; ɬפʾˤϳĥѡƥκ
        ((and make-ext?
              (not (obj-part 'create-part d 'ext -1 s (reg.ed r))))
          (inst-log "could not create extended partition.\n")
          #f)
        
        ((begin (inst-log "z\n") #f) #f)
        ; ѡƥκ
        ((not (obj-part 'create-part d t (if (in-ext? r') 0 -1) s e))
          (inst-log "could not create partition.\n")
          #f)
        
        (else
          (inst-log "x\n")
          (let ((m (obj-part 'add-mnt-r d s e mnt)))
            (cond
              ((string? m)
                (inst-log "adding mount failed : ~a\n" m))
              (else
                 ; ΰι
                 (set! region (filter (lambda (x) (not (equal? r x)))
                                      region))
                 (if (not (equal? 'all sz))
                   (set! region (cons (list d (1+ e) (reg.ed r)) region)))
                 (region-sort)
                 (inst-log "assign finished\n")
                 r')))))))
  
  ; method
  (define (init-flat l c)
    (cond
      ((not (null? (obj-part 'list-always-mnt #t)))
        (inst-log "init-tree : list-mnt not null.\n")
        #f)
      (else
        (map (lambda (x y)
               ;(inst-log "x:~a y:~a\n" x y)
               (if y (reg-add (part->reg x))))
             l
             c)
        (region-sort)
        #t)))
  
  (define (init-tree t)
    (cond
      ((not (null? (obj-part 'list-always-mnt #t)))
        (inst-log "init-tree : list-mnt not null. ~a\n" (obj-part 'list-mnt))
        #f)
      ((not (andmap (lambda (x) (= 2 (length x)))
                    t))
        (inst-log "init-tree : illegal init tree\n")
        #f)
      (else
        (map (lambda (x)
               (reg-add
                 (part->reg
                   (list-ref (obj-part 'list-part
                               (car (list-ref (obj-part 'hw-disc) (car x))))
                             (cadr x)))))
             t)
        (region-sort)
        #t)))
  
  (define (step-swap-ready?)
    (define (no-share? x)
      (null? (filter (lambda (r)
                       (and (equal? (reg.did r) (cadr x))
                            (cover? (reg.st r) (reg.ed r) (list-ref x 5) (list-ref x 6))))
                     region)))
    (let ((l (easy-sort (lambda (a b) (> (caddr a) (caddr b)))
               (filter (lambda (x)
                          (and (equal? (car x) 'swap)
                               (no-share? x)))
                 (obj-part 'list-all-part #f)))))
      (inst-log "e\n")
      (cond
        ((null? l)
          #f)
        (else
          (let ((x (car l)))
            (inst-log "f\n")
            (obj-part 'add-mnt x "swap")
            #t)))))
  
  (define (step-swap)
    (cond
      ((and (null? (obj-part 'hw-ataraid))
            (step-swap-ready?))
        (inst-log "step-swap : using existing one\n")
        #t)
      ((null? region)
        (inst-log "step-swap : no region\n")
        #f)
      (else
        (inst-log "b\n")
        (let* ((smin (max 1
                          (- 256 (i/ (string->number (cadr (cadr (parse-awk #\space #t "/proc/meminfo"))))
                                     (* 1024 1024)))))
               (dummy0 (inst-log "h\n"))
               (smax 512)
               (nmr (cdr region))
               (dummy0 (inst-log "i\n"))
               (mr (car region))
               (dummy0 (inst-log "j\n"))
               (l' (filter (lambda (x) (and (<= smin (reg-size x))
                                            (<= (reg-size x) smax)))
                           nmr))
               (dummy0 (inst-log "k\n"))
               (l'' (filter (lambda (x) (and (<= smin (reg-size x))
                                             (split? x)))
                            nmr)))
          (inst-log "l':~a\nl'':~a" l' l'')
          (cond
            ((not (null? l'))
              (assign (list-last l') 'all 'swap "swap"))
            ((not (null? l''))
              (let* ((p (list-last l''))
                     (st (reg.st p))
                     (sz (min (+ smin (min 100 (reg-size p)))
                              smax)))
                (assign p sz 'swap "swap")))
            ((split? mr)
              (let* ((st (reg.st mr))
                     (sz (min (+ smin (min 100 (reg-size mr)))
                              smax)))
                (assign mr sz 'swap "swap")))
            (else
              (inst-log "Neither could find appropriate size of partition nor split max region.\n")
              #f))))))
  
  (define (step-other-5 sz-root)
    (inst-log "step-other-5\n")
    (cond
      ((and (< sz-root 500) (not (null? region)))
        (let ((mr (car region)))
          (cond
            ((< 200 (reg-size mr))
              (assign mr 'all default-fs "/home"))
            (else
              #t))))
      (else
        #t)))
  
  (define (step-other)
    (inst-log "step-other\n")
    (cond
      ((null? region)
        (inst-log "step-other : no more region for /.\n")
        #f)
      (else
        (let* ((mr (car region))
               (sz (reg-size mr)))
          (inst-log "m\n")
          (cond
            ((and (< 500 sz) (< sz 1300) (split? mr))
              (inst-log "k\n")
              (let* ((szv (+ 200 (i/ (- sz 500) 8)))
                     (r' (assign mr szv default-fs "/var")))
                (cond
                  ((eq? #f r') #f)
                  ((eq? #f (assign (list (reg.did r') (1+ (reg.ed r')) (reg.ed mr)) 'all default-fs "/"))
                    #f)
                  (else
                    (step-other-5 (- sz szv))))))
            ((eq? #f (assign mr 'all default-fs "/"))
              #f)
            ((and (< sz 500) (not (null? (cdr region))))
              (inst-log "l\n")
              (let ((mr' (car (cdr (region))))
                    (sz' (reg-size mr')))
                (cond
                  ((< 200 sz')
                    (cond
                      ((eq? #f (assign mr' 'all default-fs "/var"))
                        #f)
                      (else
                        (step-other-5 sz))))
                  (else
                    #f))))
            (else
              #t))))))
  
  (define (analyze)
    (cond
      ((not (step-swap))
        (inst-log "analyze failed at swap\n")
        #f)
      ((not (step-other))
        (inst-log "analyze failed at other\n")
        #f)
      (else
        (inst-log "analyze finished\n")
        #t)))
  
  (make-object
    'init-flat   init-flat
    'init-tree   init-tree
    'analyze     analyze
  ))
