;;
;;         conffile utils
;; 
;;                            (C) 2001,2002 Omoikane Inc.
;;

;
;     Newt
;

(define (conf-newt-suspend-sh title . l)
  (snewt-finish)
  (unix-system (apply format (cons #f l)))
  (snewt-start)
  (newt-stage-title title))

(define (conf-newt-load/confirm o title)
  (define tmpd
    (let ((d (unix-tempname)))
      (cond
        ((not (and (= 0 (sh "mkdir ~a" d))
                   (= 0 (sh "chmod 700 ~a" d))))
          (inst-log "patcher : could not mkdir ~a" d)
          #f)
        (else
          d))))

    (_ "Starting pager ...\n\n   - 'q' for quit viewing\n   - cursor keys for moving")
  
  (define (view t)
    (let ((r (snewt-nmenu title
               (string-append
                 (format #f (_ "Configuration : ~a") t)
                 "\n\n"
                 (_ "Selecting 'view *' button will start the pager program. In pager, use keys below.\n\n")
                 (_ "  'q' for quit viewing\n")
                 (_ "  cursor keys for moving\n"))
               50 5 5 6
               (vector (_ "view current") (_ "view previous") (_ "view difference")
                       (_ "ignore difference") (_ "try to keep difference"))
               (vector (_ "Ok")))))
      (case (car r)
        ((-1) #f)
        ((1) #t)
        (else
          (case (cdr r)
            ((3)
              (if (not (o 'remove t))
                (inst-log "remove failed\n"))
              #t)
            ((4)
              (if (not (o 'remake t))
                (inst-log "remake failed\n"))
              #t)
            (else
              (let ((tmp (unix-tempname tmpd)))
                (case (cdr r)
                  ((0)
                    (conf-newt-suspend-sh title "lv ~a" t))
                  ((1)
                    (o 'make-cur t tmp)
                    (conf-newt-suspend-sh title "lv ~a" tmp))
                  (else
                    (o 'make-diff t tmp)
                    (conf-newt-suspend-sh title "lv ~a" tmp)))
                (sh "rm ~a" tmp)
                (view t))))))))
  
  (define (confirm l)
    (cond
      ((null? l)
        #t)
      (else
        (let ((r (snewt-nmenu title
                   (string-append
                     (_ "Configuration file(s) below was/were modified since this tool had written last time. ")
                     (_ "This tool will overwrite at the end of configuration. ")
                     (_ "If you select 'Try to keep Diff', this tool will try to keep the difference in patch command style. ")
                     "\n\n"
                     (_ "Do you proceed anyway?"))
                   64 5 5 5
                   (list->vector l)
                   (vector (_ "View") (_ "Ignore Diff") (_ "Try to keep Diff") (_ "Cancel")))))
          (case (car r)
            ((-1 4)
              #f)
            ((0 1)
              (view (list-ref l (cdr r)))
              (confirm (o 'list-modify)))
            ((2)
              (andmap (lambda (x) (o 'remove x))
                      l))
            (else
              (andmap (lambda (x) (o 'remake x))
                      l)))))))
  
  (newt-stage-title title)
  (let* ((r (cond
              ((eq? #f tmpd)
                (inst-log "could not create ~a\n" tmpd)
                #f)
              ((o 'load)
                (confirm (o 'list-modify)))
              (else
                (let* ((l (o 'mid-conf))
                       (r1 (snewt-choice title
                             (apply string-append
                               (append
                                 (list
                                   (_ "Some tool specific file(s) seems to be broken or have version difference.\n\n")
                                   (_ "Do you abandon older setting and proceed?\n")
                                   (_ "Pressing 'Yes' will erase files below :\n\n"))
                                 (map (lambda (x) (format #f "  ~a\n" x)) l)))
                             (_ "Yes") (_ "No"))))
                  (cond
                    ((not (= 1 r1))
                      #f)
                    (else
                      (map (lambda (x) (sh "rm ~a" x))
                           l)
                      (cond
                        ((o 'load)
                          #t)
                        (else
                          (snewt-message title
                            (_ "Could not load configuration anyway. Quit this tool and start again, please."))
                          #f)))))))))
    (sh "rm -rf ~a" tmpd)
    r))

(define (conf-newt-finish o title)
  (define tmpd
    (let ((d (unix-tempname)))
      (cond
        ((not (and (= 0 (sh "mkdir ~a" d))
                   (= 0 (sh "chmod 700 ~a" d))))
          (inst-log "patcher : could not mkdir ~a" d)
          #f)
        (else
          d))))
  
  (define (view t)
    (let ((r (snewt-nmenu title
               (format #f (_ "Configuration : ~a") t)
               50 5 5 6
               (vector (_ "view current") (_ "view previous") (_ "ignogre difference"))
               (vector (_ "Ok") (_ "Cancel")))))
      (case (car r)
        ((-1 2) #f)
        ((1) #t)
        (else
          (case (cdr r)
            ((1)
              (conf-newt-suspend-sh title "lv ~a" t)
              (view t))
            ((2)
              (o 'remove t))
            (else
              (let ((tmp (unix-tempname tmpd)))
                (o 'make-cur t tmp)
                (conf-newt-suspend-sh title "lv ~a" tmp)
                (sh "rm ~a" tmp)
                (view t))))))))
  
  (define (confirm l)
    (cond
      ((null? l)
        #t)
      (else
        (let ((r (snewt-nmenu title
                   (_ "Configuration file(s) below could not be created with older difference.")
                   64 5 5 5
                   (list->vector l)
                   (vector (_ "View") (_ "Ignore Diff") (_ "Cancel")))))
          (case (car r)
            ((-1 3)
              #f)
            ((0 1)
              (view (list-ref l (cdr r)))
              (confirm (o 'list-fail)))
            (else
              (andmap (lambda (x) (o 'remove x))
                      l)))))))

  (define (postconf)
    (cond
      ((not (o 'postconf?))
        #t)
      (else
        (andmap (lambda (x)
                  (let ((t (car x))
                        (m (cadr x))
                        (f (caddr x)))
                    (let ((r (cond
                               ((equal? "" t)
                                 (f))
                               (else
                                 (snewt-show-while t m 40 4 f)))))
                      (cond
                        ((not r)
                          (snewt-message (_ "Error")
                            (format #f (_ "Failed for '~a'." t))))
                        (else
                          #t)))))
          (o 'do-postconf)))))
  
  (let ((l (o 'list-fail)))
    (cond
      ((not (or (null? l)
                (confirm l)))
        #f)
      ((not (postconf))
        #f)
      (else
        (o 'commit)))))


;
;     Gtk 
;

(define (conf-gtk-load/confirm w o)
  (define tmpd
    (let ((d (unix-tempname)))
      (cond
        ((not (and (= 0 (sh "mkdir ~a" d))
                   (= 0 (sh "chmod 700 ~a" d))))
          (inst-log "patcher : could not mkdir ~a" d)
          #f)
        (else
          d))))
  
  (define (confirm l)
    (if (null? l)
      #t
      (let ((v0 (sgtk-vbox-new #f 10))
            (v1 (sgtk-vbox-new #t 10))
            (a (sgtk-alignment-new 0.8 0.8 0.8 0.8))
            (lb (apply sgtk-labelbox (cons #t l)))
            (m (sgtk-label-normalized-new
                 (string-append
                    (_ "Configuration file(s) below was/were modified since this tool had written last time. ")
                    (_ "This tool will overwrite at the end of configuration. ")
                    (_ "If you select 'Try to keep Diff', this tool will try to keep the difference in patch command style. "))))
            (hr0 (sgtk-hseparator-new))
            (bb (sgtk-bbox #t (sgnome-stock-button "Button_Cancel")
                              (sgtk-button-new-with-label (_ "Ignore Diff"))
                              (sgtk-button-new-with-label (_ "Try to keep Diff")))))
        (sgtk-container-add v0 v1)
        (sgtk-container-add a (lb 'widget))
        (sgtk-box-pack-start v1 m #t #t 0)
        (sgtk-box-pack-start v1 a #f #f 0)
        (sgtk-box-pack-start v0 (bb 'widget) #f #f 0)
        (sgtk-paned-pack2 w v0 #t #f)
        (sgtk-widget-show-all w)
        (sgtk-main)
        (sgtk-container-remove w v0)
        (inst-log "ret : ~a\n" (bb 'info))
        (case (bb 'info)
          ((0)
            #f)
          ((1)
            (andmap (lambda (x) (o 'remove x))
                    l))
          ((2)
            (andmap (lambda (x) (o 'remove x))
                    l))
          (else
            (let ((t (list-ref l (lb 'info)))
                  (tmp (unix-tempname tmpd)))
              (o 'make-cur t tmp)
              (sh "gtkdiff ~a ~a &" t tmp)
              (confirm (o 'list-modify))))))))
  
  (let* ((r (cond
              ((eq? #f tmpd)
                (inst-log "could not create ~a\n" tmpd)
                #f)
              ((o 'load)
                (confirm (o 'list-modify)))
              (else
                (let* ((l (o 'mid-conf))
                       (r1 (sgtk-choice w
                             (apply string-append
                               (append
                                 (list
                                   (_ "Some tool specific file(s) seems to be broken or have version difference.\n\n")
                                   (_ "Do you abandon older setting and proceed?\n")
                                   (_ "Pressing 'Yes' will erase files below :\n\n"))
                                 (map (lambda (x) (format #f "  ~a\n" x)) l)))
                             "Button_No" "Button_Yes")))
                  (cond
                    ((not (= 1 r1))
                      #f)
                    (else
                      (map (lambda (x) (sh "rm ~a" x))
                           l)
                      (cond
                        ((o 'load)
                          #t)
                        (else
                          (sgtk-message-error
                            (_ "Could not load configuration anyway. Quit this tool and start again, please."))
                          #f)))))))))
    (sh "rm -rf ~a" tmpd)
    r))


(define (conf-gtk-finish w o)
  (define tmpd
    (let ((d (unix-tempname)))
      (cond
        ((not (and (= 0 (sh "mkdir ~a" d))
                   (= 0 (sh "chmod 700 ~a" d))))
          (inst-log "patcher : could not mkdir ~a" d)
          #f)
        (else
          d))))
  
  (define (confirm l)
    (let ((v0 (sgtk-vbox-new #f 10))
          (v1 (sgtk-vbox-new #t 10))
          (a (sgtk-alignment-new 0.8 0.8 0.8 0.8))
          (lb (apply sgtk-labelbox (cons #t l)))
          (m (sgtk-label-normalized-new
               (string-append
                  (_ "Configuration file(s) below was/were modified since this tool had written last time. ")
                  (_ "This tool will overwrite at the end of configuration.\n\nDo you proceed anyway?"))))
          (hr0 (sgtk-hseparator-new))
          (bb (sgtk-bbox #t (sgnome-stock-button "Button_Cancel")
                            (sgtk-button-new-with-label (_ "Ignore Diff")))))
      (sgtk-container-add v0 v1)
      (sgtk-container-add a (lb 'widget))
      (sgtk-box-pack-start v1 m #t #t 0)
      (sgtk-box-pack-start v1 a #f #f 0)
      (sgtk-box-pack-start v0 (bb 'widget) #f #f 0)
      (sgtk-paned-pack2 w v0 #t #f)
      (sgtk-widget-show-all w)
      (sgtk-main)
      (sgtk-container-remove w v0)
      (inst-log "ret : ~a\n" (bb 'info))
      (case (bb 'info)
        ((0)
          #f)
        ((1)
          (andmap (lambda (x) (o 'remove x))
                  l))
        (else
          (let ((t (list-ref l (lb 'info)))
                (tmp (unix-tempname tmpd)))
            (o 'make-cur t tmp)
            (sh "gtkdiff ~a ~a &" t tmp)
            (confirm (o 'list-modify)))))))
  
  (define (postconf)
    (cond
      ((not (o 'postconf?))
        #t)
      (else
        (andmap (lambda (x)
                  (let ((t (car x))
                        (m (cadr x))
                        (f (caddr x)))
                    (let ((r (cond
                               ((equal? "" t)
                                 (f))
                               (else
                                 (sgtk-show-while-new t m f)))))
                      (cond
                        ((not r)
                          (sgtk-message-error
                            (format #f (_ "Failed for '~a'." t))))
                        (else
                          #t)))))
          (o 'do-postconf)))))
  
  (let ((l (o 'list-fail)))
    (cond
      ((not (or (null? l)
                (confirm l)))
        #f)
      ((not (postconf))
        #f)
      (else
        (o 'commit)))))

