#!/bin/sh
string=?;exec /usr/bin/elk -c -l $0 -p /usr/lib/ogl/scm:/usr/lib/elk/scm:/usr/lib/elk/obj:`pwd` $* 2>/dev/null

(load "gtk.scm")
(load "gtk-obj.scm")
(load "gtk-middle.scm")
(load "util.scm")
(load "obj.scm")
(load "prod.scm")
(load "net.scm")
(load "service.scm")


(set! inst-log-context 'user)

(require 'unix)

(define have-gnome? (unix-access? "/usr/bin/gnome-session" '(execute)))
(define have-kde? (unix-access? "/usr/bin/startkde" '(execute)))

(define orca-str
  (let* ((obj-net (configure-network))
         (obj-sv (configure-service))
         (obj-pd (conf-prod obj-net obj-sv)))
    (obj-pd 'load)
    (case (obj-pd 'product-type)
      ((orca)
        "gllogin start&\n")
      (else
        ""))))

(define rc
  (format #f "~a/.xinitrc-desktop" (unix-getenv "HOME")))

(define (set-gnome)
  (fprintf rc (format #f "~aexec gnome-session\n" orca-str)))

(define (set-kde)
  (fprintf rc (format #f "~aexec startkde\n" orca-str)))

(sgtk-start)
(textdomain "ogl-admin" "/usr/share/locale")
(let ((w (sgtk-window-new-toplevel))
      (p (sgtk-hpaned-new)))
  (sgtk-window-set-title w (_ "Desktop Chooser"))
  (sgtk-signal-connect w "delete_event" (lambda (w e) (run-stage fin)))
  (sgtk-container-set-border-width w 5)
  (sgtk-widget-set-usize w 480 300)
  (sgtk-container-add w p)
  (sgtk-widget-show-all w)
  
  (cond
    ((and (not have-kde?) (not have-gnome?))
      (sgtk-message-error
        (_ "This system contains neither GNOME nor KDE. Please edit ~/.xinitrc directly and restart X.")))
    ((not have-kde?)
      (set-gnome))
    ((not have-gnome?)
      (set-kde))
    (else
      (let ((r (sgtk-choice-str p
                 (_ "You can choose desktop from GNOME and KDE. \n")
                 "GNOME" "KDE")))
        (sgtk-message-info
          (_ "After this, you can change desktop by editing ~/.xinitrc-desktop or ~/.xinitrc directly."))
        (cond
          ((= r 1)
            (set-kde))
          (else
            (set-gnome)))))))
