;
;		fdisk object
;

(define (conf-fdisk)
  ; var
  (define sid "")
  (define dev "")
  (define update? #f)
  
  ; libs
  (define (restore)
    (lf-switch sid))
    
  (define (update)
    (set! update? #t))
  
  ; method
  (define (init x)
    (cond
      ((< sid 0)
        #f)
      (else
        (restore)
        (set! update? #f)
        (set! dev x)
        (= 0 (lf-open x)))))
  
  (define (close)
    (and (restore)
         (lf-close)))
  
  (define (write-it)
    (and (restore)
         (if update? (lf-write) #t)
         (lf-close)))
  
  (define (write-reopen)
    (and (restore)
         (if update? (lf-write) #t)
         (lf-close)
         (begin
           (set! sid (lf-new))
           (init dev)
           #t)))
  
  (define (get-disk)
    (if (restore)
      (lf-get-disk)
      '()))
  
  (define (get-partition)
    (if (restore)
      (lf-get-partition)
      #f))
  
  (define (unit-size)
    (if (restore)
      (lf-unit-size)
      -1))
  
  (define (delete p)
    (update)
    (if (restore)
      (lf-delete-partition p)
      #f))
  
  (define (add-dos . l)
    (update)
    (if (restore)
      (apply lf-add-dos l)
      0))
  
  (define (add-logical . l)
    (update)
    (if (restore)
      (apply lf-add-logical l)
      0))
  
  (define (change-id . l)
    (update)
    (if (restore)
      (apply lf-change-id l)
      #f))
  
  (define (cancel)
    (cond
      ((not (and (restore) (lf-close)))
        #f)
      (else
        (set! sid (lf-new))
        (init dev))))
  
  (define (get-soffset)
    (restore)
    (lf-get-soffset))
  
  (set! sid (lf-new))
  (make-object
    'init          init
    'cancel        cancel
    'abort/close   close
    'write/close   write-it
    'write/reopen  write-reopen
    'get-disk      get-disk
    'get-soffset   get-soffset
    'get-partition get-partition
    'unit-size     unit-size
    'delete        delete
    'add-dos       add-dos
    'add-logical   add-logical
    'change-id     change-id
  ))
