;
;		Gtk middle layer.
;



(define sgtk-table '())

(define (sgtk-lookup . l)
  (if (< (length l) 2)
    #f
    (let ((id (car l))
          (rest (cdr l)))
      (cond
        ((assoc id sgtk-table) =>
          (lambda (x) (apply (cadr x) rest)))
        (else
          (format #t "sgtk-lookup : could not find function for id ~a\n" id))))))

(define (sgtk-register id cb)
  (let ((r (assoc id sgtk-table)))
    (cond
      ((eq? #f r)
        (set! sgtk-table (cons (list id cb) sgtk-table)))
      (else
        (set-cdr! r (list id cb))))))

(define sgtk-start-flag #f)

(define (sgtk-start)
  (cond
    (sgtk-start-flag
      #t)
    ((not (sgtk-init sgtk-lookup sgtk-register))
      #f)
    (else
      (set! sgtk-start-flag #t)
      (set! sgtk-table '())
      (sgdk-imlib-init)
      (sgtk-set-locale))))

(define (sgtk-signal-connect w e cb)
  ; <w:cptr>      widget object
  ; <e:str>       event name
  ; <cb:compound> callback. should take two argument.
  
  (let ((id (if (null? sgtk-table)
                0
                (1+ (caar sgtk-table)))))
    (sgtk-signal-connect-raw sgtk-register w e cb id)))

(define sgtk_fill (sgtk-val "GTK_FILL"))
(define sgtk_fill (sgtk-val "GTK_SHRINK"))
(define sgtk_fill (sgtk-val "GTK_EXPAND"))

