;
;  mainpanel
;
(define (sgtk-oglt-mainpanel w t f p)
  (sgtk-window-set-title w t)
  (sgtk-container-set-border-width w 5)
  (let* ((d (get-display ""))
         (default (list 780 520))
         (sz (cond
              ((null? d) default)
              ((or (< (caar d) 800)
                   (< (cadr (car d)) 600))
                (list 620 450))
              (else default))))
    (apply sgtk-widget-set-usize (cons w sz)))
  
  (sgtk-widget-set-usize f 190 -1)
  (sgtk-paned-pack1 p f #t #f)
  (sgtk-paned-set-position p 180)
  (sgtk-container-add w p)
  #t)


;
;  layouter
;
(define (sgtk-stdlayout w l m b)
  (let ((t (sgtk-table-new 6 9 #f)))
    (sgtk-table-attach-defaults t l 1 5 1 2)
    (sgtk-table-attach-defaults t m 1 5 3 7)
    (sgtk-table-attach-defaults t b 0 6 8 9)
    (sgtk-container-add w t)
    t))

;
;   message window
;
(define (sgtk-message-info m)
  (sgnome-dialog-run
    (sgnome-message-box-new (break-line m 60) "info" "Button_Ok"))
  #t)

(define (sgtk-message-error m)
  (sgnome-dialog-run
    (sgnome-message-box-new (break-line m 60) "error" "Button_Ok"))
  #f)

(define (sgtk-message-fatalerror m)
  (sgtk-message-error m)
  (sgtk-message-fatalerror m))


;
;   Gtk Utils
;

(define (sgtk-container-add-many . l)
  (cond
    ((< (length l) 2)
      (inst-log "sgtk-container-add-many : too few parameter (~a)\n" l))
    (else
      (map (lambda (x) (sgtk-container-add (car l) x))
           (cdr l)))))

(define (sgtk-update)
  (cond
    ((sgtk-events-pending)
      (sgtk-main-iteration)
      (sgtk-update))
    (else
      #t)))

(define (sgtk-label-normalized-new s)
  (let ((l (sgtk-label-new (break-line s 60))))
    (sgtk-label-set-justify l (sgtk-val "GTK_JUSTIFY_LEFT"))
;    (sgtk-label-set-line-wrap l #t)
    l))


(define (sgtk-show-while w m f)
  (let ((l (sgtk-label-new m)))
    (sgtk-paned-pack2 w l #t #f)
    (sgtk-widget-show-all l)
    (sgtk-update)
    (let ((r (f)))
      (sgtk-widget-destroy l)
      r)))

(define (sgtk-message-while w t m f)
  (let* ((new (sgtk-window-new-toplevel-named t))
         (v (sgtk-vbox-new #f 10))
         (l (sgtk-label-new m)))
    (sgtk-box-pack-start v l #f #f 0)
    (sgtk-container-add new v)
    (sgtk-grab-add new)
    (sgtk-widget-show-all new)
    (sgtk-widget-set-sensitive w #f)
    (sgtk-update)
    (let ((r (f)))
      (sgtk-widget-destroy new)
      (sgtk-widget-set-sensitive w #t)
      r)))

(define (sgtk-show-while-new t m f)
  (let* ((new (sgtk-window-new-toplevel-named t))
         (v (sgtk-vbox-new #f 10))
         (h (sgtk-hbox-new #f 10))
         (l (sgtk-label-normalized-new (string-append " " m " ")))
         ; $B$J$<$+(B set-text $B$h$j$bBg$-$$%F%-%9%H$r:n@.$7$F$*$+$J$$$H(B
         ; $BI=<($7$F$b$i$($J$$$H$+!"(Bm $B$N:G8e$K(B ASCII $B$r$$$l$J$$$H=P$J$$$H$+!"(B
         ; $B$+$J$jLdBj$,$"$k!#(B
         (hr (sgtk-hseparator-new)))
    (sgtk-container-add h l)
;    (sgtk-box-pack-start v l #f #f 15)
    (sgtk-container-add-many v h hr)
    (sgtk-container-add new v)
    (sgtk-grab-add new)
    (sgtk-widget-show v)
    (sgtk-widget-show l)
    (sgtk-widget-show-all new)
    (sgtk-update)
    (sgtk-widget-show v)
    (sgtk-widget-show l)
	  (sgtk-label-set-text l m)
    (sgtk-update)
    (let ((r (f)))
      (sgtk-widget-destroy new)
      r)))

(define (sgtk-window-new-toplevel-named s)
  (let ((w (sgtk-window-new-toplevel)))
    (sgtk-window-set-title w s)
    w))

;
;   button choice
;
(define (sgtk-choice . arg)
  ; arg[0]       : parent pane
  ; arg[1]       : label
  ; arg[i] (i>1) : gnome button string (cf. /usr/include/libgnomeui/stock.h)
  (define val -1)
  (define (mknum i l)
    (if (null? l)
      l
      (cons i (mknum (1+ i) (cdr l)))))
  (cond
    ((< (length arg) 3)
      val)
    (else
      (let* ((p (car arg))
             (l (sgtk-label-normalized-new (cadr arg)))
             (a (sgtk-alignment-new 0 0 0.8 0.8))
             (bf (sgtk-frame-new '()))
             (bb (sgtk-hbutton-box-new))
             (bl (map (lambda (x) (sgnome-stock-button x))
                      (cddr arg)))
             (num (mknum 0 bl))
             (v (sgtk-vbox-new #f 10)))
        ;(format #t "l : ~a\n" (cadr arg))
        (sgtk-container-set-border-width bb 5)
        (sgtk-button-box-set-layout bb (sgtk-val "GTK_BUTTONBOX_END"))
        (sgtk-button-box-set-spacing bb 20)
        (sgtk-button-box-set-child-size bb 85 20)
        (sgtk-container-add bf bb)
        (apply sgtk-container-add-many (cons bb bl))
        (map (lambda (x y)
               (sgtk-signal-connect x "clicked"
                 (lambda (w) (set! val y) (sgtk-main-quit))))
             bl num)
        (sgtk-widget-set-usize bf 300 48)
        (sgtk-container-add a l)
        (sgtk-container-add v a)
        (sgtk-box-pack-start v bf #f #f 0)
        (sgtk-paned-pack2 p v #t #f)
        (sgtk-widget-show-all v)
        (sgtk-main)
        (sgtk-widget-destroy v)
        val))))


(define (sgtk-choice-nowrap . arg)
  ; arg[0]       : parent pane
  ; arg[1]       : label
  ; arg[i] (i>1) : gnome button string (cf. /usr/include/libgnomeui/stock.h)
  (define val -1)
  (define (mknum i l)
    (if (null? l)
      l
      (cons i (mknum (1+ i) (cdr l)))))
  (cond
    ((< (length arg) 3)
      val)
    (else
      (let* ((p (car arg))
             (l (sgtk-label-new (cadr arg)))
             (a (sgtk-alignment-new 0 0 0.8 0.8))
             (bf (sgtk-frame-new '()))
             (bb (sgtk-hbutton-box-new))
             (bl (map (lambda (x) (sgnome-stock-button x))
                      (cddr arg)))
             (num (mknum 0 bl))
             (v (sgtk-vbox-new #f 10)))
        ;(format #t "l : ~a\n" (cadr arg))
        (sgtk-container-set-border-width bb 5)
        (sgtk-button-box-set-layout bb (sgtk-val "GTK_BUTTONBOX_END"))
        (sgtk-button-box-set-spacing bb 20)
        (sgtk-button-box-set-child-size bb 85 20)
        (sgtk-container-add bf bb)
        (apply sgtk-container-add-many (cons bb bl))
        (map (lambda (x y)
               (sgtk-signal-connect x "clicked"
                 (lambda (w) (set! val y) (sgtk-main-quit))))
             bl num)
        (sgtk-widget-set-usize bf 300 48)
        (sgtk-container-add a l)
        (sgtk-container-add v a)
        (sgtk-box-pack-start v bf #f #f 0)
        (sgtk-paned-pack2 p v #t #f)
        (sgtk-widget-show-all v)
        (sgtk-main)
        (sgtk-widget-destroy v)
        val))))

;
;   button choice
;
(define (sgtk-choice-str . arg)
  ; arg[0]       : parent pane
  ; arg[1]       : label
  ; arg[i] (i>1) : button string
  (define val -1)
  (cond
    ((< (length arg) 3)
      val)
    (else
      (let* ((p (car arg))
             (l (sgtk-label-normalized-new (cadr arg)))
             (a (sgtk-alignment-new 0 0 0.8 0.8))
             (bf (sgtk-frame-new '()))
             (bb (sgtk-hbutton-box-new))
             (bl (map (lambda (x) (sgtk-button-new-with-label x))
                      (cddr arg)))
             (v (sgtk-vbox-new #f 10)))
        (sgtk-container-set-border-width bb 5)
        (sgtk-button-box-set-layout bb (sgtk-val "GTK_BUTTONBOX_END"))
        (sgtk-button-box-set-spacing bb 20)
        (sgtk-button-box-set-child-size bb 85 20)
        (sgtk-container-add bf bb)
        (apply sgtk-container-add-many (cons bb bl))
        (smap (lambda (n x)
                (sgtk-signal-connect x "clicked"
                  (lambda (w) (set! val n) (sgtk-main-quit))))
              bl)
        (sgtk-widget-set-usize bf 300 48)
        (sgtk-container-add a l)
        (sgtk-container-add v a)
        (sgtk-box-pack-start v bf #f #f 0)
        (sgtk-paned-pack2 p v #t #f)
        (sgtk-widget-show-all v)
        (sgtk-main)
        (sgtk-widget-destroy v)
        val))))

;
;   button choice
;
(define (sgtk-choice-new t l . sl)
  (let* ((new (sgtk-window-new-toplevel-named t))
         (ll (sgtk-label-normalized-new l))
         (bf (sgtk-frame-new '()))
         (bb (apply sgtk-bbox
               (cons #t (map (lambda (x) (sgtk-button-new-with-label x))
                             sl))))
         (h (sgtk-hbox-new #f 15))
         (v (sgtk-vbox-new #f 10)))
    (sgtk-container-set-border-width h 20)
    (sgtk-container-add h ll)
    (sgtk-container-add-many v h (bb 'widget))
    (sgtk-container-add new v)
    (sgtk-widget-show-all new)
    (sgtk-main)
    (sgtk-widget-destroy new)
    (bb 'info)))

(define (sgtk-boxed-ok)
  (let ((f (sgtk-frame-new '()))
        (bb (sgtk-hbutton-box-new))
        (b-ok (sgnome-stock-button "Button_Ok")))
    (sgtk-signal-connect b-ok "clicked" (lambda (w) (sgtk-main-quit)))
    (sgtk-container-set-border-width bb 5)
    (sgtk-button-box-set-layout bb (sgtk-val "GTK_BUTTONBOX_END"))
    (sgtk-button-box-set-spacing bb 20)
    (sgtk-button-box-set-child-size bb 85 20)
    (sgtk-container-add bb b-ok)
    (sgtk-container-add f bb)
    (sgtk-widget-set-usize f 300 48)
    f))

;
;   Generic go/back
;
(define (make-between bp bn stop?)
  (define stat 'none)
  (define (check x)
    (set! stat x)
    (if stop? (sgtk-main-quit)))
  
  (let* ((f (sgtk-frame-new '()))
         (bb (sgtk-hbutton-box-new))
         (sense (lambda l (cond
                            ((= 2 (length l))
                              (sgtk_widget_set_sensitive bp (car l))
                              (sgtk_widget_set_sensitive bn (cadr l)))
                            (else
                              #f)))))
    (sgtk-container-set-border-width bb 5)
    (sgtk-button-box-set-layout bb (sgtk-val "GTK_BUTTONBOX_END"))
    (sgtk-button-box-set-spacing bb 20)
    (sgtk-button-box-set-child-size bb 85 20)
    (sgtk-container-add f bb)
    (sgtk-container-add-many bb bp bn)
    (sgtk-signal-connect bp "clicked" (lambda (w) (check 'back)))
    (sgtk-signal-connect bn "clicked" (lambda (w) (check 'forward)))
    (sgtk-widget-set-usize f 300 48)
    
    (make-object
      'info    (lambda () stat)
      'sense   sense
      'widget  (lambda () f))))
  
;
;
;
(define (make-go/back stop?)
  (make-between 
    (sgnome-stock-button "Button_Prev")
    (sgnome-stock-button "Button_Next")
    stop?))

;
;
;
(define (sgtk-ok/cancel stop?)
  (make-between 
    (sgnome-stock-button "Button_Cancel")
    (sgnome-stock-button "Button_Ok")
    stop?))

(define (sgtk-bbox-ok)
  (sgtk-bbox #t (sgnome-stock-button "Button_Ok")))

;
;    general bbox
;
(define (sgtk-bbox stop? . bl)
  (define stat -1)
  (define (check x)
    (set! stat x)
    (if stop? (sgtk-main-quit)))
  
  (cond
    ((null? bl)
      #f)
    (else
      (let* ((f (sgtk-frame-new '()))
             (bb (sgtk-hbutton-box-new))
             (sense (lambda l (cond
                                ((= (length bl) (length l))
                                  (map (lambda (b x)
                                         (sgtk_widget_set_sensitive b x))
                                       bl l)
                                  #t)
                                (else
                                  #f)))))
        (sgtk-container-set-border-width bb 5)
        (sgtk-button-box-set-layout bb (sgtk-val "GTK_BUTTONBOX_END"))
        (sgtk-button-box-set-spacing bb 20)
        (sgtk-button-box-set-child-size bb 85 20)
        (sgtk-container-add f bb)
        (apply sgtk-container-add-many (cons bb bl))
        (smap (lambda (n b)
                (sgtk-signal-connect b "clicked" (lambda (w) (check n))))
              bl)
;        (sgtk-widget-set-usize f 300 48)
        (sgtk-widget-set-usize f (* 120 (length bl)) 48)
        (make-object
          'info    (lambda () stat)
          'sense   sense
          'widget  (lambda () f))))))

(define (sgtk-cancelbox)
  (sgtk-bbox #t (sgnome-stock-button "Button_Cancel")))


;
;   entry box
;
(define (sgtk-entrybox stop? l)
  (define data '())
  (cond
    ((not (andmap
            (lambda (x)
              (and (list? x) (= 3 (length x)) (boolean? (caddr x))))
            l))
      #f)
    (else
      (let* ((h (sgtk-hbox-new #f 10))
             (v0 (sgtk-vbox-new #f 10))
             (v1 (sgtk-vbox-new #f 10))
             (el (map (lambda (x)
                        (let ((e (sgtk-entry-new)))
                          (sgtk-entry-set-visibility e (caddr x))
                          (sgtk-entry-set-text e (cadr x))
                          e))
                      l)))
        (apply sgtk-container-add-many
          (cons v0 (map (lambda (x) (sgtk-label-new (car x)))
                        l)))
        (apply sgtk-container-add-many (cons v1 el))
        (sgtk-container-add-many h v0 v1)
        (make-object
          'sinfo   (lambda () (if (null? data) (map sgtk-entry-get-text el) data))
          'info    (lambda () (if (null? data) (map sgtk-entry-get-text el) data))
          'freeze  (lambda () (set! data (map sgtk-entry-get-text el)) #t)
          'widget  (lambda () h))))))

;
;    check box
;
(define (sgtk-checkbox l)
  (define result '())
  (cond
    ((not (andmap (lambda (x)
                    (and (= 2 (length x))
                         (string? (car x))
                         (boolean? (cadr x))))
                  l))
      #f)
    (else
      (let ((v (sgtk-vbox-new #f 10))
            (cl (map (lambda (x)
                       (let ((c (sgtk-check-button-new-with-label (car x))))
                         (sgtk-toggle-button-set-active c (cadr x))
                         c))
                     l)))
        (define (freeze)
          (set! result (map sgtk-toggle-button-get-active cl))
          #t)
        (apply sgtk-container-add-many (cons v cl))
        (freeze)
        (make-object
          'widget   (lambda () v)
          'freeze   freeze
          'info     (lambda () result))))))


;
;    hscale box
;
(define (sgtk-hscalebox str f l u v inc page sz)
  (define stat v)
  (let* ((h (sgtk-hbox-new #f 10))
         (ll (sgtk-label-new str))
         (a (sgtk-adjustment-new l u v inc page sz))
         (s (sgtk-hscale-new a)))
    (sgtk-signal-connect a "value_changed"
      (lambda (w)
        (let ((x (sgtk-adjustment-get-value a)))
          (set! stat x)
          (if (not (eq? #f f))
            (f x)))))
    (sgtk-container-add-many h ll s)
    (make-object
      'widget (lambda () h)
      'info   (lambda () stat))))


;   top := node
;  node := list of leaf (leaf|node)+
;  leaf := list of widget closure
;
(define (make-simple-tree stop? single? l)
  (define widget
    (let ((w (sgtk-scrolled-window-new (cptr-null "void") (cptr-null "void"))))
      (sgtk-scrolled-window-set-policy w (sgtk-val "GTK_POLICY_AUTOMATIC")
                                         (sgtk-val  "GTK_POLICY_AUTOMATIC"))
      w))
  
  (define stat '())
  (define selected '())
  (define node-list '())
  (define tree-list '())
  
  (define (clear-selection)
    (map (lambda (t)
           (sgtk-tree-set-selection-mode t (sgtk-val "GTK_SELECTION_EXTENDED")))
         tree-list))
  
  (define (check x)
    (set! stat x)
    (if stop? (sgtk-main-quit)))
  
  (define (expand-node)
    (map (lambda (x) (sgtk-tree-item-expand (car x)))
         node-list))
  
  (define (create-add w c)
    (sgtk-misc-set-alignment c 0.0 0.0)
    (sgtk-container-add w c)
    (sgtk-widget-show-all w)
    w)
  
  (define (create-rec p l s)
    (let ((w (sgtk-tree-item-new)))
      (sgtk-tree-append p w)
      (cond
        ((or (not (list? l))
             (< (length l) 2))
          (create-add w (sgtk-label-new (format #f "Illegal leaf : ~a" l))))
        ((and (= 2 (length l))
              (cptr? (car l)))
          (sgtk-signal-connect w "select"
            (lambda (w)
              (set! selected (cons s selected))
              (check (cadr l))))
          (sgtk-signal-connect w "deselect"
            (lambda (w)
              (set! selected (filter (lambda (x) (not (equal? s x)))
                                     selected))))
          (create-add w (car l)))
        (else
          (let ((x (car l))
                (rest (cdr l)))
            (cond
              ((not (and (list? x)
                         (= 2 (length x))
                         (cptr? (car x))))
                (create-add w (sgtk-label-new (format #f "Illegal Node : ~a" x))))
              (else
                (create-add w (car x))
                (let ((toggle (lambda (w)
                                (cond
                                  ((assoc w node-list) =>
                                    (lambda (z)
                                      (if (equal? 'expand (cdr z))
                                          (sgtk-tree-item-collapse (car z))
                                          (sgtk-tree-item-expand (car z)))))
                                  (else
                                    (format #t "error occurd with ~a\n" w))))))
                  ;(sgtk-signal-connect w "select" (lambda (w) (toggle w)))
                  #t)
                (let ((t (sgtk-tree-new))
                      (a (cons w 'collapse)))
                  (set! node-list (cons a node-list))
                  (sgtk-signal-connect w "expand"
                    (lambda (w) (set-cdr! a 'expand)))
                  (sgtk-signal-connect w "collapse"
                    (lambda (w) (set-cdr! a 'collapse)))
                  (set! tree-list (cons t tree-list))
                  (sgtk-tree-item-set-subtree w t)
                  (smap (lambda (n y) (create-rec t y (append s (list n))))
                        rest)
                  w))))))))
  
  (define (create p l)
    (smap (lambda (n x) (create-rec p x (list n)))
          l))
  
  (let ((t (sgtk-tree-new)))
    (set! tree-list (cons t tree-list))
    (sgtk-tree-set-selection-mode t
      (sgtk-val (if single?
                    "GTK_SELECTION_SINGLE"
                    "GTK_SELECTION_MULTIPLE")))
    (sgtk-scrolled-window-add-with-viewport widget t)
    (create t l))
  
  (make-object 'widget     (lambda () widget)
               'info       (lambda () selected)
               'node-list  (lambda () node-list)
               'tree-list  (lambda () tree-list)
               'expand     expand-node
               'clear      (lambda () (set! selected '()))
               ))

(define (make-vradio c n0 . l)
  (define n -1)
  (define (check x)
    (cond
      ((and (not (= n -1))
            (not (= n x)))
        (set! n x)
        (if c (c x)))))
        
  (let ((v (sgtk-vbox-new #f 10)))
    (define (buttons g i x)
      (if (null? x)
        #t
        (let ((b (sgtk-radio-button-new-with-label g (car x))))
          (sgtk-box-pack-start v b #t #t 0)
          (sgtk-signal-connect b "toggled" (lambda (w) (check i)))
          (if (= i n0) (sgtk-toggle-button-set-active b #t))
          (buttons (sgtk-radio-button-group b) (1+ i) (cdr x)))))
    (buttons (cptr-null "GtkWidget") 0 l)
    (set! n n0)
    (make-object
      'info   (lambda () n)
      'widget (lambda () v))))


(define (sgtk-labelbox stop? . l)
  (define n -1)
  (define (check x)
    (set! n x)
    (if stop? (sgtk-main-quit)))
  (let* ((v (sgtk-vbox-new #f 10))
         (ll (smap (lambda (n x) 
                     (let ((y (sgtk-button-new-with-label x)))
                       (sgtk-button-set-relief y (sgtk-val "GTK_RELIEF_NONE"))
                       (sgtk-signal-connect y "clicked" (lambda (w) (check n)))
                       (sgtk-box-pack-start v y #t #t 0)))
                  l)))
    (make-object
      'info   (lambda () n)
      'widget (lambda () v))))


(define (sgtk-option d ld lv)
  ; d  : default
  ; ld : item list for display
  ; lg : item list for value
  (cond
    ((not (and (number? d)
               (= (length ld) (length lv))))
      #f)
    (else
      (let ((m (sgtk-menu-new))
            (o (sgtk-option-menu-new)))
        (smap (lambda (n x)
               (let ((item (sgtk-menu-item-new-with-label x)))
                 (sgtk-signal-connect item "activate" (lambda (w) (set! d n)))
                 (sgtk-menu-append m item)
                 (sgtk-widget-show item)))
              ld)
        (sgtk-menu-set-active m d)
        (sgtk-option-menu-set-menu o m)
        (sgtk-widget-show m)
        (sgtk-widget-show o)
        (make-object
          'info   (lambda () (list-ref lv d))
          'widget (lambda () o))))))


(define (make-option-menu c n l)
  ; n : number of default item
  ; l : item list. (should be a string list)
  
  (define var (list-ref l n))
  (let ((m (sgtk-menu-new))
        (o (sgtk-option-menu-new)))
    (map (lambda (x)
           (let ((item (sgtk-menu-item-new-with-label x)))
             (sgtk-signal-connect item "activate" (lambda (w) (set! var x)))
             (sgtk-menu-append m item)
             (sgtk-widget-show item)))
         l)
    (sgtk-menu-set-active m n)
    (sgtk-option-menu-set-menu o m)
    (sgtk-widget-show m)
    (sgtk-widget-show o)
    (make-object
      'info   (lambda () var)
      'widget (lambda () o))))

(define (make-option-nmenu c n l)
  ; n : number of default item
  ; l : item list. (should be a string list)
  
  (define var n)
  (let ((m (sgtk-menu-new))
        (o (sgtk-option-menu-new)))
    (smap (lambda (k x)
           (let ((item (sgtk-menu-item-new-with-label x)))
             (sgtk-signal-connect item "activate" (lambda (w) (set! var k)))
             (sgtk-menu-append m item)
             (sgtk-widget-show item)))
          l)
    (sgtk-menu-set-active m n)
    (sgtk-option-menu-set-menu o m)
    (sgtk-widget-show m)
    (sgtk-widget-show o)
    (make-object
      'info   (lambda () var)
      'widget (lambda () o))))


;
;(define (make-command-progress s cmd)
;  ; s   : label string
;  ; cmd : command line
;  (let ((a (sgtk-adjustment-new 0 1 150 0 0 0))
;        (p (sgtk-progress-bar-new-with-label s)))
;    (define (run)
;      (progress-start cmd
;        (lambda (f) (sgtk-progress-bar-update p f))))
;    (sgtk-progress-set-adjustment p a)
;    (make-object
;      'widget (lambda () p)
;      'run    run)))
