(load "debug.scm")
(load "util.scm")
(load "obj.scm")
(load "snewt.scm")
(load "newt1.scm")
(load "newt2.scm")
(load "mod.scm")
(load "net.scm")
(load "media.scm")
(load "time.scm")
(load "keyboard.scm")
(load "xwin.scm")
(load "boot.scm")
(load "gtk-middle.scm")
(load "gtk-obj.scm")
(load "gtk.scm")
(load "part.scm")
(load "title.scm")
(load "fdisk.scm")
(load "autopart.scm")
(load "patch.scm")
(load "conffile.scm")
(load "na.scm")
(load "profile.scm")

(fprintf "/var/log/inst2" "Begun 2nd stage\n")
(set! sh-log "/var/log/inst2")
(sh "mkdir /mntscm")
(sh "umount /mnt")
(sh "umount /mntscm")
(system-at "/dev/tty2" "tail -f /var/log/messages &")

(textdomain "inst2" "/usr/share/locale")
(define obj-part (configure-part "/mnt"))
(define patch-part (conf-patch obj-part))

; 󥹥ȡ餬Ȥ˰񤭽Ф
(define obj-net (configure-network))
(define patch-net (conf-patch obj-net))
(obj-net 'init 'inst2)
(patch-net 'init 'admin)
(patch-net 'load)
(patch-net 'commit)

(define obj-net (configure-network))
(define patch-net (conf-patch obj-net))
(obj-net 'init 'inst2)
(patch-net 'init 'inst2)
(patch-net 'load)

(define obj-kbd (configure-keyboard))

(define obj-mod (configure-module))
(define patch-mod (conf-patch obj-mod))
(patch-mod 'init 'inst2)
(obj-mod 'init 'inst2)
(obj-mod 'load)

(define obj-prof (conf-prof))
(obj-prof 'load)

(define obj-med (conf-media obj-net obj-part obj-prof))
(define patch-med (conf-patch obj-med))
(patch-med 'init 'inst2)
(define obj-time (configure-time))
(define obj-boot (configure-boot obj-part obj-mod))
(define patch-boot (conf-patch obj-boot))
(define obj-x #f)
(define patch-x #f)
(define obj-na (conf-na))

(obj-kbd 'init 'inst2)

(obj-med 'init 'inst2)
(obj-part 'init 'inst2)
(patch-part 'init 'inst2)
(patch-part 'load)

(obj-time 'init 'inst2)
(obj-boot 'init 'inst2)
(patch-boot 'init 'inst2)
(patch-boot 'load)

(define (move-ogl-tools)
  (sh "cp /etc/pcmcia/config /target/etc/pcmcia/config")
  (sh "cp /var/lib/ogl/etc/* /target/var/lib/ogl/etc"))

(define (misc-setup)
  (sh "rm /target/sbin/unconfigured.sh")
  (sh "rm /target/var/lib/ogl/etc/*.md5sum")
  (fprintf "/target/var/lib/ogl/etc/under-inst" "")
  (cond
    ((not (eq? #f (unix-getenv "NOUSB")))
      (sh "chroot /target update-rc.d -f murasaki remove")))
  #t)

(define (move-log)
  (let ((f "/etc/X11/XF86Config-4"))
    (if (unix-access? f '(read))
      (sh "cp ~a /target~a" f f)))
  (sh "cp /var/log/messages /target/var/log/install-first.log")
  (if (unix-access? "/tmp/date" '(read))
    (sh "cp /tmp/date /target/var/lib/ogl/etc/install-date"))
  (sh "chown 0.4 /target/var/log/messages"))

(define (make-issue)
  (obj-med 'cp "ogl/inst/expandl.tar" "/target/var/lib/ogl/etc/expandl.tar")
  (cond
    ((unix-access? "/var/lib/ogl/etc/title" '(read))
      (inst-log "creating issue...\n")
      (sh "chroot /target head -1 /var/lib/ogl/etc/title | chroot /target gawk '{printf(\"%s on \\\\n \\\\l\\n\", $0)}' >/target/etc/issue")
      (sh "cp /target/etc/issue /target/etc/issue.net"))
    (else
      (inst-log "Not producing issue file.\n"))))

(define (set-lang)
  (let ((r (parse-awk #\space #t "/var/lib/ogl/etc/lang")))
    (cond
      ((eq? #f r)
        (inst-log "could not get lang\n")
        #f)
      (else
        (inst-log "setting lang to ~a\n" (caar r))
        (unix-setenv "LANG" (caar r))))))

(define (pcmcia-check)
  (cond
    ((null? (map (lambda (x) (equal? 'pcmcia_core (car x)))
                 (obj-mod 'table)))
      #f)
    (else
      (= 0 (sh "chroot /target update-rc.d pcmcia defaults")))))

(define (2nd-newt)
  
  (repeat
    (lambda ()
      (obj-part 'close-all-part)
      (obj-part 'init 'inst2)
      (obj-part 'load)
      (newt-ui-part obj-part 'linux-xfs #t)))
  
  (obj-part 'commit)
  (patch-part 'commit)
  (obj-part 'init 'inst2)
  (obj-part 'load)
  
  (obj-med 'load)
  (obj-med 'open)
  (newt-ui-base obj-med)
  (sh "mkdir -p /target/var/lib/ogl/etc")
  (sh "cp /var/lib/ogl/etc/title /target/var/lib/ogl/etc")
  (patch-mod 'commit)
  (obj-part 'commit)
  (patch-part 'commit)
  (pcmcia-check)
  (obj-part 'init 'inst2)
  (obj-part 'load)
  
  (repeat (lambda () (newt-ui-time obj-time)))
  (obj-time 'commit-tz)
  (obj-time 'commit-hwclock)
  
  (if (and (lang-ja?)
           (eq? #f (unix-getenv "NOFB")))
    (obj-boot 'set-option "vga=274"))
  (if (obj-mod 'need-force-dma?)
    (obj-boot 'add-option "ide0=ata66 ide1=ata66"))
  
  (obj-mod 'setmod 'apm "" 'inst/set)
  (newt-ui-power-management obj-mod obj-boot)
  (newt-ui-bios-order obj-part)
  
  (repeat
    (lambda ()
      (let ((r (newt-ui-install-br obj-boot obj-part #t)))
        (cond
          (r r)
          ((= 1 (snewt-choice (_ "Boot Record Installation")
                  (_ "Do you proceed without boot loader installation?")
                  (_ "Yes") (_ "No")))
            #t)
          (else
            #f)))))
  
  (newt-ui-kern obj-med obj-boot)
  (inst-log "finished installation of kernel\n")
  
  (newt-stage-title (_ "Boot Floppy"))
  (if (= 0 (snewt-buttons (_ "Boot Floppy Disk")
             (string-append
               (_ "Do you want to create a boot floppy disk?\n")
               (_ "Floppy disk is a safe way to boot."))
             40 5 (vector (_ "Yes") (_ "No"))))
    (newt-ui-bootfd #t obj-boot obj-part))
  
  (patch-boot 'commit)
  (obj-kbd 'commit)
  (patch-net 'commit)
  (patch-med 'commit)
  (patch-mod 'init 'inst2)
  (patch-mod 'commit)
  (patch-part 'commit)
  (misc-setup)
  (sh "rm /target/var/lib/ogl/etc/x-win /var/lib/ogl/etc/x-win /target/etc/X11/XF86Config-4 /etc/X11/XF86Config-4")
  ;(obj-na 'commit)
  (obj-prof 'commit)
  (move-log)
  (make-issue)
  (obj-med 'close)
  (obj-med 'eject)
  (move-ogl-tools)
  (newt-ui-flushlog)
  (snewt-message (_ "Confirm")
    (string-append
      (_ "Now you have finished the first half of the installation process. ")
      (_ "Installer will reboot the system once and proceed to the second half of the installation.\n\n")
      (_ "Do you want to proceed to the second half of the installation?\n\n")
      (_ "If yes, make sure that no CD-ROM nor floppy disk is placed in the drive. Then press 'OK' to reboot and start the second half of the installation.")))
  (snewt-finish)
  (move-log)
  (obj-part 'unmount))

(define (2nd-x)
  ;(snewt-finish)
  (unix-setenv "DISPLAY" ":0.0")
  (sh "xloadimage -fullscreen -onroot /usr/lib/ogl/lib/wallpaper-arma.jpg &")
  (sh "sawfish &")
  (sh "xset s off")
  (cond
    ((not (sgtk-start))
      (inst-log "Could not initialize Gtk.\n")
      'failed-at-gtk)
    (else
      (textdomain "inst2" "/usr/share/locale")
      (let ((w (sgtk-window-new-toplevel))
            (p (sgtk-hpaned-new))
            (f (sgtk-frame-new (_ "Installation Step")))
            (v (sgtk-vbox-new #f 10))
            (b-kbd (sgtk-label-new (_ "Keyboard Setting")))
            (b-drv (sgtk-label-new (_ "Driver Setting")))
            (b-net (sgtk-label-new (_ "Network Setting")))
            (b-med (sgtk-label-new (_ "Media Selection")))
            (b-part (sgtk-label-new (_ "Partition Setting")))
            (b-base (sgtk-label-new (_ "Base Installation")))
            (b-time (sgtk-label-new (_ "Time Setting")))
            (b-boot (sgtk-label-new (_ "Boot Loader Installation")))
            (b-kern (sgtk-label-new (_ "Kernel Installation")))
            (b-reboot (sgtk-label-new (_ "Reboot")))
            (b-root (sgtk-label-new (_ "Root Password")))
            (b-adduser (sgtk-label-new (_ "User Account")))
            (b-pkg (sgtk-label-new (_ "Package Installation")))
            (b-sound (sgtk-label-new (_ "Sound Setting")))
            (b-sv (sgtk-label-new (_ "Service Setting")))
            (b-fin (sgtk-label-new (_ "Finish Installation")))
            )
        (define (pack-set l)
          (sgtk-box-pack-start v l #f #f 0)
          (sgtk-widget-set-sensitive l #f))
        
        ; main window
        (sgtk-oglt-mainpanel w (_ "Installer") f p)
        (sgtk-signal-connect w "delete_event"
          (lambda (w e)
            (sgtk-message-info (_ "Could not abort installer."))))
        
        ; side
        (map pack-set
          (list b-kbd b-drv b-net b-med b-part b-base b-time b-boot b-kern b-reboot
                b-root b-adduser b-pkg b-sound b-sv b-fin))
        (sgtk-container-add-many f v)
        
        ; run
        (sgtk-widget-show-all w)
        (map (lambda (x) (sgtk-widget-set-sensitive x #f))
             (list b-kbd b-part b-base b-boot b-kern b-fin))
        
        ; partition
        (sgtk-widget-set-sensitive b-part #t)
        (repeat
          (lambda ()
            (obj-part 'close-all-part)
            (obj-part 'init 'inst2)
            (obj-part 'load)
            (gtk-ui-part p obj-part 'xfs #t)))
        (sgtk-widget-set-sensitive b-part #f)
        (obj-part 'commit)
        (patch-part 'commit)
        (obj-part 'init 'inst2)
        (obj-part 'load)
        
        ; base
        (sgtk-widget-set-sensitive b-base #t)
        (obj-med 'load)
        (obj-med 'open)
        (gtk-ui-base p obj-med)
        (sh "mkdir -p /target/var/lib/ogl/etc")
        (sh "cp /var/lib/ogl/etc/title /target/var/lib/ogl/etc")
        (patch-part 'commit)
        (obj-part 'init 'inst2)
        (obj-part 'load)
        (patch-mod 'commit)
        (pcmcia-check)
        (sgtk-widget-set-sensitive b-base #f)
        
        ; timzone
        (sgtk-widget-set-sensitive b-time #t)
        (inst-log "xd\n")
        (gtk-ui-timezone p obj-time)
        (gtk-ui-hwclock p obj-time)
        (inst-log "xe\n")
        (obj-time 'commit-tz)
        (obj-time 'commit-hwclock)
        (sgtk-widget-set-sensitive b-time #f)
        
        ; boot loader & APM
        (sgtk-widget-set-sensitive b-boot #t)
        (if (and (lang-ja?)
                 (eq? #f (unix-getenv "NOFB"))
                 (not (ormap (lambda (x)
                               (case (car x)
                                 ((i810 i830) #t)
                                 (else #f)))
                             (obj-mod 'table))))
          (obj-boot 'set-option "vga=274"))
        
        (if (obj-mod 'need-force-dma?)
          (obj-boot 'add-option "ide0=ata66 ide1=ata66"))
        
        (obj-mod 'setmod 'apm "" 'inst/set)
        (gtk-ui-power-management p obj-mod obj-boot)
        (gtk-ui-bios-order p obj-part)
        
        (repeat
          (lambda ()
            (let ((r (gtk-ui-install-br p obj-boot obj-part #t)))
              (cond
                (r r)
                ((= 0 (sgtk-choice p
                        (_ "Do you proceed without boot loader installation?")
                        "Button_Yes" "Button_No"))
                  #t)
                (else
                  #f)))))
        (sgtk-widget-set-sensitive b-boot #f)
        
        ; kernel
        (sgtk-widget-set-sensitive b-kern #t)
        (gtk-ui-kern p obj-med obj-boot)
        (sgtk-widget-set-sensitive b-kern #f)
        
        ; boot FD
        (repeat (lambda ()
                  (let ((r (sgtk-choice p
                             (string-append
                               (_ "Do you want to create a boot floppy disk?\n")
                               (_ "Floppy disk is a safe way to boot."))
                             "Button_Yes" "Button_No")))
                    (if (= r 0)
                      (gtk-ui-bootfd p #t obj-boot obj-part)
                      #t))))
        
        (patch-boot 'commit)
        (obj-kbd 'commit)
        (patch-net 'commit)
        (patch-med 'commit)
        (patch-mod 'init 'inst2)
        (patch-mod 'commit)
        (patch-part 'commit)
        (misc-setup)
        (sh "cp /tmp/XF86Config /target/etc/X11/XF86Config-4")
        ;(obj-ja 'load)
        ;(obj-na 'commit)
        (obj-prof 'commit)
        (move-log)
        (make-issue)
        (obj-med 'close)
        (obj-med 'eject)
        (move-ogl-tools)
        
        ; finish
        (sgtk-widget-set-sensitive b-reboot #t)
        (gtk-ui-flushlog p)
        (sgtk-choice p 
          (string-append
            (_ "Now you have finished the first half of the installation process. ")
            (_ "Installer will reboot the system once and proceed to the second half of the installation.\n\n")
            (_ "Do you want to proceed to the second half of the installation?\n\n")
            (_ "If yes, make sure that no CD-ROM nor floppy disk is placed in the drive. Then press 'OK' to reboot and start the second half of the installation."))
          "Button_Ok")
        
        (move-log)
        (obj-part 'unmount)
        (fprintf "/tmp/install-finished" "")
        #t))))

(let ((a (command-line-args)))
  (inst-log "init2.scm a:~a LANG :~a\n" a (unix-getenv "LANG"))
  (cond
    ((null? a)
      ;
      ;  Real Start of 2nd stage
      ;
      (snewt-start)
      (snewt-colreset)
      (newt-stage-title (_ "Starting second stage"))
      (snewt-show-while (_ "Starting second stage")
        (_ "Starting second stage ...") 50 4
        (lambda () (patch-mod 'load)))
      
      (repeat
        (lambda ()
          (newt-ui-na #t obj-na #f)
          (cond
            ((newt-ui-sendlog obj-na)
              #t)
            ((not (= 1 (snewt-choice (_ "Installation Recording")
                         (string-append
                           (_ "Failed to access to the ARMA Net. Do you reconfigure the ARMA Net account again? ")
                           (_ "If the host doesn't have connectivity to the Internet or the ARMA Net is under maintanance, this is not error. "))
                         (_ "Yes") (_ "No"))))
              #t)
            (else
              #f))))
      
      (obj-na 'commit)
      
      (newt-ui-memory-check)
      (cond
        ((unix-access? "/tmp/force-cui" '(read))
          (2nd-newt))
        (else
          (define (lang-str)
            (let ((l (unix-getenv "LANG")))
              (if (eq? #f l) "" (format #f "LANG=~a" l))))
          (if (eq? #f (unix-getenv "NOUSB"))
            (sh "depmod -a ; modprobe input ; modprobe mousedev ; modprobe hid"))
          (sh "depmod -a")
          (obj-kbd 'load)
          (obj-part 'close-all-part)
          (set! obj-x (configure-x (obj-kbd 'get-type) obj-mod))
          (set! patch-x (conf-patch obj-x))
          (patch-x 'init 'inst2)
          (obj-x 'init 'inst2)
          (cond
            ((obj-x 'pre-configured?)
              (patch-x 'load)
              (patch-x 'commit))
            (else
              (newt-stage-title (_ "X Configuration"))
              (let ((r (snewt-choice (_ "Configure X Window")
                         (_ "Do you want to configure X window?") (_ "Yes") (_ "No"))))
                (if (= r 1)
                  (and (newt-ui-x obj-x "elk xtest")
                       (obj-x 'make-etc "/etc/X11/XF86Config-4"))))))
          (cond
            ((unix-access? "/tmp/install-finished" '(read))
              (exit 0))
            ((equal? 'regular (unix-filetype "/etc/X11/XF86Config-4"))
              (snewt-finish)
              ;(obj-x 'xinit "elk xinstall")
              (obj-x 'test2 "elk xinstall")
              ; Ȥꤢ 'xinit ϻȤʤȤ
              (cond
                ((unix-access? "/tmp/install-finished" '(read))
                  (exit 0))
                (else
                  (snewt-start)
                  (newt-stage-title (_ "Starting second stage"))
                  (snewt-message (_  "Starting second stage")
                    (_ "Could not execute X installation.\nBack to CUI interface ...\n"))
                  (2nd-newt))))
            (else
              (2nd-newt))))))
    
    ;
    ;		X test
    ;
    ((equal? "xtest" (car a))
      (patch-mod 'load)
      (obj-kbd 'load)
      (sh "echo $LANG >/tmp/lang2-1")
      (set-lang)
      (sh "echo $LANG >/tmp/lang2-2")
      (sgtk-start)
      (textdomain "inst2" "/usr/share/locale")
      (sh "xloadimage -fullscreen -onroot /usr/lib/ogl/lib/wallpaper-arma.jpg &")
      (sh "sawfish &")
      (gtk-ui-xtest (_ "Continue with this settings") 2nd-x))
    
    ;
    ;   X install
    ;
    ((equal? "xinstall" (car a))
      (patch-mod 'load)
      (obj-kbd 'load)
      (sh "echo $LANG >/tmp/lang3-1")
      (set-lang)
      (sh "echo $LANG >/tmp/lang3-2")
      (sgtk-start)
      (textdomain "inst2" "/usr/share/locale")
      (2nd-x))
    
    ;
    ;   Fatal Error
    ;
    (else
      (sh-log "init2.scm : unknown arguments ~s\n" a)
      (unix-sleep 100000))
    ))
