(load "util.scm")
(load "misc.scm")

(load "obj.scm")
(load "conffile.scm")
(load "mod.scm")
(load "part.scm")

;(define stderr
;  (unix-filedescriptor->port 2 "w"))

(define (error-display s)
  (display s)
  (unix-sleep 100000)
  (exit 1))

(set! sh-log "/dev/tty2")

(define obj-mod (configure-module))
(obj-mod 'init 'admin)
(map (lambda (x) (if (eq? (cadr x) 'un/not)
                     (obj-mod 'insmod (car x) "")))
     (obj-mod 'table))

(define obj-part (configure-part "/mnt"))
(obj-part 'init 'admin)


(define (check-cd x)
  (sh "mkdir -p /mnt/ro")
  (let ((r (= 0 (sh "mount /dev/~a /mnt/ro -t iso9660 -o ro" (car x)))))
    (if r (sh "umount /mnt/ro"))
    r))

(let* ((l (obj-part 'info-cdrom))
       (l' (filter check-cd l)))
  (cond
    ((null? l)
      (error-display (_ "No CD-ROM found. Check driver first!")))
    ((null? l')
      (error-display (_ "No CD media found. Do not remove CD!")))
    ((= 1 (length l'))
      (let ((d (caar l')))
        (cond
          ((and (eq? #f (unix-getenv "NOHDPARM"))
                (unix-access? "/sbin/hdparm" '(exec)))
            (sh "hdparm -c1 -d1 -m16 -X66 /dev/~a" d)))
        (sh "mount /dev/~a /mnt/ro -t iso9660 -o ro" d)))
    (else
      (error-display (_ "Several CD-ROM drives look like to have OGL CD-ROM media.")))))

(exit 0)
