#!/bin/sh
string=?;exec /bin/elk -c -l $0 install-kernel.scm $*
;
;  : ΥץȤ inst2 ѤǤ
;

(load "util.scm")
(load "obj.scm")
(load "media.scm")
(load "net.scm")
(load "part.scm")
(load "profile.scm")
(load "fdisk.scm")
(load "boot.scm")
(load "mod.scm")

(set! sh-log "/var/log/inst2")

(define obj-part (configure-part "/mnt"))
(obj-part 'init 'inst2)

(define obj-net (configure-network))
(obj-net 'init 'inst2)

(define obj-prof (conf-prof))

(define obj-med (conf-media obj-net obj-part obj-prof))
(obj-med 'init 'inst2)
(obj-med 'load)
(obj-med 'open)

(define obj-mod (configure-module))
(obj-mod 'init 'inst2)
(obj-mod 'load)

(define obj-boot (configure-boot obj-part obj-mod))
(obj-boot 'init 'inst2)

(define (close-exit n)
  (obj-med 'close)
  (exit n))

(let ((a (command-line-args))
      (l (obj-med 'ls "ogl/inst/kernel"))
      (tmp (unix-tempname))
      (fd (unix-getenv "PROGRESS_FD")))
  (obj-med 'cp (format #f "ogl/inst/kernel/desc~a" (if (lang-ja?) "-ja" "")) tmp)
  (let ((tbl (ttable-read tmp '((str str str str)))))
    (cond
      ((or (not (list? l))
           (not (string? fd)))
        (close-exit 1))
      ((or (not (list? tbl)) (null? tbl))
        (close-exit 2))
      (else
        (let* ((l' (apply append
                     (map (lambda (x)
                            (let ((y (assoc x tbl)))
                              (cond
                                ((eq? #f y)
                                  '())
                                (else
                                  (let* ((f (cadr y))
                                         (len (string-length f)))
                                    (cond
                                      ((< len 6)
                                        (list f))
                                      (else
                                        (let* ((fd (string-append (substring f 0 3) "fd.deb"))
                                               (dev (string-append (substring f 0 (- len 4)) "hd.deb"))
                                               (fd? (set-include? fd l))
                                               (dev? (set-include? dev l)))
                                          (append
                                            (list f)
                                            (if fd? (list fd) '())
                                            (if dev? (list dev) '()))))))))))
                          (cdr a))))
               (l'' (list-uniq (easy-sort string<? l')))
               (cp1 (lambda (x) (obj-med 'cp (format #f "ogl/inst/~a" x)
                                             (format #f "/target/tmp/~a" x))))
               (cp2 (lambda (x) (obj-med 'cp (format #f "ogl/inst/kernel/~a" x)
                                             (format #f "/target/tmp/~a" x))))
               (pp (unix-filedescriptor->port (string->number fd) "w"))
               (prog (lambda (x)
                       (display (format #f "~a\n" x) pp)
                       (flush-output-port pp))))
          (inst-log "l'':~s\n" l'')
          (prog (+ 3 (length l'')))
          (let ((r (and
                     (andmap
                       (lambda (x)
                         (prog 1)
                         (and (cp1 x)
                              (chroot-target-dpkg "-i" (format #f "/tmp/~a" x) "\n\n\n\n")))
                       (list "elkogl.deb" "oglt.deb"))
                     (andmap
                       (lambda (x)
                         (prog 1)
                         (and (cp2 x)
                              (chroot-target-dpkg "-i" (format #f "/tmp/~a" x)
                                "No\nNo\nNo\nNo\nNo\nNo\nNo\nNo\nNo\n")))
                       l''))))
             (cond
               ((not r)
                 (close-exit 3))
               (else
                 (map (lambda (x) (obj-boot 'make-initrd x))
                      (cdr a))
                 (prog 1)
                 (close-exit 0)))))))))
