

(define (conf-jobq)
  
  ; var
  (define id 0)
  (define q '())       ; (id key func-job func-on-seccuss func-on-fail)
  
  ; method
  (define (enq key fj fs ff) 
    (set! q (cons (list id key fj fs ff) q))
    (set! id (1+ id)))
  
  (define (remove id)
    (let ((q' (filter (lambda (x)
                        (not (equal? (car x) id)))
                      q)))
      (cond
        ((= (length q) (length q'))
          #f)
        (else
          (set! q q')
          #t))))
  
  (define (remove-bykey key)
    (let ((q' (filter (lambda (x)
                        (not (equal? (cadr x) key)))
                      q)))
      (cond
        ((= (length q) (length q'))
          #f)
        (else
          (set! q q')
          #t))))
  
  (define (exec)
    (let ((r (map (lambda (x)
                    (inst-log "executing job id ~a\n" (car x))
                    (let ((t ((caddr x))))
                      (inst-log "result : ~a\n" t)
                      (if t ((list-ref x 3)) ((list-ref x 4)))
                      (list (car x) (caddr x) t)))
                  (reverse q))))
      (set! q '())
      r))
  
  (define (have? key)
    (ormap (lambda (x) (equal? (cadr x) key))
           q))
  
  (make-object
    'enq           enq
    'have?         have?
    'remove        remove
    'remove-bykey  remove-bykey
    'exec          exec))
    