;
;		Net Account 
;                    (C) 2002 Omoikane Inc.
;

(define (conf-na)
  
  ; var
  (define id   "")
  (define pass "")
  
  ; lib
  (define (id-std s)
    (string-upcase (string-gsub s "-" "")))
  
  ; method
  (define (set-id s)
    (let ((l0 (string-length s)))
      (cond
        ((< l0 12)
          (inst-log "na obj, set-id : too short id.\n")
          #f)
        (else
          (let* ((s' (id-std s))
                 (l (string-length s'))
                 (m (md5sum (format #f "|echo ~a" (substring s' 0 (- l 2))))))
            (cond
              ((not (string? m))
                (inst-log "failed to calculate md5sum (~a).\n" m)
                #f)
              ((not (equal? (substring s' (- l 2) l)
                            (string-upcase (substring m 0 2))))
                (inst-log "na obj, set-id : failed md5sum test.\n")
                #f)
              (else
                (set! id s)
                #t)))))))
  
  (define (set-passwd x)
    (set! pass x)
    #t)
  
  (define (get-hashed)
    (let ((tmp (unix-tempname)))
      (cond
        ((not (and (fprintf tmp "")
                   (= 0 (sh "chmod 600 ~a" tmp))))
          (inst-log "na : could not access tmp file\n")
          "")
        ((not (fprintf tmp (format #f "~a\n" pass)))
          (inst-log "na : could not output pass\n")
          "")
        (else
          (let ((s (md5sum tmp)))
            (sh "rm ~a" tmp)
            (cond
              ((not (string? s))
                (inst-log "na : failed to calc md5sum\n")
                "")
              (else
                (list->string
                  (map (lambda (n) (string-ref s (* 4 n)))
                       '(0 1 2 3 4 5 6 7))))))))))
  
  (define (commit)
    (let ((f "/var/lib/ogl/etc/netaccount"))
      (and (fprintf f (format #f "~a\t~a" id pass))
           (= 0 (sh "chmod og-rw ~a" f)))))
  
  (define (load-it)
    (let ((r (parse-awk #\tab #t "/var/lib/ogl/etc/netaccount")))
      (cond
        ((eq? #f r)
          (inst-log "na : account not found.\n")
          #t)
        ((not (and (= 1 (length r))
                   (= 2 (length (car r)))))
          (inst-log "na : illegal account file.\n")
          #f)
        (else
          (set! id (caar r))
          (set! pass (cadr (car r)))
          #t))))
  
  (define (write-netrc f)
    (fprintf f
      (format #f "machine 202.216.241.68 login D~a password ~a\n"
        (id-std id) (get-hashed))))
  
  (make-object
    'commit      commit
    'conf        (lambda () (list (list "/root/.netrc" write-netrc #t)))
    'get-id      (lambda () id)
    'get-stdid   (lambda () (id-std id))
    'get-hashed  get-hashed
    'get-passwd  (lambda () pass)
    'load        load-it
    'mid-conf    (lambda () (list "/var/lib/ogl/etc/netaccount"))
    'set-id      set-id
    'set-passwd  set-passwd
    'write-netrc write-netrc
    ))
    
    
  