;
;     snewt interface for stage2 of installer
;
;                                               (C) 2002 Omoikane Inc.
;
;

(define (newt-ui-pager-info inst?)
  (snewt-show-while (_ "Starting Pager")
    (_ "Starting pager ...\n\n   - 'q' for quit viewing\n   - cursor keys for moving")
    54 5
    (lambda () (unix-sleep (if inst? 6 4))))
  #t)

(define (newt-ui-na inst? obj-na obj-med)
  (define title (_ "ARMA Net Account"))
  (let* ((old-id (obj-na 'get-id))
         (old-ps (obj-na 'get-passwd))
         (r (snewt-entries title
              (string-append
                (_ "Enter your customer ID and current password to access to the ARMA Net, which provides features below:\n\n")
                (_ "     - remote installation recording (currently unavailable)\n")
                (_ "     - update deb package downloading\n")
                (_ "     - remote maintainance\n")
                (_ "\nWhen you change your password, make sure it is done both on the support web and administration tool(ogl-admin). Keep your password confidential.\n"))
              60 4 4 26
              (list
                (list (_ "customer ID :") old-id 0)
                (list (_ "password :") old-ps 0)))))
    (cond
      ((null? r)
        #f)
      ((not (obj-na 'set-id (car r)))
        (snewt-message (_ "Error")
          (format #f (_ "Customer ID ~a is not valid, sorry.\n") (car r)))
        (newt-ui-na inst? obj-na obj-med))
      (else
        (obj-na 'set-passwd (cadr r))
        (if inst? (obj-na 'write-netrc "/.netrc") #t)
        (if (< 4 (string-length (car r)))
          (fprintf "/var/lib/ogl/etc/product"
            (string-upcase (substring (car r) 0 4))))
        (cond
          ((or inst? (eq? #f obj-med))
            #t)
          ((and (equal? old-id (car r)) (equal? old-ps (cadr r)))
            #t)
          (else
            (let ((m (obj-med 'info)))
              (cond
                ((not (and (equal? 'http (car m)) (equal? "www.omoikane.co.jp" (cadr m))))
                  #t)
                ((not (= 1 (snewt-choice title
                             (_ "Do you update the configurtion for the default install media? (ie. to rewrite /etc/apt/sources.list)")
                             (_ "Yes") (_ "No"))))
                  #t)
                (else
                  (let ((r1 (obj-med 'set (car m) (cadr m) (caddr m)
                              (format #f "D~a" (obj-na 'get-id)) (obj-na 'get-hashed)
                              (list-ref m 5) (list-ref m 6))))
                    (cond
                      ((not (eq? #t r1))
                        (snewt-message title
                          (format #f
                            (_ "Failed to configure the default install media. (~a) Please investigate manually, sorry.")
                            r1))
                        #t)
                      (else
                        (snewt-message title
                          (_ "Default install media has been successfully configured. "))))))))))))))

(define (newt-ui-sendlog obj-na)
  (define title (_ "Installation Recording"))
  (let ((r0 (snewt-show-while title
              (_ "Contacting ARMA Net ....") 54 3
              (lambda ()
                (let ((ip (obj-net 'resolv "net.omoikane.co.jp")))
                  (sh "cd /tmp ; echo 'get date' | cadaver  https://202.216.241.68/inst")
                  (unix-access? "/tmp/date" '(read)))))))
    (inst-log "ui-sendlog : accessing center? ~a\n" r0)
    (cond
      ((eq? #f r0) #f)
      (else
        (let ((r1 (snewt-choice title
                    (string-append
                      (_ "Do you use recording function?\n\n")
                      (_ "After pressing OK, installer will encrypt and safely send infomation below to the ARMA Net's support center.\n\n")
                      (_ "   - Type of CPU\n")
                      (_ "   - Amount of memory\n")
                      (_ "   - PCI(USB/IEEE1394) device IDs\n")
                      (_ "   - Disk type, ID/paritition\n")
                      (_ "   - Install log (except passowrds)\n\n")
                      (_ "These information will be only used for your support. ")
                      (_ "(Any other additional information won't be sent.)\n\n")
                      (_ "This enables us quick help when you utilize our support either about or after the installation. ")
                      (_ "With recording, you don't need to inform about device/install information. \n\n")
                      (_ "Do you enable installation recording?"))
                    (_ "Yes") (_ "No"))))
          (case r1
            ((1)
              (sh "mkdir /tmp/sup")
              (sh "tail -f /var/log/messages | split -1 - /tmp/sup/mes2: &")
              (sh "sleep 1 ; rm /tmp/sup/*")
              (sh "cp /var/log/messages /tmp/sup/first")
              (sh "logsender ~a `cat /tmp/date` &" (obj-na 'get-stdid))
              (sh "cp /proc/bus/pci/devices /tmp/sup/pci")
              (sh "cp /proc/bus/usb/devices /tmp/sup/usb")
              (sh "cp /proc/cpuinfo /tmp/sup/cpu")
              #t)
            (else
              #t)))))))

(define (newt-ui-flushlog)
  (define (rep n)
    (let ((l (unix-read-directory2 "/tmp/sup")))
      (cond
        ((< 6 n)
          #f)
        ((<= (length l) 2)
          #t)
        (else
          (unix-sleep 2)
          (rep (1+ n))))))
  (let ((l (unix-read-directory2 "/tmp/sup")))
    (let ((r (if (< 2 (length l))
               (snewt-show-while (_ "Flushing Log")
                 (_ "Flushing log ...") 54 3
                 (lambda () (rep 0)))
               #t)))
      (sh "rm -rf /tmp/sup")
      r)))

(define (newt-ui-memory-check)
  (newt-stage-title (_ "Memory Checking"))
  (let ((sz (unix-filesize "/proc/kcore")))
    (cond
      ((< sz 0)
        (snewt-fatal-error
          (_ "Could not access /proc/kcore. Could not measure memory size."))
        #f)
      ((< (* 90 1024 1024) sz)
        #t)
      (else
        (snewt-message (_ "Info")
          (string-append
            (_ "To install with GUI, there should be at least 96MBytes memory.\n")
            (_ "Install can be done only with CUI. After install, you are enable to configure X with ogl-admin.\n")))
        (fprintf "/tmp/force-cui" "")
        #t))))

(define (early-swapoff-check)
  (cond
    ((not (unix-access? "/tmp/swapped" '(read)))
      #t)
    (else
      (= 0 (sh "swapoff ~a" (caar (parse-awk #\space #t "/tmp/swapped")))))))

(define (newt-ui-x obj-x prog)
  (define title (_ "X Configuration"))
  (define fin? #f)
  
  (define (probe)
    (let ((r (snewt-show-while (_ "Auto Probing")
               (_ "Probing Hardware. Please wait for a while....") 54 3
               (lambda () (obj-x 'probe #t)))))
      (cond
        ((not (eq? #t r))
          (snewt-message (_ "Probe Error")
            (format #f (_ "Probe failed. Reason:\n~a") r))
          #f)
        ((null? (filter (lambda (x) (and (list? x)
                                         (<= 3 (length x))
                                         (not (equal? "unknown-driver" (list-ref x 3)))))
                        (obj-x 'info-device)))
          (snewt-message (_ "Auto Probing")
            (_ "Could not find valid video device.\n"))
          #f)
        (else
          #t))))
  
  (define (probe-lite)
    (snewt-show-while (_ "Auto Probing")
      (_ "Probing Hardware. Please wait for a while....") 54 3
      (lambda () (obj-x 'probe-lite)))
    (cond
      ((null? (filter (lambda (x) (and (list? x)
                                       (<= 3 (length x))
                                       (not (equal? "unknown-driver" (list-ref x 3)))))
                      (obj-x 'info-device)))
        (snewt-message (_ "Auto Probing")
          (_ "Could not find valid video device.\n"))
        #f)
      (else
        #t)))
  
  (define (device-check-pointer)
    (case (length (obj-x 'info-mouse))
      ((0)
        (snewt-message (_ "Warning") (_ "No pointer device(mouse) detected."))
        #t)
      (else
        (cond
          ((not (null? (filter (lambda (x) (equal? x 'ps2old))
                               (obj-x 'info-mouse))))
             (let ((r (snewt-choice title
                        (_ "PS/2 mouse was detected. Do you enable wheel?\n")
                        (_ "Yes") (_ "No"))))
               (cond
                 ((= r 1)
                   (obj-x 'set-mouse
                     (map (lambda (x) (if (equal? x 'ps2old) 'ps2 x))
                          (obj-x 'info-mouse))))))))
        (case (length (obj-x 'info-mouse))
          ((1)
            #t)
          (else
            (let ((r (snewt-choice title
                       (_ "In X configuration, you have to choose main mouse.")
                       (_ "USB") (_ "PS/2")))
                  (ps2list (filter (lambda (x) (not (equal? 'usb x)))
                                   (obj-x 'info-mouse))))
              (cond
                ((= r 1)
                  (obj-x 'set-mouse (cons 'usb ps2list)))
                (else
                  (obj-x 'set-mouse (append ps2list (list 'usb)))))))))))
  
  (define (set-resolution n)
    (let* ((l (obj-x 'valid-mode))
           (r (snewt-nmenu title
                (string-append
                  (_ "Select a resolution of the screen.\n")
                  (_ "Anomalous sizes other than SVGA are listed towards the bottom.\n"))
                50 5 5 8
                (list->vector
                  (map (lambda (x)
                         (sprintf (_ "%3dx%3d dots @%dHz") (car x) (cadr x) (caddr x)))
                       l))
                (if (= n -1)
                  (vector (_ "Ok") (_ "Set Multi Display") (_ "Cancel"))
                  (vector (_ "Ok") (_ "Cancel"))))))
      (case (car r)
        ((-1 3) #f)
        ((0 1)
          (let* ((x (list-ref l (cdr r)))
                 (n' (if (= n -1) 0 n))
                 (rr (caddr x))
                 (hs (list-ref x 3))
                 (hsl (real->int (* 0.85 hs)))
                 (hsh (real->int (* 1.07 hs)))
                 (rrl (real->int (* 0.85 rr)))
                 (rrh (real->int (* 1.07 rr)))
                 (m (list-ref x 4)))
            (obj-x 'set-resolution n' (car x) (cadr x))
            (let* ((d (list-ref (obj-x 'info-display) n')))
              (cond
                ((or (null? d) (not (< 0 (cadr d))) (not (< 0 (list-ref d 3))))
                  (obj-x 'set-hsync n' hsl hsh)
                  (obj-x 'set-vsync n' rrl rrh))
                ((and (<= (cadr d) hs) (<= hs (caddr d)) (<= (list-ref d 3) rr) (<= rr (list-ref d 4)))
                  #t)
                ((not (= 1 (snewt-choice title
                             (string-append
                               (_ "Previous (or probed from display) frequency range(s) doesn't cover the required value. ")
                               (_ "This can be happen when the display tells invalid frequency or when you change the resolution/frequency dynamically during the configuration. ")
                               "\n\n"
                               (_ "Do you set frequency ranges so that these cover the required value? "))
                             (_ "Yes") (_ "No"))))
                  #t)
                (else
                  (obj-x 'set-hsync n' (min (cadr d) hsl) (max (caddr d) hsh))
                  (obj-x 'set-vsync n' (min (list-ref d 3) rrl) (max (list-ref d 4) rrh)))))
            (if (not (equal? "" m))
                (obj-x 'set-modeline n' m))))
        (else
          (cond
            ((= n -1)
              'multi)
              ;(let ((r (path-5)))
              ;  (set! fin? #t)
              ;  r)
            (else
              #f))))))
  
  (define (manual-freq n)
    (let* ((h (obj-x 'get-hsync n))
           (v (obj-x 'get-vsync n))
           (r (snewt-entries title
                (_ "Enter Horizontal/Vertical Frequency.\n")
                60 4 4 5
                (list
                  (list (_ "Horizontal uppermost (kHz) :") (number->string (car h)) 0)
                  (list (_ "           lowermost       :") (number->string (cadr h)) 0)
                  (list (_ "Vertical   uppermost  (Hz) :") (number->string (car v)) 0)
                  (list (_ "           lowermost       :") (number->string (cadr v)) 0)))))
      (cond
        ((null? r) #f)
        (else
          (let ((r' (map string->number r)))
            (cond
              ((ormap (lambda (x) (eq? x #f)) r')
                (snewt-message title (_ "Enter correct value."))
                (manual-freq n))
              (else
                (and (obj-x 'set-hsync n (car r') (cadr r'))
                     (obj-x 'set-vsync n (caddr r') (list-ref r' 3))))))))))
  
  (define (set-color)
    (let* ((l (list 16 24 32 8))
           (r (snewt-nmenu (_ "Color Depth Setting")
                (_ "Select the color depth from below.")
                64 5 5 8
                (list->vector
                  (map (lambda (x) (obj-x 'color-name x))
                       l))
                (vector (_ "Ok") (_ "Cancel")))))
      (case (car r)
        ((-1 2) #f)
        (else
          (obj-x 'set-color (list-ref l (cdr r)))))))
  
  (define (test-it)
    (define (check)
      (let ((r (snewt-nmenu (_ "Configuration Testing")
                 (string-append
                   (_ "Did it work as well as you expected? \n\n")
                   (_ "If you would like to retry, choose 'Retry'.")
                   "\n\n"
                   (_ "Selecting 'View Log' button will start the pager program. In pager, use keys below.\n\n")
                   (_ "  'q' for quit viewing\n")
                   (_ "  cursor keys for moving\n"))
                 50 8 8 4
                 (vector)
                 (vector (_ "Ok") (_ "Retry") (_ "View Log") (_ "Skip")))))
        (case (car r)
          ((-1 4) #f)
          ((1)
            (set! fin? #t)
            #t)
          ((2) 'again)
          ((3)
            (conf-newt-suspend-sh title "lv /var/log/XFree86.0.log")
            (check))
          (else #f))))
    (let* ((r0 (snewt-show-while title
                 (_ "testing configuration ...")
                 54 3
                 (lambda ()
                   (obj-x 'commit-med)
                   (obj-x 'test2 prog)))))
      (cond
        ((unix-access? "/tmp/install-finished" '(read))
          #t)
        (else
          (check)))))
  
  (define (select-device n)
    (let* ((d (filter (lambda (x) (equal? (cadr x) 0))
                      (obj-x 'info-device)))
           (l (apply append
                (map (lambda (x)
                       (let ((s (list-ref x 3)))
                         (list s
                              (format #f "~a secondary output (if dual head device)" s))))
                     d)))
           (r (snewt-nmenu title
                (format #f (_ "Select device for ~a display.") (ordinal-string #t n))
                50 5 5 4
                (list->vector l)
                (vector (_ "Ok") (_ "Cancel")))))
      (case (car r)
        ((-1 2) #f)
        (else
          (let ((bid (car (list-ref d (quotient (cdr r) 2)))))
            (obj-x 'set-device-scr n bid (remainder (cdr r) 2))
            (let* ((l (obj-x 'list-driver))
                   (r1 (snewt-nmenu title
                         (format #f (_ "Select video driver.\ncurrent driver : ~a\n") (obj-x 'get-driver bid))
                         50 5 5 8
                         (list->vector l)
                         (vector (_ "Skip")))))
              (case (car r1)
                ((-1 1) #t)
                (else
                  (obj-x 'set-driver bid (list-ref l (cdr r1)))
                  #t))))))))
  
  (define (set-num-screen)
    (let ((r (snewt-nmenu title
               (_ "Select number and layout of display.\n")
               50 5 5 8
               (vector (_ "Single")
                       (_ "Horizontal Dual")   (_ "Vertical Dual")
                       (_ "Horizontal Triple") (_ "Vertical Triple")
                       (_ "Horizontal Quadruple") (_ "Vertical Qualdruple")
                       (_ "Quadruple in grid"))
               (vector (_ "Ok") (_ "Cancel")))))
      (case (car r)
        ((-1 2) #f)
        (else
          (case (cdr r)
            ((0)  (obj-x 'set-num-screen 1))
            ((1) (and (obj-x 'set-num-screen 2)
                      (obj-x 'set-layout 'h)))
            ((2) (and (obj-x 'set-num-screen 2)
                      (obj-x 'set-layout 'v)))
            ((3) (and (obj-x 'set-num-screen 3)
                      (obj-x 'set-layout 'h)))
            ((4) (and (obj-x 'set-num-screen 3)
                      (obj-x 'set-layout 'v)))
            ((5) (and (obj-x 'set-num-screen 4)
                      (obj-x 'set-layout 'h)))
            ((6) (and (obj-x 'set-num-screen 4)
                      (obj-x 'set-layout 'v)))
            ((7) (and (obj-x 'set-num-screen 4)
                      (obj-x 'set-layout 'g)))
            (else #f))))))
  
  (define (set-multi-screen rep?)
    (define (set n)
      (cond
        ((not (select-device n))
          (inst-log "path3 : device selection canceled.\n")
          #f)
        ((not (set-resolution n))
          (inst-log "path3 : setting resolution canceled.\n")
          #f)
        ((and rep?
              (not (manual-freq 0)))
          (inst-log "path3 : setting freq canceled.\n")
          #f)
        (else
          #t)))
    (let* ((l (case (obj-x 'info-num-screen)
                ((2) (list 1 2))
                ((3) (list 1 2 3))
                ((4) (list 1 2 3 4))
                (else '())))
           (r (snewt-nmenu title
                (string-append
                  (_ "Select sceen to set.\n\n")
                  (case (obj-x 'info-layout)
                    ((h)
                      (case (obj-x 'info-num-screen)
                        ((2) (_"  layout:[#1][#2]\n\n"))
                        ((3) (_"  layout:[#1][#2][#3]\n\n"))
                        ((4) (_"  layout:[#1][#2][#3][#4]\n\n"))
                        (else "")))
                    ((v)
                      (case (obj-x 'info-num-screen)
                        ((2) (_"  layout:[#1]\n         [#2]\n\n"))
                        ((3) (_"  layout:[#1]\n         [#2]         [#3]\n\n"))
                        ((4) (_"  layout:[#1]\n         [#2]         [#3]         [#4]\n\n"))
                        (else "")))
                    ((g)
                      (_"  layout:[#1][#2]\n         [#3][#4]\n\n"))
                    (else
                      "")))
                50 5 5 4
                (list->vector
                  (map (lambda (x) (format #f (_ "display #~a ~a") x (obj-x 'desc-display (1- x))))
                       l))
                (vector (_ "Ok") (_ "Cancel")))))
      (case (car r)
        ((-1 2) #f)
        ((0)
          (set (cdr r))
          (set-multi-screen rep?))
        ((1)
          (cond
            ((ormap (lambda (x) (equal? x (_ "not yet set")))
               (map (lambda (x) (obj-x 'desc-display (1- x)))
                    l))
              (snewt-message title
                (_ "Set all screen before pressing ok."))
              (set-multi-screen rep?))
            (else
              #t)))
        (else
          #f))))
  
  (define (path-1)
    (inst-log "path1\n")
    (let ((r0 (set-resolution -1)))
    (cond
      ((eq? r0 #f)
        (inst-log "path1 : setting resolution or path2 canceled.\n")
        #f)
      ((eq? r0 'multi)
        (if (path-2)
          #t
          (path-1)))
      (else
        (let ((r (cond
                   ((not (set-color))
                     (inst-log "path1 : setting color canceled.\n")
                     #f)
                   (else
                     (test-it)))))
          (cond
            ((eq? #t r)
              r)
            ((eq? #f r)
              (path-1))
            (else
              (probe-lite)
              (path-3))))))))
  
  (define (path-2)
    (inst-log "path2\n")
    (cond
      ((not (set-num-screen))
        (inst-log "path2 : set screen canceled.\n")
        #f)
      (else
        (let ((n (obj-x 'info-num-screen)))
          (let ((x (if (= 1 n)
                     (path-3)
                     (cond
                       ((not (set-multi-screen #f))
                         (inst-log "path2 : set resolution canceled.\n")
                         #f)
                       ((not (set-color))
                         (inst-log "path2 : setting color canceled.\n")
                         #f)
                       (else
                         (let ((r (test-it)))
                           (cond
                             ((boolean? r) r)
                             (else
                               (probe-lite)
                               (path-4)))))))))
            (cond
              (x
                x)
              (else
                (path-2))))))))
  
  ; path-5  path-2 ȤۤȤƱǤresolution Τ߸ƤФ졢֤ޤ
  (define (path-5)
    (inst-log "path5\n")
    (cond
      ((not (set-num-screen))
        (inst-log "path5 : set screen canceled.\n")
        #f)
      (else
        (let ((n (obj-x 'info-num-screen)))
          (if (= 1 n)
            (path-3)
            (cond
              ((not (set-multi-screen #f))
                (inst-log "path5 : set resolution canceled.\n")
                #f)
              ((not (set-color))
                (inst-log "path5 : setting color canceled.\n")
                #f)
              (else
                (let ((r (test-it)))
                  (cond
                    ((boolean? r) r)
                    (else
                      (probe-lite)
                      (path-4)))))))))))
  
  (define (path-4)
    (inst-log "path4\n")
    ;(obj-x 'set-num-screen (obj-x 'info-num-screen))
    (cond
      ((not (set-multi-screen #t))
        (inst-log "path5 : set resolution canceled.\n")
        #f)
      ((not (set-color))
        (inst-log "path5 : setting color canceled.\n")
        #f)
      (else
        (let ((r (test-it)))
          (cond
            ((boolean? r) r)
            (else
              (probe-lite)
              (path-4)))))))
  
  (define (path-3)
    (inst-log "path3\n")
    (cond
      ((not (set-resolution 0))
        (inst-log "path3 : setting resolution canceled.\n")
        #f)
      ((not (manual-freq 0))
        (inst-log "path3 : setting freq canceled.\n")
        (path-3))
      ((not (set-color))
        (inst-log "path3 : setting color canceled.\n")
        (path-3))
      ((not (select-device 0))
        (inst-log "path3 : device selection canceled.\n")
        (path-3))
      (else
        (let ((r (test-it)))
          (cond
            ((boolean? r) r)
            (else
              (probe-lite)
              (path-3)))))))
  
  (define (started-x?)
    (let* ((dpyinfo? (unix-access? "/usr/X11R6/bin/xdpyinfo" '(exec)))
           (r0 (and dpyinfo?
                    (= 0 (sh "DISPLAY=:0.0 /usr/X11R6/bin/xdpyinfo 2>&1 | grep refused"))))
           (r1 (and dpyinfo?
                    (= 0 (sh "DISPLAY=:0.0 /usr/X11R6/bin/xdpyinfo")))))
      (inst-log "started-x?, dpyinfo? : ~a, r0 : ~a, r1 : ~a\n" dpyinfo? r0 r1)
      (cond
        ((not (or (not dpyinfo?)
                  r0
                  r1))
          #t)
        ((and (unix-access? "/tmp/.X11-unix" '(read))
              (not (= 1 (snewt-choice title
                     (_ "It is possible that a X server is already running on this host. Do you stop X server first? Otherwise the tool will quit here.")
                     (_ "Yes") (_ "No")))))
          #f)
        (else
          (sh "/etc/init.d/kdm stop ; /etc/init.d/xdm stop ; /etc/init.d/gdm stop ; /etc/init.d/wdm stop")
          (sh "killall XFree86 ; killall X ; killall xinit")
          (sh "rm -rf /tmp/.X11-unix")
          #t))))
  
  (cond
    ((not (started-x?))
      #f)
    ((eq? #f (probe))
      #f)
    (else
      (let ((d (obj-x 'info-device)))
        (case (length d)
          ((0)
            (snewt-message (_ "Error")
              (_ "No video device detected. Please write /etc/X11/XF86Config manually, sorry."))
            #f)
          ((1)
            (obj-x 'set-device-scr 0 (caar d) (cadr (car d)))
            (path-1))
          (else
            (path-2)))))))


(define (newt-ui-part obj-part default-fs mount?)
  ; obj-part   : partition object (o is older name)
  ; default-fs : default type
  ; mount?     : whether do mount or not
  (define title (_ "Partition Setting"))
  (define o #f)
  
  (define (automatic)
    (define title (_ "Auto-Partition"))
    (define (confirm)
      (let* ((l (filter (lambda (x)
                          (case (car x)
                            ((empty) #f)
                            ((dev) (equal? 'disc (list-ref x 3)))
                            (else #t)))
                        (obj-part 'list-all-part #t)))
             (r (snewt-nmenu title
                  (string-append
                    (_ "Disk(s) will be partitioned as shown below.\n")
                    (_ "If you are satisfied with the partition, press 'ok'.\n"))
                  68 5 5 9
                  (list->vector (map (lambda (x) (obj-part 'hw-mid-print #t x))
                                     l))
                  (vector (_ "finish") (_ "cancel")))))
        (case (car r)
          ((-1 2)
            (obj-part 'abort)
            #f)
          ((1)
            #t)
          (else
            (confirm)))))
    (let* ((ap (conf-autopart obj-part))
           ; auto-list
           (l (filter (lambda (x)
                        (case (car x)
                          ((empty) #t)
                          ((dev) (equal? 'disc (list-ref x 3)))
                          (else #t)))
                      (obj-part 'list-all-part #t)))
           (ataraid? (not (null? (obj-part 'hw-ataraid))))
           (r (snewt-checkbox title
                (string-append
                  (_ "Disk(s) is/are partitioned as shown below.\n")
                  (_ "Check region which you plan to leave to the installer.\n")
                  (if ataraid?
                    (_ "IDE RAID is shown as single drive and logical drive. Be carefull not to specify both at a time.\n")
                    "\n"))
                62 (if ataraid? 4 2) (if ataraid? 9 10)
                (list->vector (map (lambda (x) (cons (obj-part 'hw-mid-print #t x) #f))
                                   l))
                (vector (_ "Ok") (_ "Cancel")))))
      (cond
        ((not (= 0 (car r)))
          (obj-part 'abort)
          #f)
        ((eq? #f (ap 'init-flat l (vector->list (cdr r))))
          (snewt-message title (_ "Failed to do automatic partitioning(0).\n"))
          (obj-part 'abort)
          #f)
        ((eq? #f (ap 'analyze))
          (snewt-message title (_ "Failed to do automatic partitioning(1).\n"))
          (obj-part 'abort)
          #f)
        (else
          (confirm)))))
  
  (define (part-fdisk)
    (define (exec-fdisk d)
      (inst-log "start fdisk\n")
      (snewt-finish)
      (inst-log "start fdisk 2\n")
      (let ((r (unix-system (format #f "fdisk ~a" d))))
        (inst-log "end fdisk\n")
        (snewt-start)
        (newt-stage-title title)
        (inst-log "end fdisk 2\n")
        r))
    (inst-log "part-fdisk\n")
    (let ((d (part-select-drive (_ "Select drive to be partitioned with fdisk"))))
      (inst-log "selected : ~a\n" d)
      (cond
        ((boolean? d)
          d)
        (else
          (obj-part 'close-all-part)
          (let ((r (exec-fdisk (obj-part 'oldname d))))
            (obj-part 'init (obj-part 'get-context))
            (cond
              ((not (= 0 r))
                (snewt-message (_ "Error") (format #f (_ "fdisk exited with ~a") r))
                #f)
              ((= 1 (length (obj-part 'hw-disc)))
                ;(obj-part 'abort)
                #t)
              (else
                (part-fdisk))))))))
  
  ;
  ;     Select drive
  ;
  (define (part-select-drive m)
    (let ((a (obj-part 'hw-disc)))
      (cond
        ((null? a)
          (snewt-message (_ "Error") (_ "No drive found to be partitioned."))
          #f)
        ((= 1 (length a))
          (caar a))
        (else
          (let ((r (snewt-nmenu title
                     m 60 5 5 5
                     (list->vector
                       (map (lambda (x)
                              (sprintf "%-32s : %s"
                                (string-cut (obj-part 'did-desc (car x)) 32) (cadr x)))
                            a))
                     (vector (_ "Select") (_ "Next")))))
            (case (car r)
              ((-1) #f)
              ((2) #t)
              (else
                (car (list-ref a (cdr r))))))))))
  
  (define (mfdisk-create u x l)
    (define (ask s e)
      (let* ((s' s)
             (mn (i/ (* u (1+ (- e s'))) (* 1024 1024)))
             (m (format #f "~a" mn))
             (r (snewt-entries
                   (_ "New Partition")
                   (_ "Enter size for new partition in Mbytes.\n")
                   50 5 5 8
                   (list (list "" m 0)))))
        (cond
          ((null? r) r)
          ((= s' e) 
            (snewt-message (_ "Error") (_ "Could not create partition."))
            '())
          ((string=? (car r) m) (cons s' e))
          (else
            (let ((n (string->number (car r))))
              (cond
                ((eq? n #f)
                  (snewt-message (_ "Error") (_ "Number character is only allowed for size."))
                  '())
                ((and (< 0 n)
                      (<= n mn))
                  (cons s' (+ s' (1- (i/ (* n 1024 1024) u)))))
                (else 
                  (snewt-message (_ "Error")
                    (string-append
                      (_ "Entered value exceeds the valid range for partition size.\n")
                      (sprintf (_ "Enter value between %d and %d.\n") 0 mn)))
                  '())))))))
    (cond
      ((eq? 'e-empty (list-ref x 3))
        (let ((p (ask (list-ref x 4) (list-ref x 5))))
          (if (not (null? p))
              (obj-part 'create-part (cadr x) default-fs 0 (car p) (cdr p)))))
      (else
        (let ((pr (obj-part 'rest-primary (cadr x)))
              (ep? (obj-part 'have-extended (cadr x))))
          (cond
            ((null? pr)
              (snewt-smessage (_ "Error")
                (string-append
                  (_ "You are only able to have 4 primary partitions at most.\n")
                  (_ "To create more primary/extended partition, first delete some other partition."))
                56 4))
            (ep?
              (let ((r1 (ask (list-ref x 4) (list-ref x 5))))
                (if (not (null? r1))
                    (obj-part 'create-part (cadr x) default-fs (car pr) (car r1) (cdr r1)))))
            (else
              (let ((r0 (snewt-choice (_ "New Partition")
                          (_ "which partition do you create?")
                          (_ "primary") (_ "extended")))
                    (r1 (ask (list-ref x 4) (list-ref x 5))))
                (cond
                  ((= r0 0) #f)
                  ((null? r1) #f)
                  (else
                    (obj-part 'create-part (cadr x) (if (= 1 r0) default-fs 'ext)
                              (car pr) (car r1) (cdr r1)))))))))))
  
  ;
  ;   Delete / Modify partition
  ;
  (define (mfdisk-modify x)
    (cond
      ((eq? 'ext (car x))
        (let ((r (snewt-choice (_ "Change Partition")
                               (_ "Delete this partition?")
                    (_ "Delete")
                    (_ "cancel"))))
          (cond
            ((= r 1)
              (obj-part 'delete-part (cadr x) (list-ref x 3)))
            (else #t))))
      (else
        (let ((r (snewt-nmenu
                   (_ "Change/Delete Partition")
                   (_ "Choose FS type to change or Delete button")
                   56 5 5 8
                   (vector "Swap" "XFS" "Ext2" "Ext3" "Reiserfs" "JFS")
                   (vector (_ "Ok") (_ "cancel") (_ "Delete")))))
          (case (car r)
            ((-1) #f)
            ((1) #t)
            ((3)
              (obj-part 'delete-part (cadr x) (list-ref x 3)))
            (else
              (obj-part 'modify-part (cadr x) (list-ref x 3)
                   (case (cdr r)
                     ((0) 'swap)
                     ((1) 'linux-xfs)
                     ((2) 'linux-ext2)
                     ((3) 'linux-ext3)
                     ((4) 'linux-reiser)
                     (else 'linux-jfs)))))))))
  
  (define (mfdisk-rep did u)
    (let* ((l (obj-part 'list-part did))
           (r (snewt-nmenu title
                (string-append
                  (format #f (_ "  Drive : ~a\n\n") (obj-part 'did-desc did))
                  (_ "To modify/delete partition, select a partition.\n")
                  (_ "To create partition, select empty region.\n"))
                68 5 5 8
                (list->vector (map (lambda (x) (obj-part 'hw-mid-print #t x))
                                   l))
                (vector (_ "finish") (_ "cancel")))))
      (case (car r)
        ((2 -1) #f)
        ((1) #t)
        (else
          (let ((x (list-ref l (cdr r))))
            (cond
              ((eq? 'empty (car x))
                (mfdisk-create u x l))
              (else
                (mfdisk-modify x)))
            (mfdisk-rep did u))))))
  
  (define (part-check)
    (let ((r (obj-part 'check-mnt)))
      (cond
        ((eq? #t r) r)
        (else
          (snewt-message (_ "Error") (format #f (_ "Incorect mount point. : ~a") r))
          #f))))
  
  (define (mount-check-root)
    (inst-log "===== mount-check-root\n")
    (let ((l (filter (lambda (x)
                       (set-include? (car x)
                         '(linux-xfs linux-ext2 linux-ext3 linux-reiser linux-jfs linux-unknown)))
                     (obj-part 'list-all-part #f))))
      (cond
        ((not (null? (obj-part 'path-mnt "/")))
          #t)
        ((null? l)
          (snewt-message (_ "Error")
            (_ "There is no Linux partition. Create Linux partition first other menus first."))
          #f)
        (else
          (let ((r (apply snewt-menu
                     (append (list (_ "Root Partition Setting") (_ "Select Root partition.") 50 5 5 8)
                             (map (lambda (x) (obj-part 'did-desc (cadr x) (list-ref x 3)))
                                  l)))))
            (case r
              ((-1) #f)
              (else
                (obj-part 'add-mnt (list-ref l r) "/"))))))))
  
  (define (mount-check-swap)
    (inst-log "===== mount-check-swap\n")
    (let ((l (filter (lambda (x) (equal? 'swap (car x)))
                     (obj-part 'list-all-part #f))))
      (cond
        ((not (null? (obj-part 'path-mnt "swap")))
          #t)
        ((null? l)
          (let ((r (snewt-choice (_ "Confirm")
                     (_ "Do you proceed without swap partition?")
                     (_ "Ok") (_ "Edit Again"))))
            (= r 1)))
        (else
          (let ((r (snewt-nmenu (_ "Swap Partition Setting")
                     (_ "Select swap partition.") 50 5 5 8
                     (list->vector (map (lambda (x) (obj-part 'did-desc (cadr x) (list-ref x 3)))
                                        l))
                     (vector (_ "No Swap") (_ "Ok")))))
            (case (car r)
              ((-1) #f)
              ((1) #t)
              (else
                (obj-part 'add-mnt (list-ref l (cdr r)) "swap"))))))))
  
  (define (part-medit first?)
    (let ((l (filter (lambda (x)
                       (case (car x)
                         ((empty) #f)
                         ((dev) (equal? 'disc (list-ref x 3)))
                         (else #t)))
                     (obj-part 'list-all-part #t))))
      (cond
        ((null? l)
          (snewt-message (_ "Error") (_ "You have no partition yet."))
          #f)
        (else
          (let ((r (snewt-nmenu
                      (_ "Mount Point Setting")
                      (string-append
                        (_ "You can edit more mount point here.\n")
                        (_ "If this mount table is enough for you, press 'finish'.\n\n"))
                      68 5 5 9
                      (list->vector (map (lambda (x) (obj-part 'hw-mid-print #t x))
                                         l))
                      (vector (_ "finish") (_ "cancel")))))
            (case (car r)
              ((0)
                (part-edit-one (list-ref l (cdr r)) first?)
                (part-medit first?))
              ((1)
                (if (part-check)
                    #t
                    (part-medit first?)))
              (else
                #f)))))))
  
  (define (part-edit-one l first?)
    (cond
      ((< (length l) 6)
        (snewt-message (_ "Info") (_ "Nothing done for disk itself.")))
      ((eq? 'ext (car l))
        (snewt-message (_ "Info") (_ "Could not edit extended partition.")))
      (else
        (let* ((m (obj-part 'search-mnt l))
               (r (snewt-entries
                    (_ "Modify Mount point")
                    (format #f (_ "Enter mount point or swap for '~a'.\nWhen delete mount point, just enter empty string.\n")
                               (obj-part 'did-desc (cadr l) (list-ref l 3)))
                    50 5 5 13
                    (list (list "" m 0)))))
          (cond
            ((null? r)
              #f)
            (else
              (let ((r1 (cond
                          ((string=? (car r) "")
                            (if (string=? "" m)
                              #t
                              (obj-part 'del-mnt m)))
                          (else
                            (let ((x (obj-part 'add-mnt l (car r))))
                              (cond
                                ((eq? x #t)
                                  #t)
                                (else
                                  (snewt-message (_ "Error")
                                    (format #f (_ "Could not set mount point.\nReason:~a") x))
                                  #t)))))))
                (cond
                  ((or (not r1)
                       (not first?)
                       (not (equal? 131 (list-ref l 8))))
                    r1)
                  (else
                    (let ((r (snewt-menu title
                               (_ "Select a filesystem for the partition.")
                               50 5 5 5 "XFS" "Ext2" "Ext3" "ReiserFS" "JFS")))
                     (if (equal? -1 r)
                       #f
                       (obj-part 'modify-part (cadr l) (list-ref l 3)
                         (case r
                           ((0) 'linux-xfs)
                           ((1) 'linux-ext2)
                           ((2) 'linux-ext3)
                           ((3) 'linux-reiser)
                           (else 'linux-jfs))))))))))))))
  
  (define (mfdisk)
    (let ((did (part-select-drive (_ "Select drive to be partitioned."))))
      (cond
        ((boolean? did)
          did)
        ((not (mfdisk-rep did (* (obj-part 'block-size did) (obj-part 'unit-size did))))
          (if (not (obj-part 'abort-part did))
            (inst-log "Aborting ~a failed\n" did))
          #f)
        ((= 1 (length (obj-part 'hw-disc)))
          #t)
        (else
          (mfdisk)))))
  
  (define (check&format cl l)
    (cond
      ((null? cl) #t)
      ((not (car cl)) (check&format (cdr cl) (cdr l)))
      (else
        (let* ((x (car l))
               (d (obj-part 'devfsname (car x) (list-ref x 5))))
          (sh "dd if=/dev/zero of=~a bs=1024 count=65" d)
          (snewt-progress-init
            (format #f (_ "Formatting ~a") (list-ref x 6))
            (obj-part 'did-desc (car x) (list-ref x 5)))
          (let ((r (progress-start
                     (let ((log (if (equal? "logger" sh-log) "/dev/null" sh-log)))
                       (format #f "PROGRESS_FD=9 ~a ~a 9>&1 2>~a 1>~a | tee /tmp/mkfslog "
                                  (obj-part 'format-command (list-ref x 6)) d log log))
                     (lambda (f m) (snewt-progress-update f "")))))
            (cond
              ((not (= 0 r))
                (inst-log "format command returned ~a.\n" r)
                (snewt-message (_ "Fatal Error")
                  (format #f (_ "Failed to format ~a (~a).\n" d (list-ref x 6))))
                #f)
              (else
                (if (equal? 'swap (list-ref x 6))
                  (sh "swapon ~a" d))
                (snewt-progress-finish)
                (check&format (cdr cl) (cdr l)))))))))
  
  (define (do-format auto?)
    (inst-log "===== do-format ~a\n" auto?)
    (let ((l (obj-part 'list-always-mnt #f)))
      (cond
        ((null? l)
          #t)
        (auto?
          (check&format (map (lambda (x) #t) l) l))
        (else
          (let* ((l (map (lambda (x)
                           (cons (sprintf "%11s : %s, %s"
                                          (obj-part 'did-desc (car x) (list-ref x 5))
                                          (symbol->string (list-ref x 6))
                                          (list-ref x 4))
                                 #t))
                         (obj-part 'list-always-mnt #f)))
                 (r (snewt-checkbox
                        (_ "Partition Formatting")
                        (string-append
                          (_ "Checked partitions are going to be formatted.\n")
                          (_ "If you have a partition not to be formatted, uncheck it.\n\n"))
                        52 5 5
                        (list->vector l)
                        (vector (_ "Ok") (_ "Cancel"))))
                 (b (car r))
                 (cl (vector->list (cdr r))))
              (cond
                ((not (= b 0)) #f)
                (else
                  (check&format cl (obj-part 'list-always-mnt #f)))))))))
  
  (define (do-mount)
    (inst-log "===== do-mount\n")
    (cond
      ((eq? #f (snewt-show-while (_ "Mounting Filesystems")
                 (_ "Mounting target filesystem(s) ....") 54 3
                 (lambda () (obj-part 'domount))))
        (snewt-message (_ "Fatal Error")
          (_ "Failed to mount some partition."))
        #f)
      (else
        #t)))
  
  (define (fs-check)
    (let ((l (filter (lambda (x) (equal? 'linux-unknown (list-ref x 6)))
                     (obj-part 'list-mnt))))
      (cond
        ((null? l) #t)
        (else
          (let ((r (snewt-menu title
                     (apply string-append
                       (cons
                         (_ "Filesystem type for partition below is not determined.\nWhich filesystem do you use?\n\n")
                         (map (lambda (x) (format #f "    ~a for ~a\n"
                                                  (obj-part 'did-desc (car x) (list-ref x 5))
                                                  (list-ref x 4)))
                              l)))
                     50 5 5 5 "XFS" "Ext2" "Ext3" "ReiserFS" "JFS")))
           (if (equal? -1 r)
             #f
             (let ((t (case r
                        ((0) 'linux-xfs)
                        ((1) 'linux-ext2)
                        ((2) 'linux-ext3)
                        ((3) 'linux-reiser)
                        (else 'linux-jfs))))
               (map (lambda (x) (obj-part 'modify-part (car x) (list-ref x 5) t))
                    l)
               (obj-part 'set-default-fs t)
               #t)))))))
  
  (define (start-mnt auto? leave?)
    (inst-log "===== start-mnt ~a ~a\n" auto? leave?)
    (let ((r (or leave?
               (snewt-show-while title
                 (_ "Writing on to the disk(s) ...")
                 50 4
                 (lambda () (obj-part 'commit-part))))))
      (cond
        ((not r)
          (snewt-message (_ "Info")
            (string-append
              (_ "Kernel could not read newly created partition. \n\n")
              (_ "If you use IDE RAID device (or other similar one), this isn't error. ")
              (_ "Reboot system once and choose 'Leave partition as current' next time. ")
              (_ "\n\nPressing Ok will reboot system. ")))
          (snewt-finish)
          (exit 0))
        (else
          (and (mount-check-root)
               (mount-check-swap)
               (if auto? #t (part-medit leave?))
               (fs-check))))))
  
  (define (sanity-check)
    (let ((l (filter (lambda (x) (not (obj-part 'sane-table? (car x))))
                     (obj-part 'hw-disc))))
      (cond
        ((null? l)
          #t)
        (else
          (let ((r (snewt-choice (_ "Partition Setting")
                     (apply string-append
                       (append
                         (list (_ "Disk(s) below seems to have a broken partition table.\n\n"))
                         (map (lambda (x)
                                (format #f "  - ~a" (obj-part 'did-desc (car x))))
                              l)
                         (list
                           (_ "\n\nDo you initialize a partition table of this device(s)? ")
                           (_ "If not, you need to initialize it manually (ie using dd or fdisk) before installation"))))
                     (_ "Yes") (_ "No"))))
            (cond
              ((not (= 1 r))
                #t)
              ((not (andmap
                      (lambda (x)
                        (= 0 (sh "dd if=/dev/zero of=~a count=1" (obj-part 'devfsname (car x)))))
                      l))
                (snewt-message (_ "Fatal Error")
                  (_ "Could not initialize partition. (no dd command?)"))
                #f)
              (else
                (obj-part 'abort)
                #t)))))))
  
  (define (swap-check)
    (inst-log "Checking swap ...\n")
    (let ((mem (unix-filesize "/proc/kcore"))
          (sw (apply +
                (map (lambda (x)
                       (case (list-ref x 6)
                         ((swap)
                           (* (obj-part 'block-size (car x))
                              (obj-part 'unit-size (car x))
                              (1+ (- (list-ref x 3) (list-ref x 2)))))
                         (else
                           0)))
                     (obj-part 'list-mnt))))
          (retry (lambda () (begin (obj-part 'abort) #f))))
      (inst-log "mem :~a, sw:~a\n" mem sw)
      (cond
        ((< (* 255 1024 1024) (+ mem sw))
          #t)
        ((equal? 'orca (product-type))
          (snewt-message (_ "Error")
            (string-append
              (_ "In order to run ORCA server, the machine should virtually have at least 256MB memory. ")
              (_ "Set partition again and increase swap size. ")))
          (retry))
        ((= 1 (snewt-choice (_ "Partition Setting")
                (string-append
                  (_ "In order to run most application, it is recommended that the machine virtually has at least 256MB memory. ")
                  (_ "Do you set partition again?"))
                (_ "Yes") (_ "No")))
          (obj-part 'abort)
          (retry))
        (else
          #t))))
  
  (define (fs-capacity-check)
    (inst-log "checking capacity ...\n")
    (let* ((sz (apply +
                 (map (lambda (x)
                        (case (list-ref x 6)
                          ((swap)
                            0)
                          (else
                            (* (obj-part 'block-size (car x))
                               (obj-part 'unit-size (car x))
                               (1+ (- (list-ref x 3) (list-ref x 2)))))))
                      (obj-part 'list-mnt))))
           (szg (/ sz (* 1024 1024 1024))))
      (inst-log "sz : ~a, sgz : ~a\n" sz szg)
      (if (equal? 'orca (product-type))
        (cond
          ((< 10.0 szg)
            #t)
          ((= 1 (snewt-choice (_ "Warning")
                  (string-append
                    (if (< szg 2.0)
                      (_ "Too small free disk space. ")
                      (_ "Small free disk space. "))
                    "\n\n"
                    (if (< szg 3.0)
                      (_ "In order to install ORCA, there should be at least 3GB of free space. ")
                      "")
                    (_ "If you plan to use the machine as simple ORCA client, this may not be a problem. (if so, at least 2GB of free space is required) ")
                    (_ "If you plan to run ORCA server, free space should be have more than 20GB. ")
                    (_ "\n\nDo you retry the partition setting?"))
                  (_ "Yes") (_ "No")))
            (obj-part 'abort)
            #f)
          (else
            #t))
        (cond
          ((< 3.0 szg)
            #t)
          ((= 1 (snewt-choice (_ "Warning")
                  (string-append
                    (cond
                      ((< szg 1.4)
                        (_ "Free disk space is so small that an average installation cannot be accomplished. "))
                      ((< szg 2.0)
                        (_ "Free disk space is too small. "))
                      (else
                        (_ "Free disk space is small. ")))
                    (_ "\n\nIn order to run most application, it is recommended you have at least 3GB of free space. ")
                    (_ "\n\nDo you retry the partition setting?"))
                  (_ "Yes") (_ "No")))
            (obj-part 'abort)
            #f)
          (else
            #t)))))
  
  (define (start)
    (early-swapoff-check)
    (and
      (sanity-check)
      (let* ((r0 (snewt-menuc
                   (_ "Partition Setting")
                   (_ "Select method for partitioning. \nWhen you select 'automatic', you will get a confirmation before the actual writing.\n")
                   50 5 5 5
                   (_ "Automatic")
                   (_ "Edit with Menu")
                   (_ "Edit with fdisk")
                   (_ "Leave partition as current")))
             (auto? (= r0 0)))
        (if (= -1 r0)
          #f
          (let ((r1 (case r0
                      ((0) (automatic))
                      ((1) (mfdisk))
                      ((2) (part-fdisk))
                      (else #t))))
            (cond
              ((not r1)
                (start))
              (else
                (and
                  (start-mnt auto? (= r0 3))
                  (cond
                    ((not (and (swap-check) (fs-capacity-check)))
                      (start))
                    (else
                      (and (do-format auto?)
                           (do-mount))))))))))))
  
  (set! o obj-part)
  (newt-stage-title title)
  (case (obj-part 'get-context)
    ((inst1 inst2 recovery)
      (start))
    (else
      (cond
        (mount?
          (start))
        ((mfdisk)
          (obj-part 'commit)
          (snewt-message (_ "Info") 
            (string-append
              (_ "You need to manually format the newly created partitions. ")
              (_ "When you modify the already mounted drive, you also need to reboot before formatting.")))
          #t)
        (else
          #f)))))

(define (newt-ui-base obj-med)
  (newt-stage-title (_ "Base Installation"))
  (let ((r (snewt-show-while
            (_ "Base Installation")
            (_ "Installing base files. This step takes a few minutes.\nPlease wait a moment ...")
            54 3
            (lambda ()
              (obj-med 'pipe "ogl/inst/base.tgz" "gunzip | (cd /target ; tar x)")))))
    (cond
      ((not r)
        (snewt-message (_ "Error") (_ "Failed to get base file."))
        r)
      (else
        (sh "mkdir -p /target/var/lib/ogl/etc")
        (sh "cp /var/lib/ogl/etc/title /target/var/lib/ogl/etc")
        (unix-sync)
        #t))))

(define (newt-ui-time obj-time)
  (define (tz)
    (let* ((l (append (obj-time 'get-root) (obj-time 'get-table)))
           (r (snewt-radio-tree (_ "TimeZone Setting")
                (_ "Select appropriate time zone for your location.")
                30 1 10 l)))
      (obj-time 'set-tz r)
      #t))
  ; cancel ǤƤʤ
  
  (define (hw)
    (case (snewt-choice (_ "Clock Setting")
            (string-append
              (_ "You can select two different types of clock setting.\n\n")
              (_ "The machine has its own hardware clock which can be set with BIOS. ")
              (_ "This is called 'hardware clock'. ")
              (_ "On the other hand, OS has its own expression of time, according to the location. ")
              (_ "This is called 'local time'.\n\n")
              (_ "You can set local time to hardware clock or GMT. ")
              (_ "If you have several Unix like OS installed, it might be better to set it to GMT.")
              (_ "Otherwise you would better to set it to hardware clock.\n\n")
              (_ "Would the local time be set to hardware clock?"))
            (_ "Yes") (_ "No"))
      ((0) #f)
      ((1) (obj-time 'set-hwclock #t) #t)
      (else (obj-time 'set-hwclock #f) #t)))
  (newt-stage-title (_ "Time Setting"))
  (and (tz) (hw)))


(define (newt-ui-kern obj-med obj-boot)
  (define title (_ "Kernel Installation"))
  (newt-stage-title title)
  (let* ((tmp (unix-tempname)))
    (obj-med 'cp (format #f "ogl/inst/kernel/desc~a" (if (lang-ja?) "-ja" "")) tmp)
      (let ((tbl (ttable-read tmp '((str str str str)))))
        (cond
          ((or (not (list? tbl)) (null? tbl))
            (snewt-message (_ "Fatal Error")
              (_ "Could not read kernel description table. Aborting, sorry."))
            #f)
          (else
            (define (k-select)
              (let* ((r (snewt-checkbox title
                          (_ "You can install several kernels here. Please check the kernel which you want to install.")
                          60 5 7
                          (list->vector
                            (map (lambda (x)
                                   (cons
                                     (sprintf "%-20s %-38s" (string-cut (caddr x) 20) (string-cut (list-ref x 3) 38))
                                     (equal? (car x) (get-proc-version))))
                                 tbl))
                          (vector (_ "Ok"))))
                     (b (car r))
                     (cl (vector->list (cdr r))))
                (cond
                  ((not (= b 0))
                    (snewt-message (_ "Error")
                      (_ "This process cannot be skipped."))
                    (k-select))
                  ((not (ormap (lambda (x) x) cl))
                    (snewt-message (_ "Error")
                      (_ "You have to install at least one kernel."))
                    (k-select))
                  (else
                    (filter string?
                      (map (lambda (x y) (if x (car y)))
                           cl tbl))))))
            (define (def-sel l)
              (cond
                ((= 1 (length l))
                  (car l))
                (else
                  (let ((r (snewt-nmenu title
                             (_ "Select default kernel.")
                             50 5 5 5
                             (list->vector l)
                             (vector (_ "Ok")))))
                    (cond
                      ((< (car r) 0)
                        (snewt-message (_ "Error")
                          (_ "This process cannot be skipped."))
                        (def-sel))
                      (else
                        (list-ref l (cdr r))))))))
            (let* ((l (k-select))
                   (d (def-sel l)))
              (snewt-progress-init title (_ "Installing kernel ..."))
              (let ((r (progress-start
                         (format #f "(PROGRESS_FD=9 /scm/install-kernel.scm ~a 9>&1 2>/tmp/klog 1>/tmp/klog ; echo $? >/tmp/exit-kinst) | tee /tmp/instk.log"
                           (list-foldstring " " l))
                         (lambda (f m) (snewt-progress-update f "")))))
                (snewt-progress-finish)
                (let ((r' (parse-awk #\space #t "/tmp/exit-kinst")))
                  (cond
                    ((not (equal? '(("0")) r'))
                      (inst-log "kernel installation command returned ~a.\n" r')
                      (snewt-fatal-error
                        (format #f (_ "Kernel installation failed (~a).\n") r'))
                      #f)
                    (else
                      (map (lambda (x)
                             (if (not (equal? x d))
                               (obj-boot 'add-default x)))
                           l)
                      (obj-boot 'add-default d)
                      (obj-boot 'set-timeout 3)
                      #t))))))))))

(define (newt-ui-bios-order obj-part)
  (define title (_ "BIOS Drive Order"))
  
  (define (if->str x)
    (sprintf "   %s   " (obj-part 'hw-ifname (car x) (cadr x))))
  
  (define (make-up n l)
    (cond
      ((or (= n 0) (null? l)) l)
      ((not (= n 1))
        (cons (car l) (make-up (1- n) (cdr l))))
      ((= 1 (length l))
        l)
      (else
        (cons (cadr l)
          (cons (car l) (cddr l))))))
  
  (define (rep g)
    (let ((r (snewt-nmenu title
               (_ "Selected item will moves upward.\n")
               50 5 5 5
               (list->vector (map if->str g))
               (vector (_ "Ok") (_ "Cancel")))))
      (case (car r)
        ((-1 2) #f)
        ((1) g)
        (else
          (let ((r (make-up (cdr r) g)))
            (if (list? r) (rep r) #f))))))
  
  (newt-stage-title (_ "BIOS Drive Order setting"))
  (let ((g (obj-part 'hw-get-biosorder)))
    (cond
      ((< (length g) 2)
        #t)
      (else
        (let ((r (snewt-choice title
                   (apply string-append
                     (append
                       (list
                         (_ "Several type of disc interfaces are found. ")
                         (_ "Either to boot or to install boot-loader correctly, you need to specify drive order in BIOS.")
                         (_ "Order of line below should be exactly as same as that of BIOS. ")
                         (_ "Do you set up BIOS drive order?\n\n"))
                       (map (lambda (x) (format #f "  ~a  \n" (if->str x)))
                            g)))
                   (_ "Set up") (_ "Leave as shown"))))
          (case r
            ((1)
              (let ((r (rep g)))
                (cond
                  ((list? r)
                    (obj-part 'hw-set-biosorder r))
                  (else
                    #f))))
            (else #t)))))))


(define (newt-ui-power-management obj-mod obj-boot)
  (define title (_ "Power Management"))
  (newt-stage-title title)
  (let* ((acpi-valid? (not (null? (string-match (obj-boot 'get-option) "acpi=on"))))
         (apm-valid? (not (null? (filter (lambda (x) (equal? 'apm (car x)))
                          (obj-mod 'table)))))
         (opt (string-gsub (string-gsub (obj-boot 'get-option) "acpi=[^ ]\\+" "")
                           "  " " "))
         (r (snewt-menuc title
             (string-append
               (_ "Specify the method for power management.\n")
               (_ "Linux can do two ways of power management : APM and ACPI\n\n")
               (_ "APM is classical and safe. ")
               (_ "Although Linux ACPI is still under development and doesn't work enough, ")
               (_ "some recent notebook PCs lack APM and might require ACPI in order to work PCI device properly.")
               (_ "\n\nCurrent status : ")
               (cond
                 (acpi-valid? (_ "ACPI valid "))
                 (apm-valid? (_ "APM valid "))
                 (else (_ "No Power management")))
               "\n")
             62 5 5 5
             (_ "Use APM") (_ "Use ACPI") (_ "No Power Management"))))
    (case r
      ((1)
        (if (not apm-valid?)
          (obj-mod 'setmod "apm" "" 'inst/set))
        (if acpi-valid?
          (obj-boot 'set-option opt))
        #t)
      ((2)
        (if apm-valid?
          (obj-mod 'rmmod "apm"))
        (if (not acpi-valid?)
          (obj-boot 'set-option (format #f "~a acpi=on" opt)))
        #t)
      ((3)
        (if apm-valid?
          (obj-mod 'rmmod "apm"))
        (if acpi-valid?
          (obj-boot 'set-option opt))
        #t)
      (else
        #f))))

(define (newt-ui-install-br obj-boot obj-part first?)
  (define title (_ "Boot Record Installation"))
  (define (check-win)
    (let ((l (filter (lambda (x)
                       (case (car x)
                         ((dev empty) #f)
                         (else (id-win? (list-ref x 8)))))
                     (obj-part 'list-all-part #f))))
      (define (add t p)
        (obj-boot 'add-entry (list 'P t (cadr p) (1- (list-ref p 3)))))
      (inst-log "adding boot loader for : ~a\n" l)
      (if (= 1 (length l))
        (add "Windows" (car l))
        (smap (lambda (n x)
                (add (format #f "Windows(~a)" n) x))
              l))))
  
  (newt-stage-title title)
  (let ((l (obj-part 'hw-disc))
        (p (obj-part 'boot-mnt)))
    (cond
      ((or (null? l) (null? p))
        (snewt-message (_ "Error")
          (_ "Disc drive or boot partition couldn't be found."))
        #f)
      (else
        (let* ((ext? (< 0 (caddr p)))
               (desc0 (obj-part 'did-desc (car p) (if ext? (caddr p) (cadr p))))
               (boot-part? (list-ref p 3))
               (desc-p (cons
                         (format #f (_ "top region of ~a") desc0)
                         (not ext?)))
               (desc-m (map (lambda (x)
                              (cons
                                (format #f (_ "top region of ~a") (obj-part 'hw-desc x))
                                (and (not (equal? 'ataraid (list-ref x 3)))
                                     (equal? (car x) (car p)))))
                            l))
               (r (snewt-checkbox title
                    (string-append
                      (_ "Select regions where boot loader will be installed.\n")
                      (if (ormap (lambda (x) (equal? 'ataraid (list-ref x 3))) l)
                        (_ "If you want to use ATA RAID device as root partition, it is recommended not to install the boot loader and instead to use a boot FD (or other media). ")
                        "")
                      (if boot-part?
                        ""
                        (_ "(XFS partitions are not listed because boot loader cannot be installed. )"))
                      (if (and boot-part? ext?)
                        (format #f (_ "'~a' is an extended partition where boot partions resides.\n") desc0)
                        ""))
                    52 5 6
                    (list->vector
                      (if boot-part? (cons desc-p desc-m) desc-m))
                    (vector (_ "Ok") (_ "Cancel"))))
               (b (car r))
               (cl (vector->list (cdr r))))
          (cond
            ((not (= b 0)) #f)
            ((not (ormap (lambda (x) x) cl))
              (cond
                ((not first?)
                  #f)
                ((= 1 (snewt-choice title
                        (string-append
                          (_ "Without boot loader, the system won't be able to boot. ")
                          (_ "In this case, you have to use boot fd or other (already installed some) boot loader. ")
                          (_ "\n\nDo you proceed without boot loader installation?"))
                        (_ "Yes") (_ "No")))
                  #f)
                (else
                  (newt-ui-install-br obj-boot obj-part first?))))
            (else
              (let ((r1 (if (and boot-part? (car cl))
                          (obj-boot 'install (car p) (if ext? (caddr p) (cadr p)))
                          #t))
                    (r2 (map (lambda (x y)
                               (if y
                                 (obj-boot 'install (car x))
                                 #t))
                             l (if boot-part? (cdr cl) cl))))
                (cond
                  ((andmap (lambda (x) (eq? #t x))
                           (cons r1 r2))
                    (if first? (check-win))
                    #t)
                  ((= 1 (snewt-choice title
                          (apply string-append
                            (append
                              (list
                                (_ "Failed to install grub into regions below. ")
                                (if (and (not first?)
                                      (andmap (lambda (x) (equal? 1 x))
                                        (cons r1 r2)))
                                  (_ "This may be that grub tried to use running journaling file systems and cannot read it. You don't need to care match about this but should try later (or after next boot). ")
                                  "")
                                "\n\n"
                                (if (eq? #t r1) "" (format #f "    ~a\n" (car desc-p))))
                              (map (lambda (x y) (if (eq? #t y) "" (format #f "    ~a\n" (car x))))
                                   desc-m r2)
                              (list
                                (_ "\nDo you retry boot loader install?"))))
                         (_ "Yes") (_ "No")))
                    (newt-ui-install-br obj-boot obj-part first?))
                  (else
                    #f))))))))))

(define (newt-ui-bootfd inst? obj-boot obj-part)
  (newt-stage-title (_ "Boot Floppy"))
  (let* ((f (obj-part 'get-fdd)))
    (cond
      ((equal? f "")
        (snewt-message (_ "Error")
          (_ "Could not find floppy device."))
        #f)
      (else
        (let* ((old? (or (equal? f "/dev/fd0") (equal? f "/dev/floppy/0")))
               (s (if old?
                    (snewt-ternary
                      (_ "Boot Floppy Disk")
                      (if inst?
                        (_ "Remove installer FD from drive and insert new floppy disk.\n")
                        (_ "Insert new floppy disk.\n"))
                      (_ "Proceed") (_ "Format&Proceed") (_ "Cancel"))
                    (snewt-choice
                      (_ "Boot Floppy Disk")
                      (if inst?
                        (_ "Remove installer FD from drive and insert new floppy disk.\n")
                        (_ "Insert new floppy disk.\n"))
                      (_ "Proceed") (_ "Cancel")))))
          (case s
            ((0) #f)
            (else
              (cond
                ((= s (if old? 3 2))
                  #f)
                (else
                  (let ((r (snewt-show-while (_ "Boot Floppy Disk")
                             (_ "Creating boot floppy disk ...") 40 3
                             (lambda () (obj-boot 'make-fd (and old? (= s 2)))))))
                    (cond
                      ((string? r)
                        (snewt-message "Error"
                          (format #f (_ "Could not create boot floppy disk.\nReason:~a\n\n") r))
                        (newt-ui-bootfd inst? obj-boot obj-part))
                      (else
                        #t))))))))))))
