;;#################################
;;        print setting
;;#################################
(define retain 'start)
(define (configure-oprint)

  (define object-name "ogl-print")
  (define filter-dir "/usr/lib/ogl/lib/")
  (define printcap "/etc/printcap")
  (define printerconf "/var/lib/ogl/printerconf")
  (define filterconf "/var/lib/ogl/filterconf")
  (define drvtbl "/usr/lib/ogl/lib/gsdrv-tbl")
  (define testps "/usr/lib/ogl/lib/testprint.ps")
  (define smbprint "/usr/sbin/ogl/smbprint")
  (define smbspool "/var/spool/lpd/smb")
  (define hoge "/tmp/hoge")
  (define printers '())
  (define filters '())
  (define drivers '())
  (define init-files '())
;
; ȥν
;
;

  (define (set-context . a)
    #t)
  
;
;######### load #########
;

  (define (load)

    (define (item-check key ls)
      (if (null? ls) '()
          (if (assoc key (car ls))
              (item-check key (cdr ls))
              ls)))
    (define (equal-set? x y)
      (define (include? s mother)
        (if (null? s) #t
            (if (member (car s) mother)
                (include? (cdr s) mother)
                #f)))
      (if (and (include? x y)
               (include? y x))
          #t
          #f))
    (define (req-filter ls)
      (if (null? ls) '()
          (if (and (> (length (car ls)) 1) 
                   (string? (cadar ls))
                   (or (string=? (cadar ls) "Non-PS") 
                       (string=? (cadar ls) "SERVER")
                       (string=? (cadar ls) "SMBN")))
              (cons (caar ls) (req-filter (cdr ls)))
              (req-filter (cdr ls)))))
          
    (define er-driver '())
    (set! printers (stripq (parse-awk #\tab printerconf)))
    (set! filters (strip-head (parse-awk #\tab filterconf)))
    (set! filters (if filters  filters '())) 
    (set! drivers (strip-head (parse-awk #\tab drvtbl)))
    (set! init-files (set-files))
    (cond
       ((or (not printers) (null? printers)) 'no-conffile)
       ((or (not drivers) (null? drivers)) 'no-drvtbl)
       (else (let loop ((item (item-check "DRIVER" drivers)))
               (if (not (null? item))
                   (let ((name (cadr (assoc "DRIVER" (car item)))))
                     (set! drivers (delete (list "DRIVER" name) drivers))
                     (set! er-driver (cons name er-driver))
                     (loop (item-check "DRIVER" (cdr item))))))
             (let loop ((item (item-check "DESCRIPTION" drivers)))
               (if (not (null? item))
                   (let ((name (cadr (assoc "DRIVER" (car item)))))
                     (set! drivers (delete (list "DRIVER" name) drivers))
                     (set! er-driver (cons name er-driver))
                     (loop (item-check "DESCRIPTION" (cdr item))))))
             (cond
              ((null? printers) 'empty-conffile)
              ((not (null? (item-check "FILTER" filters))) 'no-FILTER)
              ((not (null? (item-check "TYPE" filters))) 'no-TYPE)
              ((not (equal-set? (req-filter printers) (map (lambda (x) (cadr (assoc "FILTER" x))) filters)))
               'not-match-filtername)
              ((not (null? er-driver)) er-driver)
              (else (if (and (conf-load-test object-name printcap mkprintcap)
                             (let loop ((t init-files))
                               (if (null? t) #t
                                   (if (conf-load-test object-name (car t) (lambda (x) (mkfilter x (car t))))
                                       (loop (cdr t))
                                       #f))))
                        'success
                        'md5sum))))))
    
  (define (stripq l)
    (cond
     ((null? l) '())
     ((not l) '())
     ((string=? (caar l) "") (stripq (cdr l)))
     ((char=? (car (string->list (caar l))) #\#) (stripq (cdr l)))
     ((printer? (car l)) (cons (car l) (stripq (cdr l))))
     (else (stripq (cdr l)))))

  (define (printer? q)
    (if (>= (length q) 2)
        (cond
         ((string=? (cadr q) "LOCAL")  (= (length q) 3))
         ((string=? (cadr q) "Non-PS") (= (length q) 3))
         ((string=? (cadr q) "REMOTE") (= (length q) 4))
         ((string=? (cadr q) "SERVER") (= (length q) 4))
         ((string=? (cadr q) "SMBPS")  (= (length q) 4))
         ((string=? (cadr q) "SMBN")   (= (length q) 4))
         (else #f))
        #f))

  (define (strip-head l)
    (cond
     ((null? l) '())
     ((not l) '())
     ((string=? (caar l) "") (strip-head (cdr l)))
     ((char=? (car (string->list (caar l))) #\#) (strip-head (cdr l)))
     ((string? (caar l)) (let ((m (mkentry l)))
                           (if (list? (caar (last-pair m)))
                               (cons (reverse (cdr (reverse m))) (strip-head (car (last-pair m))))
                               (list m))))
     (else '(not-string))))

  (define (mkentry body)
     (cond
      ((null? body) '())
      ((string=? (caar body) "") (if (null? (cdr body)) '() (list (cdr body))))
      ((char=? (car (string->list (caar body))) #\#) (mkentry (cdr body)))
      ((string? (caar body)) (cons (car body) (mkentry (cdr body))))))
  
  ;########## driver-index ##########
  ;---------- A list of driver and description ----------
  ;
  (define (driver-index ls)  
    (if (null? ls) '()
        (let ((name (assoc "DRIVER" (car ls)))
              (description (assoc "DESCRIPTION" (car ls))))
          (if (and name description
                   (= 2 (length name) (length description)))
              (cons (cons (cadr name) (cadr description)) (driver-index (cdr ls)))
              (driver-index (cdr ls))))))
                   

  ;
  ;########## filter ##########
  ;
  (define (inquiry-filter . arg)
    (if (null? arg) (apply list filters)
        (map (lambda (x) (assoc (list "FILTER" x) filters)) arg)))

  ;
  ;########## printer ##########
  ;
  (define (inquiry-printer . arg)
    (if (null? arg) (apply list printers)
        (map (lambda (x) (assoc x printers)) arg)))

  ;
  ;########## driver ##########
  ;
  (define (inquiry-driver . arg)
    (if (null? arg) (apply list drivers)
        (map (lambda (x) (assoc (list "DRIVER" x) drivers)) arg)))

  ;
  ;########## delete ##########
  ;
  (define (delete key l)
    (if (null? l) '()
        (if (member key (car l))
            (cdr l)
            (cons (car l) (delete key (cdr l))))))

  (define (delete-printer name)
    (if (assoc name printers)
        (let ((t (cadr (assoc name printers))))
          (set! printers (delete name printers))
          (if (or (string=? t "Non-PS")
                  (string=? t "SERVER")
                  (string=? t "SMBN"))
              (delete-filter name))
          '())))

  (define (delete-filter key)
    (set! filters (delete (list "FILTER" key) filters)))

  ;
  ;########## replace ##########
  ;
  (define (replace key new l) 
    (if (null? l) '()
        (if (member key (car l))
            (cons new (cdr l))
            (cons (car l) (replace key new (cdr l))))))

  ;
  ;########## lpd? ##########
  ;
  (define (lpd?)
    (zero? (sh "nmap localhost | grep printer > /dev/null")))

  ;
  ;########## lprng restart ##########
  ;
  (define (lprng-restart)
    (and (zero? (sh "/etc/init.d/lprng stop > /dev/null"))
         (zero? (sh "/etc/init.d/lprng start > /dev/null"))))

  ;
  ;########## test-print ##########
  ;
  (define (test-print pr)
    (define (gs-print)
      (let ((filter (unix-tempname "/tmp" "filt")))
        (if (eq? 'done (mkfilter filter (string-append filter-dir (car pr) ".gsfilter-ogl")))
            (cond
             ((string=? (cadr pr) "Non-PS") (sh "~a < ~a > /dev/~a" 
                                                filter testps (caddr pr)))
             ((string=? (cadr pr) "SERVER") (sh "~a < ~a | lpr -P~a@~a"
                                                filter testps (caddr pr) (cadddr pr)))
             ((string=? (cadr pr) "SMBN") (smb-config pr) (sh "~a < ~a" filter testps)))
            (set! filter #f))
        (if filter (sh "rm ~a" filter)
            'wrong-filter)))
             
    (cond
     ((string=? (cadr pr) "LOCAL") (sh "cat ~a > /dev/~a" testps (caddr pr)))
     ((string=? (cadr pr) "REMOTE") (sh "lpr -P~a@~a ~a" (caddr pr) (cadddr pr) testps))
     ((string=? (cadr pr) "SMBPS") (smb-config pr) (sh "cat ~a | ~a" testps smbprint))
     (else (gs-print))))
      

  ;
  ;########## SMB config ##########
  ;
  (define (smb-config pr)
    '())

  ;
  ;########## save ##########
  ;
  (define (save)
    (let ((result (writeqc printerconf)))
      (if (equal? result 'done)
          (let ((files (set-files)))
            (cond
               ((not (equal? (mkprintcap printcap) 'done )) 'cannot-save)
               ((not (equal? (mkprintcap printcap) 'done ))  'cannot-save)
               ((not (equal? (save-filter files) 'done)) 'cannot-save)
               ((not (equal? (writefc filterconf) 'done)) 'cannot-save)
               (else (strip-filter init-files files)
                   (if (conf-make-md5sum object-name (cons  printcap files))
                       (if (or (conf-diff-ok? printcap mkprintcap)
                               (let loop ((t files))
                                 (if (null? t) #f
                                     (if (conf-diff-ok? (car t) (lambda (x) (mkfilter x (car t))))
                                         #t
                                         (loop (cdr t))))))
                           'ask-patch
                           'success)
                       'failed-md5sum))))
          result)))

  (define (set-files)
;list of filter' file name
    (map (lambda (x) (string-append filter-dir (car (extract-filter "FILTER" x)) ".gsfilter-ogl"))
         filters))

  ;
  ;########## commit ##########
  ;
  (define (commit)
    (let ((result (writeqc printerconf)))
      (if (equal? result 'done)
          (let ((files (set-files)))
            (if (and (equal? (mkprintcap printcap) 'done)
                     (equal? (save-filter files) 'done)
                     (equal? (writefc filterconf) 'done))
                (begin 
                  (strip-filter init-files files)
                  (conf-diff-commit printcap mkprintcap 1)
                  (map (lambda (x) (conf-diff-commit x (lambda (y) (mkfilter y x)) 1))
                       files)
                  (if (conf-make-md5sum object-name (cons  printcap files))
                      'success
                      'failed-md5sum))
                'cannot-save))
          result)))

  (define (save-filter targets)
    (if (null? targets) 'done
        (let ((r (mkfilter (car targets))))
          (if (equal? r 'done)
              (save-filter (cdr targets))
              r))))

  (define (strip-filter old new)
    (set! retain (list old new))
    (define dif '())
    (let loop ((f old))
      (cond
       ((null? f) dif)
       ((member (car f) new)
           (loop (cdr f)))
       (else (sh "rm ~a" (car f))
             (set! dif (cons (car f) dif))
             (loop (cdr f))))))

  ;
 ; ---------- mkprintcap ----------
; save printcap
  (define (mkprintcap out)
    (sh "echo -e '# This file was writen by ogl-print.\n# Do NOT edit.\n\n' > ~a" out)
    (printers->printcap printers out))

  (define (printers->printcap body out)
    (if (null? body) 'done
        (if (< (length (car body)) 2) #f
            (let ((r (cond
                      ((string=? (cadar body) "LOCAL")
                       (if (< (length (car body)) 3) 'wrong-printer
                           (begin (sh "echo -e '~a:' >> ~a" (caar body) out)
                                  (sh "echo -e '        :lp=/dev/~a' >> ~a" (caddar body) out)
                                  (sh "echo -e '        :sd=/var/spool/lpd/~a' >> ~a" (caddar body) out)
                                  )))
                      ((string=? (cadar body) "Non-PS")
                       (if (< (length (car body)) 3) 'wrong-printer
                           (begin (sh "echo -e '~a:' >> ~a" (caar body) out)
                                  (sh "echo -e '        :lp=/dev/~a' >> ~a" (caddar body) out)
                                  (sh "echo -e '        :sd=/var/spool/lpd/~a' >> ~a" (caddar body) out)
                                  (sh "echo -e '        :if=~a~a.gsfilter-ogl' >> ~a" filter-dir (caar body) out)
                                  )))
                      ((string=? (cadar body) "REMOTE")
                       (if (< (length (car body)) 4) 'wrong-printer
                           (begin (sh "echo -e '~a:' >> ~a" (caar body) out)
                                  (sh "echo -e '        :lp=~a@~a' >> ~a" (caddar body) (cadddr (car body)) out)
                                  (sh "echo -e '        :sd=/var/spool/lpd/remote' >> ~a" out)
                                  )))
                      ((string=? (cadar body) "SERVER")
                       (if (< (length (car body)) 4) 'wrong-printer
                           (begin (sh "echo -e '~a:' >> ~a" (caar body) out)
                                  (sh "echo -e '        :lpr_bounce' >> ~a" out)
                                  (sh "echo -e '        :lp=~a@~a' >> ~a" (caddar body) (cadddr (car body)) out)
                                  (sh "echo -e '        :sd=/var/spool/lpd/remote' >> ~a" out)
                                  (sh "echo -e '        :if=~a~a.gsfilter-ogl' >> ~a"  filter-dir (caar body) out)
                                  )))
                      ((string=? (cadar body) "SMBPS")
                       (if (< (length (car body)) 4) 'wrong-printer
                           (begin (sh "echo -e '~a:' >> ~a" (caar body) out)
                                  (sh "echo -e '        :sd=~a' >> ~a" smbspool out)
                                  (sh "echo -e '        :if=~a' >> ~a" smbprint out)
                                  )))
                      ((string=? (cadar body) "SMBN")
                       (if (< (length (car body)) 4) 'wrong-printer
                           (begin (sh "echo -e '~a:' >> ~a" (caar body) out)
                                  (sh "echo -e '        :sd=~a' >> ~a" smbspool out)
                                  (sh "echo -e '        :if=~a~a.gsfilter-ogl' >> ~a"  filter-dir (caar body) out)
                                  )))
                      )))
              (if (zero? r) (begin (sh "echo -e '        :mx#0' >> ~a" out)
                                   (sh "echo -e '        :sh\n' >> ~a" out)
                                   (printers->printcap (cdr body) out))
                  'wrong-printer)))))


  ;
 ;---------- writeqc ----------
; save printerconf
  (define (writeqc out)
    (if (zero? (sh "echo -e '# This is ogl-print configuration file.\n# Do NOT edit this file manually.\n\n' > ~a" out))
        (let loop ((l printers))
          (if (null? l) 'done
              (let ((ent (car l)))
                (if (printer? ent) 
                    (begin (cond
                            ((string=? (cadr ent) "LOCAL") (sh "echo -e '~a\t~a\t~a' >> ~a"
                                                               (car ent) (cadr ent) (caddr ent) out))
                            ((string=? (cadr ent) "Non-PS") (sh "echo -e '~a\t~a\t~a' >> ~a"
                                                                (car ent) (cadr ent) (caddr ent) out))
                            ((string=? (cadr ent) "REMOTE") (sh "echo -e '~a\t~a\t~a\t~a' >> ~a"
                                                                (car ent) (cadr ent) (caddr ent) (cadddr ent) out))
                            ((string=? (cadr ent) "SERVER") (sh "echo -e '~a\t~a\t~a\t~a' >> ~a"
                                                                (car ent) (cadr ent) (caddr ent) (cadddr ent) out))
                            ((string=? (cadr ent) "SMBPS") (sh "echo -e '~a\t~a\t~a\t~a' >> ~a"
                                                                (car ent) (cadr ent) (caddr ent) (cadddr ent) out))
                            ((string=? (cadr ent) "SMBN") (sh "echo -e '~a\t~a\t~a\t~a' >> ~a"
                                                             (car ent) (cadr ent) (caddr ent) (cadddr ent) out)))
                           (loop (cdr l)))
                    'wrong-printer))))
        'cannot-open))


  ;
 ;---------- writefc ----------
; save filterconf
  (define (writefc out)
    (if (zero? (sh "echo -e '# This is ogl-print configuration file.\n# Do NOT edit this file manually.\n\n' > ~a" out))
        (let loop ((l filters))
          (if (null? l) 'done
              (let ((f (car l)))
                (map (lambda (x) (if (null? (cdr x)) 0 (sh "echo -e '~a\t~a' >> ~a" 
                                                           (car x) (cadr x) out))) f)
                (sh "echo >> ~a" out)
                (loop (cdr l)))))
        'cannot-open))
  
  (define (file-name s)
    (if (substring? "/" s) 
        (file-name (substring s (+ (substring? "/" s) 1) (string-length s)))
        (substring s 0 (if (substring? ".gsfilter-ogl" s) (substring? ".gsfilter-ogl" s) (string-length s)))))

  (define (extract-filter key l)
    (if (string? key)
        (map (lambda (x) (if (null? (cdr x))  "" (cadr x)))  (if (assoc-all key l) (assoc-all key l) '((""))))
        '("")))

  (define (mkfilter out . file)
    ; save a filter
    ;------- write options (NOT "OPTION") ------
    (if (null? file) (set! file (list out)))
    (define (write-op ls)
      (if (null? ls) '()
          (cond
           ((string=? "FILTER" (caar ls)) (write-op (cdr ls)))
           ((string=? "DRIVER" (caar ls)) (write-op (cdr ls)))
           ((string=? "DESCRIPTION" (caar ls)) (write-op (cdr ls)))
           ((string=? "DETAIL" (caar ls)) (write-op (cdr ls)))
           ((string=? "TYPE" (caar ls)) (write-op (cdr ls)))
           ;((string=? "TIPS" (caar ls)) (write-op (cdr ls)))
           ((string=? "OPTION" (caar ls)) (write-op (cdr ls)))
           (else (begin
                   (if (not (null? (cdar ls)))
                       (sh "echo ' ~a~a \\' >> ~a" (caar ls) (cadar ls) out))
                   (write-op (cdr ls)))))))

    (let loop ((l filters))
      (if (null? l) 'no-file
          (let ((f (car l)))
            (if (string=? (car (extract-filter "FILTER" f)) (file-name (car file)))
                (let* ((type (car (extract-filter "TYPE" f)))
                       (link (substring? "link to:" type)))
                  (if (unix-access? out '())
                      (sh "rm ~a" out))
                  (cond
                   ((and link (zero? link))
                    (if (zero? (sh "ln -sf ~a ~a" (substring type 8 (string-length type)) out))
                        'done
                        'cannot-open))
                   ((and link (= link 3) (string=? "smb" (substring type 0 3)))
                     (if (zero? (sh "echo '#!/bin/sh' > ~a" out))
                         (begin
                           (unix-chmod out 493)
                           (sh "echo -e '# OGL-PRINT created and control this file.\n# Do NOT edit.\n' >> ~a" out)
                           (sh "echo -e 'cat - | ~a | ~a' >> ~a"
                               (substring type 11 (string-length type))
                               smbprint
                               out)
                           'done)
                         'cannot-open))
                   ((or (string=? type "normal") (string=? type "smb"))
                    (let ((o (extract-filter "OPTION" f)))
                      (if (zero? (sh "echo '#!/bin/sh' > ~a" out))
                          (begin
                            (unix-chmod out 493)
                            (sh "echo -e '# OGL-PRINT created and control this file.\n# Do NOT edit.\n' >> ~a" out)
                            (sh "echo 'tmpf=`tempfile`' >> ~a" out)
                            (sh "echo 'LANG=ja_JP.ujis gs -q -dSAFER -dNOPAUSE -sDEVICE=~a  \\' >> ~a"
                                (car (extract-filter "DRIVER" f)) out)
                            (write-op f)
                            (let mkoption ((option o))
                              (if (null? option) '()
                                  (begin (if (not (string=? (car option) ""))
                                             (sh  "echo ' ~a \\' >> ~a" (car option) out))
                                         (mkoption (cdr option)))))
                            (sh "echo ' -sOutputFile=$tmpf - -c quit 2>&1 | logger -t '\"'gs'\" >> ~a" out)
                            (if (string=? type "smb")
                                (sh "echo -e 'cat $tmpf | ~a\nrm $tmpf' >> ~a" smbprint out)
                                (sh "echo -e 'cat $tmpf\nrm $tmpf' >> ~a" out))
                            'done)
                          'cannot-open)))
                   (else 'unknown-type)))
                (loop (cdr l)))))))


  ;########## clean ##########
  ;---------- delete patch file ----------
  ;
  (define (clean . files)
    (if (null? files) 
        (map conf-diff-clean (cons printcap init-files))
        (map (lambda (x) (sh "rm ~a" x)) files)))

  (make-object
   'set-context    set-context
   'load           load  
   'filter         inquiry-filter
   'printer        inquiry-printer
   'driver         inquiry-driver
   'delete         delete-printer
   'preplace       (lambda (k n) (set! printers (replace k n printers)))
   'filter-rename    (lambda (k n) (set! filters 
                                       (replace (list "FILTER" k) 
                                                (replace "FILTER" (list "FILTER" n)  (car (inquiry-filter k)))
                                                filters)))
   'freplace       (lambda (k n) (set! filters (replace (list "FILTER" k) n filters)))
   'save           save
   'commit         commit
   'clean          clean
   'fdelete        delete-filter
   'pdelete        delete-printer
   'padd           (lambda (x) (set! printers (append printers (list x))))
   'fadd           (lambda (x) (set! filters (append filters (list x))))
   'driver-index   (lambda () (driver-index drivers))
   'init-filter    (lambda () init-files)
   'current-filter (lambda () (set-files))
   'lpd?           lpd?
   'test-print     test-print
   'strip          strip-filter
   'restart        lprng-restart
   ))
