;
;		A object maker
;                                        (C)2002 Omoikane Inc.
;

;  $B%3%s%F%-%9%H$N%7%s%\%k%A%'%C%/(B
;
(define (obj-context-valid? c)
  (set-include? c '(inst1 inst2 inst3 recovery admin alone)))

(define obj-debug #t)

;
;  object $B$N:n@.(B
;
(define (make-object . key-proc)
  (define (filter m x)
    (case m
      ((set-passwd get-passwd passwd adduser sinfo)
        (format #f "~a *****" m))
      (else
        (format #f "~s ~s" m x))))
  
  (lambda (msg . param)
    (cond
      ((null? key-proc) #f)
      ((eq? msg 'destroy)
        (set! key-proc '())
        #t)
      ((eq? msg 'method?)
        (cond
          ((not (= 1 (length param)))
            #f)
          (else
            (let rep ((L key-proc))
              (cond
                ((null? L)
                  #f)
                ((eqv? (car param) (car L))
                  #t)
                (else
                  (rep (cddr L))))))))
      (else
        (let rep ((L key-proc))
          (cond
            ((null? L)
              (error 'make-object "no match method ~a" msg))
            ((eqv? msg (car L))
              (if obj-debug
                (inst-log "method call : ~a\n" (filter msg param)))
              (let ((r (apply (cadr L) param)))
                (if obj-debug
                  (inst-log "method ret  : ~a\n" (filter msg r)))
                r))
            (else
              (rep (cddr L)))))))))

