#!/bin/sh
string=?;exec /usr/bin/scheme-elk -c -l $0 -p /usr/lib/ogl/scm:/usr/lib/elk/scm $* 2>/dev/null
(load "debug.scm")
(load "util.scm")
(load "obj.scm")
(load "newt1.scm")
(load "snewt.scm")
(load "newt2.scm")
(load "newt3.scm")
(load "mod.scm")
(load "net.scm")
(load "media.scm")
(load "time.scm")
(load "conffile.scm")
(load "keyboard.scm")
(load "xwin.scm")
(load "boot.scm")
(load "gtk-middle.scm")
(load "gtk-obj.scm")
(load "gtk.scm")
(load "part.scm")
(load "gtk3.scm")
(load "account.scm")
(load "service.scm")
(load "volume.scm")
(load "fdisk.scm")
(load "autopart.scm")
(load "patch.scm")
(load "ideconf.scm")
(load "na.scm")
(load "profile.scm")
(load "dirsv.scm")
(load "print.scm")
(load "prod.scm")
(load "orca.scm")
(load "add.scm")
(load "jobq.scm")
(load "cron.scm")

(set! sh-log "logger")
(set! inst-log-context 'admin)
(unix-setenv "PATH" (string-append "/usr/sbin/ogl:" (unix-getenv "PATH")))

(define obj-jq (conf-jobq))

(define obj-cur (lambda l (format #t "Not set\n")))
(define obj-p (lambda l (format #t "Not set\n")))

(define ogl-admin-debug? #f)
(define ogl-admin-keyword 'all)

(define (admin-gtk)
  (define orca-conf-session? #f)
  (define (run-console p m)
    (let ((ll (sgtk-label-new (_ "Executing console version ..."))))
      (sgtk-paned-pack2 p ll #t #f)
      (sgtk-widget-show-all p)
      (sgtk-update)(sgtk-update)
      (let ((cmd (format #f "~agnome-terminal -e sh -c 'DISPLAY= ogl-admin ~a'"
                         (if (lang-ja?) "LANG=ja_JP.eucJP " "")
                         m)))
        (inst-log "ogl-admin exec : ~s\n" cmd)
        (sh cmd))
      (sgtk-container-remove p ll)
      (sgtk-update)(sgtk-update)))
  
  (define (loop p tr)
    (let ((ll (sgtk-label-normalized-new
                (string-append
                  (_ "Select configuration item from side menu.\n")
                  (_ "A menu starging with '[*]' will launch console version. ")
                  (if (arma-check)
                    ""
                    (_ "\ninactive items can be configured only with ARMA version.\n"))
                  )))
          (a (sgtk-alignment-new 0 0 0.8 0.8))
          (bb (sgtk-bbox #t (sgnome-stock-button "Button_Close")))
          (v1 (sgtk-vbox-new #f 10)))
      (sgtk-container-add a ll)
      (sgtk-container-add-many v1 a)
      (sgtk-box-pack-start v1 (bb 'widget) #f #f 0)
      (sgtk-paned-pack2 p v1 #t #f)
      (sgtk-widget-set-sensitive (tr 'widget) #t)
      (sgtk-widget-show-all v1)
      (sgtk-main)
      (sgtk-container-remove p v1)
      (sgtk-widget-set-sensitive (tr 'widget) #f)
      
      (inst-log "tr : ~a\n" (tr 'info))
      
      ;  arma check 
      (let ((r (tr 'info)))
        (cond
          ((null? r) 
            (exit 0))
          (else
            (case (caar r)
              ((0)
                (case (cadr (car r))
                  ((0)
                    (let ((obj-acc (configure-acc)))
                      (gtk-ui-root-password p obj-acc)))
                  ((1)
                    (let ((obj-acc (configure-acc)))
                      (gtk-ui-adduser p obj-acc)))
                  ((2)
                    (let* ((obj-sv (configure-service))
                           (obj-ds (conf-dirsv obj-sv))
                           (patcher (conf-patch obj-ds)))
                      (and (conf-gtk-load/confirm p patcher)
                           (gtk-ui-ldap p obj-ds)
                           (conf-gtk-finish p patcher))))
                  ((3)
                    (let* ((obj-sv (configure-service))
                           (obj-ds (conf-dirsv obj-sv))
                           (patcher (conf-patch obj-ds)))
                      (and (conf-gtk-load/confirm p patcher)
                           (gtk-ui-nis p obj-ds)
                           (conf-gtk-finish p patcher))))))
              ((1) (run-console p "na"))
              ((2) (run-console p "kbd"))
              ((3) (run-console p "driver"))
              ((4) (run-console p "net"))
              
              ((5)
                (let* ((obj-part (configure-part "/mnt/tmp"))
                       (patcher (conf-patch obj-part)))
                  (obj-part 'init 'admin)
                  (set! obj-cur obj-part)
                  (and (conf-gtk-load/confirm p patcher)
                       (gtk-ui-part p obj-part 'xfs (if ogl-admin-debug? #t #f))
                       (conf-gtk-finish p patcher))))
              ((6)
                (case (cadr (car r))
                  ((0)
                    (let ((obj-time (configure-time)))
                          (obj-time 'init 'admin)
                      (and (gtk-ui-timezone p obj-time)
                           (obj-time 'commit-tz))))
                  ((1)
                    (let ((obj-time (configure-time)))
                          (obj-time 'init 'admin)
                      (and (gtk-ui-hwclock p obj-time)
                           (obj-time 'commit-hwclock))))))
              ((7)
                (case (cadr (car r))
                  ((0)
                    (let* ((obj-mod (configure-module))
                           (obj-part (configure-part "/mnt/tmp"))
                           (obj-boot (configure-boot obj-part obj-mod))
                           (patcher (conf-patch obj-boot)))
                        (obj-mod 'init 'admin)
                        (obj-mod 'load)
                        (obj-part 'init 'admin)
                        (obj-part 'load)
                        (obj-boot 'init 'admin)
                        (and (conf-gtk-load/confirm p patcher)
                             (gtk-ui-install-br p obj-boot obj-part #f)
                             (conf-gtk-finish p patcher))))
                  ((1)
                    (let* ((obj-mod (configure-module))
                           (obj-part (configure-part "/mnt/tmp"))
                           (obj-boot (configure-boot obj-part obj-mod))
                           (patcher (conf-patch obj-boot)))
                        (obj-mod 'init 'admin)
                        (obj-mod 'load)
                        (obj-part 'init 'admin)
                        (obj-part 'load)
                        (obj-boot 'init 'admin)
                        (and (conf-gtk-load/confirm p patcher)
                             (gtk-ui-recover-mbr p obj-boot obj-part)
                             (conf-gtk-finish p patcher))))
                  ((2)
                    (let* ((obj-mod (configure-module))
                           (obj-part (configure-part "/mnt/tmp"))
                           (obj-boot (configure-boot obj-part obj-mod))
                           (patcher (conf-patch obj-boot)))
                        (obj-mod 'init 'admin)
                        (obj-mod 'load)
                        (obj-part 'init 'admin)
                        (obj-part 'load)
                        (obj-boot 'init 'admin)
                        (and (conf-gtk-load/confirm p patcher)
                             (gtk-ui-bootfd p #f obj-boot obj-part)
                             (conf-gtk-finish p patcher))))
                  ((4)
                    (let* ((obj-part (configure-part "/mnt/tmp"))
                           (patcher (conf-patch obj-part)))
                        (obj-part 'init 'admin)
                        (and (conf-gtk-load/confirm p patcher)
                             (gtk-ui-bios-order p obj-part)
                             (conf-gtk-finish p patcher))))
                  (else
                    (inst-log "illegal response from tree object : ~a\n" r)
                    #f)))
              
              ((8)
                (let* ((obj-part (configure-part "/mnt/tmp"))
                       (obj-ide (conf-ide obj-part))
                       (patcher (conf-patch obj-ide)))
                  (obj-part 'init 'admin)
                  (obj-ide 'init 'admin)
                  (set! obj-cur obj-ide)
                  (and (conf-gtk-load/confirm p patcher)
                       (gtk-ui-ide p obj-ide obj-part)
                       (conf-gtk-finish p patcher))))
              
              ((9)
                (let* ((obj-add (conf-additional)))
                  (gtk-ui-additional p #f obj-add)))
              
              ((10)
                (let* ((obj-mod (configure-module))
                       (obj-vol (conf-vol))
                       (patcher0 (conf-patch obj-mod))
                       (patcher1 (conf-patch obj-vol)))
                  (sgtk-show-while-new (_ "Loading")
                    (_ "Loading configuration files ...")
                    (lambda () (obj-mod 'init 'admin)))
                  (and (conf-gtk-load/confirm p patcher0)
                       (gtk-module-sound p obj-mod)
                       (obj-vol 'init 'admin)
                       (conf-gtk-load/confirm p patcher1)
                       (gtk-ui-volume p obj-vol)
                       (conf-gtk-finish p patcher0)
                       (conf-gtk-finish p patcher1))))
              
              ((11)
                (gtk-ui-service p (configure-service)))

              ((12) (run-console p "media"))
              
              ((13) (run-console p "printer"))
              
              ((14) (run-console p "sup"))
              
              ((15)
                (let* ((obj-net (configure-network))
                       (obj-sv (configure-service))
                       (obj-pd (conf-prod obj-net obj-sv))
                       (patch-pd (conf-patch obj-pd))
                       (obj-prof (conf-prof))
                       (patch-prof (conf-patch obj-prof))
                       (obj-cr (conf-cron obj-sv))
                       (patch-cron (conf-patch obj-cr)))
                  (set! obj-cur obj-pd)
                  (obj-pd 'load)
                  (let ((t (obj-pd 'get-orcatype)))
                    (and (conf-gtk-load/confirm p patch-pd)
                         (conf-gtk-load/confirm p patch-prof)
                         (conf-gtk-load/confirm p patch-cron)
                         (case t
                           ((unset)
                             (and (gtk-ui-orca-type p obj-pd patch-pd obj-prof obj-cr)
                                  (if (< (obj-pd 'get-initstep) 100)
                                      #f
                                      (begin (set! orca-conf-session? #t) #t))))
                           (else
                             (cond
                               ((< (obj-pd 'get-initstep) 100)
                                 (and (case t
                                        ((unset)
                                          (gtk-ui-orca-type p obj-pd patch-pd obj-prof obj-cr))
                                        ((primary)
                                          (gtk-ui-orca-type-primary p obj-pd patch-pd obj-cr))
                                        ((secondary)
                                          (gtk-ui-orca-type-secondary p obj-pd patch-pd))
                                        ((single)
                                          (gtk-ui-orca-type-single p obj-pd patch-pd))
                                        ((client)
                                          (gtk-ui-orca-type-client p obj-pd))
                                        (else
                                          #f))
                                      (if (< (obj-pd 'get-initstep) 100)
                                        #f
                                        (begin (set! orca-conf-session? #t) #t))))
                               (orca-conf-session?
                                 (sgtk-message-info
                                   (_ "ORCA has been configured. In order to configure ORCA, please restart ogl-admin again."))
                                 #f)
                               (else
                                 (let ((sub (cadr (car r))))
                                   (case t
                                     ((primary)
                                       (case sub
                                         ((0) (gtk-ui-orca-server p obj-pd patch-pd))
                                         ((1) (gtk-ui-orca-primary-host p #f obj-pd patch-pd))
                                         ((2) (gtk-ui-orca-master p obj-pd))
                                         ((3) (gtk-ui-orca-acc p obj-pd))
                                         ((4) (gtk-ui-orca-hospid p obj-pd))
                                         ((5) (gtk-ui-orca-recover-secondary p obj-pd))
                                         ((6) (gtk-ui-orca-schedule p obj-pd obj-cr))
                                         ((7) (gtk-ui-orca-recover-primary p obj-pd))
                                         (else #f)))
                                     ((secondary)
                                       (and (gtk-ui-orca-secondary-recover-check obj-pd)
                                         (case sub
                                           ((0) (gtk-ui-orca-server p obj-pd patch-pd))
                                           ((1) (gtk-ui-orca-secondary-host p #f obj-pd patch-pd))
                                           ((2) (gtk-ui-orca-master p obj-pd))
                                           ((3) (gtk-ui-orca-acc p obj-pd))
                                           (else #f))))
                                     ((single)
                                       (case sub
                                         ((0) (gtk-ui-orca-server p obj-pd patch-pd))
                                         ((1) (gtk-ui-orca-master p obj-pd))
                                         ((2) (gtk-ui-orca-acc p obj-pd))
                                         ((3) (gtk-ui-orca-hospid p obj-pd))
                                         (else #f)))
                                     ((client)
                                       (case sub
                                         ((0) (gtk-ui-orca-host p obj-pd patch-pd))
                                         (else #f)))
                                     (else
                                       #f)))))))
                        (conf-gtk-finish p patch-pd)
                        (conf-gtk-finish p patch-prof)
                        (conf-gtk-finish p patch-cron)))))
              
              (else
                (inst-log "illegal response from tree object : ~a\n" r)
                (exit 0))))))
      (tr 'clear)
      (loop p tr)))
  
  (sgtk-start)
  (textdomain "ogl-admin" "/usr/share/locale")
  (let* ((obj-net (configure-network))
         (obj-sv (configure-service))
         (obj-part (configure-part "/mnt/tmp"))
         (obj-pd (conf-prod obj-net obj-sv)))
    (obj-part 'init 'admin)
    (obj-part 'load)
    (obj-pd 'load)
    (let* ((w (sgtk-window-new-toplevel))
           (p (sgtk-hpaned-new))
           (f (sgtk-frame-new (_ "Configuration Menu")))
           (v0 (sgtk-vbox-new #f 10))
           (b-acc (sgtk-label-new (_ "Account Setting")))
           (b-ldap (sgtk-label-new (_ "LDAP client setting")))
           (b-nis (sgtk-label-new (_ "NIS client setting")))
           (b-root (sgtk-label-new (_ "Root Password")))
           (b-adduser (sgtk-label-new (_ "User Creation")))
           (b-na (sgtk-label-new (string-append (_ "[*]") (_ "ARMA Net Account"))))
           (b-kbd (sgtk-label-new (string-append (_ "[*]") (_ "Keyboard Setting"))))
           (b-driver (sgtk-label-new (string-append (_ "[*]") (_ "Driver Setting"))))
           (b-net (sgtk-label-new (string-append (_ "[*]") (_ "Network Setting"))))
           (b-part (sgtk-label-new (_ "Partition Setting")))
           (b-time (sgtk-label-new (_ "Time Setting")))
           (b-tztime (sgtk-label-new (_ "Timezone")))
           (b-hwclock (sgtk-label-new (_ "Hardware Clock")))
           (b-boot (sgtk-label-new (_ "Boot loader Setting")))
           (b-boot-inst (sgtk-label-new (_ "GRUB installation")))
           (b-boot-recv (sgtk-label-new (_ "Boot Record Recovery")))
           (b-boot-bootfd (sgtk-label-new (_ "Boot FD")))
           (b-boot-entry (sgtk-label-new (_ "Boot Entry")))
           (b-boot-bios (sgtk-label-new (_ "BIOS order")))
           (b-ide (sgtk-label-new (_ "IDE (HDD optimization)")))
           (b-add (sgtk-label-new (_ "Additional Package")))
           (b-sound (sgtk-label-new (_ "Sound Setting")))
           (b-sv (sgtk-label-new (_ "Service Setting")))
           (b-media (sgtk-label-new (string-append (_ "[*]") (_ "Package Source"))))
           (b-printer (sgtk-label-new (string-append (_ "[*]") (_ "Printer Setting"))))
           (b-support (sgtk-label-new (string-append (_ "[*]") (_ "Remote Maintenance"))))
           (b-orca (sgtk-label-new (_ "ORCA Configuration")))
           (b-orca-0 (sgtk-label-new (_ "Server Status Setting")))
           (b-orca-1p (sgtk-label-new (_ "Secondary Server Address")))
           (b-orca-1s (sgtk-label-new (_ "Primary Server Address")))
           (b-orca-1c (sgtk-label-new (_ "Server Address")))
           (b-orca-2 (sgtk-label-new (_ "Master Password Setting")))
           (b-orca-3 (sgtk-label-new (_ "Operator Account Setting")))
           (b-orca-4 (sgtk-label-new (_ "Hospital ID Setting")))
           (b-orca-5 (sgtk-label-new (_ "Secondary Server Data Recovery")))
           (b-orca-6 (sgtk-label-new (_ "Data Refresh Schedule")))
           (b-orca-7 (sgtk-label-new (_ "Primary Server Data Recovery")))
           (tr (make-simple-tree #t #t
                 (append
                   (list (list (list b-acc #f) (list b-root #f) (list b-adduser #f)
                               (list b-ldap #f) (list b-nis #f))
                         (list b-na #f)
                         (list b-kbd #f)
                         (list b-driver #f)
                         (list b-net #f)
                         (list b-part #f)
                         (list (list b-time #f) (list b-tztime #f) (list b-hwclock #f))
                         (append
                           (list (list b-boot #f))
                           (list (list b-boot-inst #f) (list b-boot-recv #f)
                                 (list b-boot-bootfd #f))
                                 ;(list b-boot-entry #f)
                           (if (< (length (obj-part 'hw-get-biosorder)) 2)
                               '()
                               (list (list b-boot-bios #f))))
                         (list b-ide #f)
                         (list b-add #f)
                         (list b-sound #f)
                         (list b-sv #f)
                         (list b-media #f)
                         (list b-printer #f)
                         (list b-support #f))
                   (if (equal? 'orca (obj-pd 'product-type))
                     (if (< (obj-pd 'get-initstep) 100)
                       (list (list b-orca #f))
                       (list
                         (case (obj-pd 'get-orcatype)
                           ((primary)
                             (list (list b-orca #f) (list b-orca-0 #f) (list b-orca-1p #f) (list b-orca-2 #f)
                                   (list b-orca-3 #f) (list b-orca-4 #f) (list b-orca-5 #f) (list b-orca-6 #f)
                                   (list b-orca-7 #f)))
                           ((secondary)
                             (list (list b-orca #f) (list b-orca-0 #f) (list b-orca-1s #f) (list b-orca-2 #f)
                                   (list b-orca-3 #f)))
                           ((single)
                             (list (list b-orca #f) (list b-orca-0 #f) (list b-orca-2 #f) (list b-orca-3 #f)
                                   (list b-orca-4 #f)))
                           ((client)
                             (list (list b-orca #f) (list b-orca-1c #f))))))
                     '()))))
           (asking-to-abort #f))
      ; main window
      (sgtk-oglt-mainpanel w (_ "ARMA/OGL System Management Tool") f p)
      (sgtk-signal-connect w "delete_event"
        (lambda (w e)
          (cond
            (asking-to-abort
              #f)
            (else
              (set! asking-to-abort #t)
              (sgtk-widget-set-sensitive w #f)
              (let ((new (sgtk-window-new-toplevel-named (_ "Confirm")))
                    (v (sgtk-vbox-new #f 10))
                    (l (sgtk-label-new (_ "Are you ok to abort configuration tool?")))
                    (bb (sgtk-ok/cancel #t)))
                (sgtk-container-add-many v l (bb 'widget))
                (sgtk-container-add new v)
                ;(sgtk-box-pack-start v l #t #f 10)
                ;(sgtk-box-pack-start v (bb 'widget) #t #f 10)
                ;(sgtk-box-pack-start new v #t #f 10)
                (sgtk-widget-show-all new)
                (sgtk-main)
                (sgtk-widget-destroy new)
                (inst-log "info : ~a\n" (bb 'info))
                (set! asking-to-abort #f)
                (cond
                  ((equal? (bb 'info) 'forward)
                    (exit 1))
                  (else
                    (sgtk-widget-set-sensitive w #t))))))))
      
      (sgtk-container-add-many f v0)
      (sgtk-box-pack-start v0 b-root #t #t 0)
      (sgtk-box-pack-start v0 (tr 'widget) #t #t 0)
      (sgtk-widget-show-all f)
      (sgtk-widget-show-all w)
      (tr 'expand)
      (loop p tr))))


(define (make-menu-newt)
  (let* ((obj-net (configure-network))
         (obj-sv (configure-service))
         (obj-part (configure-part "/mnt/tmp"))
         (obj-pd (conf-prod obj-net obj-sv)))
    (obj-part 'init 'admin)
    (obj-part 'load)
    (obj-pd 'load)
    (cond
      ((arma-check)
        (append
          (list (_ "Root Password") (_ "User Account Setting")
                (_ "ARMA Net Account")
                (_ "Keyboard Setting") (_ "Driver Setting")
                (_ "Network Setting")
                (_ "X Window Setting") (_ "Partition Setting")
                (_ "Time Setting") (_ "Boot loader Setting")
                (_ "Service Setting") (_ "Sound Setting")
                (_ "IDE setting (HDD optimization)")
                (_ "Package Source Setting")
                (_ "Additional Package Installation")
                (_ "Printer Setting")
                (_ "Remote Maintenance Mode"))
          (if (equal? 'orca (obj-pd 'product-type))
            (list (_ "ORCA Configuration"))
            '())))
      (else
        (list (_ "Root Password") (_ "User Account Setting")
              (_ "Keyboard Setting") (_ "Driver Setting")
              (_ "Network Setting")
              (_ "X Window Setting") (_ "Partition Setting")
              (_ "*Time Setting*") (_ "Boot loader Setting")
              (_ "*Service Setting*") (_ "*Sound Setting*")
              (_ "*IDE setting (HDD optimization)*")
              (_ "Package Source Setting")
              (_ "Additional Package Installation")
              (_ "*Printer Setting*")
              (_ "*Remote Maintenance Mode*"))))))

(define (admin-newt)
  (define (alert-md5sum ld-state . conflist)
    (cond
     ((equal? ld-state 'md5sum)
        (if (= 1 (snewt-choice  (_  "Confirmation") 
                              (string-append
                               (cond
                                 ((null? conflist)
                                    "Configuretion file")
                                 ((null? (cdr conflist))
                                    (car conflist))
                                 (else
                                    (string-append
                                      (apply string-append
                                           (map (lambda (x) (string-append x ", "))
                                                (reverse (cdr (reverse conflist)))))
                                      (car (last-pair conflist)))))
                               (_ " has been modified.\n")
                               (_ "Would you like to continue?\n")
                               (_ "Some modifications via the other tools or editors\n")
                               (_ "may be omitted\n")) 
                              (_ "Continue") (_ "Abort")))
            #t #f))
     ((equal? ld-state 'success) #t)
     (else ld-state)))
  (textdomain "ogl-admin" "/usr/share/locale")
  (newt-stage-title "OGL Admin")
  (let* ((l (make-menu-newt))
         (title-acc (_ "User Account Setting"))
         (title-na (_ "ARMA Net Account"))
         (title-driver (_ "Driver Setting"))
         (title-kbd (_ "Keyboard Setting"))
         (title-sound (_ "Sound Setting"))
         (title-net (_ "Network Setting"))
         (title-x (_ "X Window Setting"))
         (title-part (_ "Partition Setting"))
         (title-ide (_ "IDE setting (HDD optimization)"))
         (title-boot (_ "Boot loader Setting"))
         (title-media (_ "Package Source Setting"))
         (title-add (_ "Additional Package Installation"))
         (title-printer (_ "Printer Setting"))
         (title-orca (_ "ORCA Configuration"))
         (title-support (_ "Remote Maintenance Mode"))
         (r' (case ogl-admin-keyword
               ((netacc na) title-na)
               ((driver) title-driver)
               ((kbd) title-kbd)
               ((sound) title-sound)
               ((net) title-net)
               ((x) title-x)
               ((part) title-part)
               ((ide) title-ide)
               ((boot) title-boot)
               ((media) title-media)
               ((add) title-add)
               ((printer) title-printer)
               ((sup) title-support)
               (else #f)))
         (r (if (eq? r' #f)
                (snewt-nmenu (_ "Admin Mode") 
                             (string-append
                               (_ "Select admin menu below.\n")
                               (if (arma-check)
                                   ""
                                   (_ "(term enclosed with * can be configured only with ARMA version.)\n")))
                             50 5 5 9
                             (list->vector l)
                             (vector (_ "Exit")))
                (cons 0 0))))
    (case (car r)
      ((-1) #f)
      ((1) #t)
      (else
        (let ((x (if (eq? r' #f)
                   (list-ref l (cdr r))
                   r')))
          (cond
            ((equal? x (_ "Root Password"))
              (let ((obj-acc (configure-acc)))
                (newt-ui-root-pass obj-acc)))
                
            ((equal? x title-acc)
              (let* ((obj-acc (configure-acc))
                     (obj-sv (configure-service))
                     (obj-ds (conf-dirsv obj-sv))
                     (patcher (conf-patch obj-ds)))
                (set! obj-cur obj-ds)
                (set! obj-p patcher)
                (and (conf-newt-load/confirm patcher title-acc)
                     (newt-ui-user-account obj-ds obj-acc)
                     (conf-newt-finish patcher title-acc))))
            
            ((equal? x title-na)
              (let* ((obj-net (configure-network))
                     (obj-part (configure-part "/mnt/tmp"))
                     (obj-prof (conf-prof))
                     (obj-med (conf-media obj-net obj-part obj-prof))
                     (patcher2 (conf-patch obj-med))
                     (obj-na (conf-na))
                     (patcher3 (conf-patch obj-na)))
                (set! obj-cur obj-na)
                (set! obj-p patcher3)
                (obj-part 'init 'admin)
                (obj-med 'init 'admin)
                (obj-prof 'load)
                (obj-na 'load)
                (and (conf-newt-load/confirm patcher2 title-na)
                     (conf-newt-load/confirm patcher3 title-na)
                     (newt-ui-na #f obj-na obj-med)
                     (conf-newt-finish patcher2 title-na)
                     (conf-newt-finish patcher3 title-na))))
            
            ((equal? x title-driver)
              (let* ((obj-part (configure-part "/mnt/tmp"))
                     (obj-mod (configure-module))
                     (patcher (conf-patch obj-mod)))
                (set! obj-cur obj-mod)
                (set! obj-p patcher)
                (obj-part 'init 'admin)
                (obj-mod 'init 'admin)
                (and (conf-newt-load/confirm patcher title-driver)
                     (newt-module-select obj-mod)
                     (newt-module-sound obj-mod)
                     (newt-ui-auto-probe obj-part obj-mod)
                     (newt-ui-more-driver obj-part obj-mod)
                     (conf-newt-finish patcher title-driver))))
            
            ((string=? x title-kbd)
              (let ((obj-kbd (configure-keyboard)))
                (obj-kbd 'init 'admin)
                (obj-kbd 'load)
                (let* ((obj-mod (configure-module))
                       (obj-x (configure-x (obj-kbd 'get-type) obj-mod))
                       (patcher (conf-patch obj-x)))
                  (obj-mod 'init 'admin)
                  (obj-x 'init 'admin)
                  (and (conf-newt-load/confirm patcher title-kbd)
                       (newt-ui-kbd #f obj-kbd obj-x)
                       (obj-kbd 'commit)
                       (conf-newt-finish patcher title-kbd)))))
            
            ((string=? x title-net)
              (let* ((obj-net (configure-network))
                     (patcher (conf-patch obj-net)))
                (set! obj-cur obj-net)
                (set! obj-p patcher)
                (obj-net 'init 'admin)
                (obj-net 'load)
                (and (conf-newt-load/confirm patcher title-net)
                     (newt-ui-net #f obj-net)
                     (conf-newt-finish patcher title-net))))
            
            ((string=? x title-x)
              (let ((obj-kbd (configure-keyboard)))
                (obj-kbd 'init 'admin)
                (obj-kbd 'load)
                (let* ((obj-mod (configure-module))
                       (patcher0 (conf-patch obj-mod))
                       (obj-x (configure-x (obj-kbd 'get-type) obj-mod))
                       (patcher1 (conf-patch obj-x)))
                  (set! obj-cur obj-x)
                  (set! obj-p patcher1)
                  (snewt-show-while title-x
                    (_ "Loading configuration files ...") 54 3
                    (lambda ()
                      (obj-mod 'init 'admin)
                      (obj-x 'init 'admin)))
                  (and (conf-newt-load/confirm patcher0 title-x)
                       (conf-newt-load/confirm patcher1 title-x)
                       (newt-ui-x obj-x "/usr/sbin/ogl/xtest")
                       (conf-newt-finish patcher0 title-x)
                       (conf-newt-finish patcher1 title-x)
                       (newt-ui-kdm (configure-service) obj-jq)))))
            
            ((string=? x title-part)
              (let* ((obj-part (configure-part "/mnt/tmp"))
                     (patcher (conf-patch obj-part)))
                (set! obj-cur obj-part)
                (obj-part 'init 'admin)
                (and (conf-newt-load/confirm patcher title-part)
                     (newt-ui-part obj-part 'linux-xfs (if ogl-admin-debug? #t #f))
                     (conf-newt-finish patcher title-part))))
            
            ((equal? x (_ "Time Setting"))
              (let ((obj-time (configure-time)))
                (set! obj-cur obj-time)
                (newt-ui-time obj-time)
                (obj-time 'commit-tz)
                (obj-time 'commit-hwclock)))
            
            ((string=? x title-boot)
              (let* ((obj-mod (configure-module))
                     (obj-part (configure-part "/mnt/tmp"))
                     (obj-boot (configure-boot obj-part obj-mod))
                     (patcher (conf-patch obj-boot)))
                (snewt-show-while title-boot
                  (_ "Loading configuration files ...") 54 3
                  (lambda ()
                    (obj-mod 'init 'admin)
                    (obj-mod 'load)
                    (obj-part 'init 'admin)
                    (obj-part 'load)
                    (obj-boot 'init 'admin)
                    (obj-boot 'load)
                    (set! obj-cur obj-boot)
                    (set! obj-p patcher)))
                (and (conf-newt-load/confirm patcher title-boot)
                     (newt-boot obj-boot obj-part)
                     (conf-newt-finish patcher title-boot))))
            
            ((string=? x title-ide)
              (let* ((obj-part (configure-part "/mnt/tmp"))
                     (obj-ide (conf-ide obj-part))
                     (patcher (conf-patch obj-ide)))
                (obj-part 'init 'admin)
                (obj-ide 'init 'admin)
                (set! obj-cur obj-ide)
                (and (conf-newt-load/confirm patcher title-ide)
                     (newt-ui-ide obj-ide obj-part)
                     (conf-newt-finish patcher title-ide))))
            
            ((equal? x (_ "Service Setting"))
              (let ((obj-sv (configure-service)))
                (set! obj-cur obj-sv)
                (newt-ui-service obj-sv)))
            
            ((string=? x title-sound)
              (let* ((obj-mod (configure-module))
                     (obj-vol (conf-vol))
                     (patcher0 (conf-patch obj-mod))
                     (patcher1 (conf-patch obj-vol)))
                (set! obj-cur obj-vol)
                (set! obj-p patcher1)
                (obj-mod 'init 'admin)
                (and (conf-newt-load/confirm patcher0 title-sound)
                     (newt-module-sound obj-mod)
                     (obj-vol 'init 'admin)
                     (conf-newt-load/confirm patcher1 title-sound)
                     (newt-ui-volume obj-vol)
                     (conf-newt-finish patcher0 title-sound)
                     (conf-newt-finish patcher1 title-sound))))
            
            ((string=? x title-media)
              (let* ((obj-net (configure-network))
                     (obj-part (configure-part "/mnt/tmp"))
                     (patcher0 (conf-patch obj-part))
                     (obj-prof (conf-prof))
                     (patcher1 (conf-patch obj-prof))
                     (obj-med (conf-media obj-net obj-part obj-prof))
                     (patcher2 (conf-patch obj-med))
                     (obj-na (conf-na)))
                (set! obj-cur obj-med)
                (set! obj-p patcher1)
                ;(obj-net 'init 'admin)
                (obj-part 'init 'admin)
                (obj-med 'init 'admin)
                (obj-prof 'load)
                (obj-na 'load)
                (and ;(obj-net 'load)
                     (conf-newt-load/confirm patcher0 title-media)
                     (conf-newt-load/confirm patcher1 title-media)
                     (conf-newt-load/confirm patcher2 title-media)
                     (newt-ui-media obj-med obj-part obj-na)
                     (begin (inst-log "mountp:~a\n" (obj-part 'list-mnt)) #t)
                     (conf-newt-finish patcher0 title-media)
                     (conf-newt-finish patcher1 title-media)
                     (conf-newt-finish patcher2 title-media))))
            
            ((string=? x title-add)
              (let ((obj-add (conf-additional)))
                (set! obj-cur obj-add)
                (newt-ui-addtitional #f obj-add)))
            
            ((string=? x title-printer)
              (let* ((obj-pr (conf-print))
                     (patcher (conf-patch obj-pr)))
                (set! obj-cur obj-pr)
                (set! obj-p patcher)
                (obj-pr 'init)
                (and (conf-newt-load/confirm patcher title-printer)
                     (newt-ui-printer #t obj-pr)
                     (conf-newt-finish patcher title-printer)
                     (= 0 (sh "/etc/init.d/lprng start")))))
            
            ((equal? x title-orca)
              (let* ((obj-net (configure-network))
                     (obj-sv (configure-service))
                     (obj-pd (conf-prod obj-net obj-sv))
                     (patch-pd (conf-patch obj-pd))
                     (obj-prof (conf-prof))
                     (patch-prof (conf-patch obj-prof))
                     (obj-cr (conf-cron obj-sv))
                     (patch-cron (conf-patch obj-cr)))
                (set! obj-cur obj-pd)
                (obj-prof 'load)
                (and (conf-newt-load/confirm patch-pd title-orca)
                     (conf-newt-load/confirm patch-prof title-orca)
                     (conf-newt-load/confirm patch-cron title-orca)
                     (newt-ui-orca obj-pd patch-pd obj-prof obj-cr)
                     (conf-newt-finish patch-pd title-orca)
                     (conf-newt-finish patch-prof title-orca)
                     (conf-newt-finish patch-cron title-orca))))
            
            ((string=? x title-support)
              (let* ((obj-na (conf-na))
                     (obj-acc (configure-acc)))
                (obj-acc 'init 'admin)
                (and (obj-na 'load)
                     (newt-ui-support obj-na obj-acc)
                     (obj-na 'commit))))
            
            (else
              (snewt-message (_ "Admin Mode") (_ "Error."))))
          (if (eq? #f r')
            (admin-newt)
            #t))))))
            

;
; main part
;
(let ((d (unix-getenv "DISPLAY"))
      (xa (unix-getenv "XAUTHORITY"))
      (a (command-line-args)))
  (cond
    ((ormap (lambda (x) (equal? "debug" x)) a)
      (set! ogl-admin-debug? #t)
      (if (< 1 (length a))
        (set! ogl-admin-keyword (string->symbol (cadr a)))))
    ((not (null? a))
      (set! ogl-admin-keyword (string->symbol (car a)))))
  
  (cond
    ((or (eq? #f d) (equal? "" d))
      (snewt-start)
      (newt-stage-title (_ "starting ogl-admin"))
      (snewt-show-while (_ "starting ogl-admin")
        (string-append
          (_ "ARMA/OGL Administration Tool ver 2.1.0\n")
             "      (C) 2001,2002 Omoikane Inc.\n"
             "          All rights reserved")
        40 3
        (lambda() (unix-usleep 400000)))
      (let ((printk (unix-tempname "/tmp" "prk")))
        (sh "cat /proc/sys/kernel/printk > ~a" printk)
        (sh "echo '4 4 1 7' >  /proc/sys/kernel/printk")
        (admin-newt)
        (sh "cat ~a > /proc/sys/kernel/printk" printk)
        (sh "rm ~a" printk)
        (snewt-finish)))
    (else
      (cond
        ((eq? #f xa)
          (let ((give-up (lambda () 
                           (textdomain "ogl-admin" "/usr/share/locale")
                           (format #t
                             (string-append
                               (_ "Setting only DISPLAY environment will probably break Gtk. \n")
                               (_ "Set XAUTHORITY environment or unset DISPLAY and run console version.\n")
                               (_ "  (ex. export XAUTHORITY=/home/foo/.Xauthority)\n")))
                           (exit 1)))
                (tty (unix-readlink "/proc/self/fd/0"))
                (who (parse-awk #\space #t "| who")))
          ;(format #t "~s\n" tty)
          ;(format #t "~s\n" who)
          (cond
            ((< (string-length tty) 5)
              (give-up))
            (else
              (let* ((t (substring tty 5 (string-length tty)))
                     (l (filter (lambda (x)
                                  (let ((y (cadr x)))
                                    ;(format #t "y:~s\n" y)
                                    (or (equal? (cadr x) t)
                                      (if (and (< 4 (string-length y))
                                               (equal? "ttyp" (substring y 0 4)))
                                        (equal? (unix-readlink (format #f "/dev/~a" y)) t)
                                        #f))))
                                who)))
                ;(format #f "l:~s\n" l)
                (cond
                  ((not (= 1 (length l)))
                    (give-up))
                  (else
                    (unix-setenv "XAUTHORITY" (format #f "/home/~a/.Xauthority" (caar l)))
                    (admin-gtk))))))))
        (else
          (admin-gtk))))))

(obj-jq 'exec)
