#!/bin/sh
string=?;exec /usr/bin/elk -h 3000 -l $0 -p /usr/lib/ogl/scm:/usr/lib/elk/scm:/usr/lib/elk/obj:`pwd` `basename $0` $*

(load "obj.scm")
(load "util.scm")
(load "conffile.scm")
(load "prod.scm")
(load "service.scm")
(load "net.scm")
(load "patch.scm")

(set! sh-log "logger")
(set! inst-log-context 'admin)


(define (fail&exit m c)
  (format #t m)
  (exit c))

(define (recover&exit obj-pd st c)
  (case st
    ((work)
      (obj-pd 'run-server))
    ((wait)
      (obj-pd 'wait-server))
    ((stop)
      (obj-pd 'stop-server)))
  (exit c))

(define (usage)
  (fail&exit "Usage : orca-auto-refresh <secondary IP>\n" 1))

(let ((a (command-line-args)))
  (cond
    ((not (= 1 (length a)))
      (usage))
    (else
      (let* ((obj-net (configure-network))
             (obj-sv (configure-service))
             (obj-pd (conf-prod obj-net obj-sv))
             (st (obj-pd 'stat-server)))
        (obj-pd 'load)
        (case st
          ((error)
            (fail&exit "auto-refresh : primary server is in error status." 1))
          (else
            (unix-setenv "PATH" "/usr/sbin/ogl:/bin:/usr/bin:/usr/sbin:/usr/local/bin")
            (cond
              ((not (andmap (lambda (x) x) (obj-pd 'semiwait-server)))
                (inst-log "auto-refresh : not every server'status could not changed. aborting.\n")
                (recover&exit obj-pd st 2))
              ((not (= 0 (obj-pd 'recover-secondary)))
                (inst-log "auto-refresh : failed refresh process. aborting.\n")
                (recover&exit obj-pd st 3))
              (else
                (inst-log "auto-refresh : refresh succeeded.\n")
                (recover&exit obj-pd st 0)))))))))

