;
;   ORCA management object
;

(define (conf-orca)
  
  ; libs
  (define (psql . l)
    (let ((s (apply format (cons #f l))))
      (inst-log "psql : ~s\n" s)
      (parse-awk #\space #t (format #f "| echo \"~a\" | su orca -c 'psql -h localhost orca' 2>&1" s))))
  
  (define (adduser-gen id u p)
    (let* ((c (crypt p (sprintf "%02d" (modulo (random) 100))))
           (exist? (psql "select usr from orca_acc where usr = '~a'" u))
           (mid (psql "select max(uid) from orca_acc;")))
      (inst-log "orca adduser ex:~s\n" exist?)
      (inst-log "orca adduser c:~s, mid:~s\n" c mid)
      (cond
        ((or (not (list? exist?)) (< (length exist?) 3))
          (_ "Could not access to PostgreSQL."))
        ((< 4 (length exist?))
          (_ "User already exists."))
        ((or (equal? "" c))
          (_ "Could not generate encrypted password or get maximum uid, sorry. Please consult ARMA Net"))
        ((or (not (list? mid)) (< (length mid) 4))
          (_ "Could not get maximum user ID."))
        (else
          (let* ((mn (string->number (car (caddr mid))))
                 (mn' (if (number? mn) mn 1)))
            (let ((r1 (if (< 0 id)
                        (psql "insert into orca_acc (usr,passwd,uid,gid) values ('~a','~a',~a,0);" u c id)
                        (psql "insert into orca_acc (usr,passwd,uid) values ('~a','~a',~a);" u c (1+ mn')))))
              (inst-log "r1: ~s\n" r1)
              (cond
                ((or (not (list? r1)) (not (= 1 (length r1))))
                  (_ "Could not access to PostgreSQL."))
                ((equal? "INS" (substring (caar r1) 0 3))
                  #t)
                (else
                  (_ "Could not generate account.")))))))))
  
  ; method
  
  (define (adduser u p)
    (adduser-gen -1 u p))
  
  (define (make-master)
    (adduser-gen 1 "ormaster" ""))
  
  (define (passwd u p)
    (let ((c (crypt p (sprintf "%02d" (modulo (random) 100)))))
      (cond
        ((equal? "" c)
          (_ "Could not generate encrypted password, sorry. Please consult ARMA Net"))
        (else
          (let ((r1 (psql "update orca_acc set passwd = '~a' where usr = '~a';" c u)))
            (cond
              ((not (and (list? r1)
                         (= 1 (length r1))
                         (not (null? (car r1)))
                         (< 3 (string-length (caar r1)))
                         (equal? "UPD" (substring (caar r1) 0 3))))
                (_ "Could not change password. Check if your ORCA installaion is finished."))
              (else
                #t)))))))
  
  ; $B$"$H(B no such account check $B$,I,MW(B
  
  (define (deluser u)
    (let ((r (psql "delete from orca_acc where usr = '~a'" u)))
      (inst-log "respond : ~s\n" r)
      (cond
        ((not (and (list? r)
                   (= 1 (length r))
                   (< 3 (string-length (caar r)))
                   (equal? "DEL" (substring (caar r) 0 3))))
          (_ "Could not remove user. Check if your ORCA installaion is finished."))
        (else
          #t))))
  
  (define (user-list)
    (let ((r (psql "select usr from orca_acc;")))
      (inst-log "ocra r : ~s\n" r)
      (cond
        ((or (not (list? r)) (< (length r) 4))
          #f)
        (else
          (filter (lambda (x) (not (equal? "ormaster" x)))
            (map (lambda (x) (if (not (null? x)) (car x) ""))
                 (list-sub r 2 (- (length r) 4))))))))
  
  (make-object
    'adduser     adduser
    'deluser     deluser
    'make-master make-master
    'passwd      passwd
    'user-list   user-list
    ))
    
    
    