;;
;;		Partition Object
;;                                 (C)2001,2002 Omoikane Inc.
;;

(define (configure-part mnt)
  ;
  ;  var
  ;
  (define context 'admin)
  ; 
  (define hw-list '())
  (define bios-order '())
  (define default-group '())
  (define part '())
  (define to-format '())          ; <did> <n> <fs-sym>Υꥹ
  (define fd-drive '())
  
  ; 
  (define hw-ide-hd '())
  (define hw-ide-cdrom '())
  (define hw-scsi-hd '())
  (define hw-scsi-opt '())
  (define hw-scsi-cdrom '())
  
  (define mountp '())
  
  ;
  ;  libs
  ;
  (define (hw-check-ide)
    (define (get-id d)
      (let ((p (open-input-file (string-append d "/model"))))
        (let ((s (read-string p)))
          (close-input-port p)
          (substring s 0 (1- (string-length s))))))
    (define (check i)
      (let* ((v (string-append "hd"
                  (list->string
                    (list (integer->char (+ (char->integer #\a) i))))))
            (d (string-append "/proc/ide/" v)))
        (cond
          ((unix-access? d '(read))
            (let ((ty (symbol->string (call-with-input-file (string-append d "/media") read))))
              (cond
                ((string=? "disk" ty)
                  (set! hw-ide-hd
                      (append hw-ide-hd
                        (list (cons v (get-id d))))))
                ((string=? "cdrom" ty)
                  (set! hw-ide-cdrom
                      (append hw-ide-cdrom
                        (list (cons v (get-id d))))))))))
        (if (= i 8)
            #t
            (check (1+ i)))))
    (cond
      ((or (unix-access? "/proc/ide/ide0" '(read))
            (unix-access? "/proc/ide/ide1" '(read)))
        (set! hw-ide-hd '())
        (set! hw-ide-cdrom '())
        (check 0))
      (else
        #t)))
  
  (define (hw-check-scsi)
    (define (get-id l)
      (cond
        ((string=? "Rev:" (list-ref l 4))
          (list-ref l 3))
        (else
          (string-append (list-ref l 3) " "
                        (list-ref l 4)))))
    (define (get-dev-hdstr i)
      (list->string
        (list #\s #\d
          (integer->char (+ (char->integer #\a) i)))))
    
    (define (get-dev-cdstr i)
      (list->string
        (list #\s #\r (integer->char (+ (char->integer #\0) i)))))
    
    ;  sg ؤб򤷤ƤСȤꤢ̵
    ; Ȥ serial Ƥޤä褵
    (define (check l i j)
      (cond
        ((< (length l) 3) #t)
        (else
          (let ((ty (cadr (caddr l))))
            (cond
              ((string=? "Direct-Access" ty)
                (let* ((d (get-dev-hdstr i))
                       (s (ioctl-getblocksize (format #f "/dev/~a" d))))
                  (cond
                    ((and (not (= s -1))
                          (not (= s 2880)))  ; should be USB FD
                      (set! hw-scsi-hd
                            (append hw-scsi-hd
                              (list (cons (get-dev-hdstr i)
                                          (get-id (cadr l))))))
                      (set! i (1+ i)))
                    (else
                      (inst-log "part : eliminated ~a (size ~a)\n" d s)))))
              ((string=? "Optical" ty)
                (set! hw-scsi-opt
                      (append hw-scsi-opt
                        (list (cons (get-dev-hdstr i)
                                    (get-id (cadr l))))))
                (set! i (1+ i)))
              ; ΤǤϤʤ
              ; ߤǤ direct-access ȤƽФƤޤ褦
              ((string=? "CD-ROM" ty)
                (set! hw-scsi-cdrom
                      (append hw-scsi-cdrom
                        (list (cons (get-dev-cdstr j)
                                    (get-id (cadr l))))))
                (set! j (1+ j)))))
          (check (cdddr l) i j))))
    (cond
      ((unix-access? "/proc/scsi/scsi" '(read))
        (set! hw-scsi-hd '())
        (set! hw-scsi-opt '())
        (set! hw-scsi-cdrom '())
        (check (cdr (parse-awk #\space #t "/proc/scsi/scsi")) 0 0))
      (else
        #f)))
  
  (define (hw-make-model type h d)
    ;(inst-logformat #f "h:~a\n" h)
    (let ((r (hdd-identify d)))
      (inst-log "hdd-identify ~a returned : ~a\n" d r)
      (cond
        ((string? (car r))
          (car r))
        (else
          (case type
            ((rd hda ataraid)
              (format #f "RaidDriveArray(~a~a)" type h))
            (else
              "unknown-model"))))))
  
  ;(define (hw-make-id type h d))
  (define (hw-make-id type h b t l d)
    (let* ((r (hdd-identify d))
           (c (let ((c0 (ioctl-getblocksize (format #f "~a/disc" d))))
                (cond
                  ((< 0 c0) c0)
                  (else 0))))
           (m? (string? (car r)))
           (s? (string? (cadr r))))
      (cond
        ((and s? m?)               ; ξ
          (format #f "~a:~a" (car r) (cadr r)))
        (m?                        ; ǥ̾
          (format #f "~a:~a:~a" (car r) type h))
        (s?                        ; ꥢ
          (format #f "~a:~a:~a:~a" type h c (cadr r)))
        (else                      ; ʤ
          (format #f "~a:~a:~a:~a:~a" type h b t l c)))))
  
  (define (hw-check-did)
    (define (numlist l)
      ;(format #t "numlist : ~a\n" l)
      (map
        (lambda (y)
          (string->number (list-ref y (1- (length y)))))
        (filter
          (lambda (y) (not (null? y)))
          (map
            (lambda (x)
              (string-match x "[0-9]\\+"))
            l))))
    
    (define (getdir d)
      ;(format #t "getdir : ~a\n" d)
      (numlist
        (filter (lambda (x)
                  (equal? 'dir (unix-filetype (format #f "~a/~a" d x))))
                (unix-read-directory2 d))))
    
    (define scsi-fd '())
    
    (define (capacity d)
      (case context
        ((inst1) -1)
        (else
          (cond
            ((not (= 0 (lf-open d)))
              -1)
            (else
              (let ((r (lf-get-disk)))
                (lf-close)
                (cond
                  ((= 7 (length r))
                    ;(inst-log "r:~a\n" r)
                    (* (cadr r) (caddr r) (list-ref r 3)))
                  (else
                    -1))))))))
    
    (define (check type h b t l)
      ;(inst-log "~a/~a/~a/~a/~a\n" type h b t l)
      (cond
        ((not (eq? #f l))
          (let* ((dir (format #f "/dev/~a/host~a/bus~a/target~a/lun~a" type h b t l))
                 (disc (format #f "~a/disc" dir))
                 (cd (format #f "~a/cd" dir))
                 (disc? (unix-access? disc '(read)))
                 (cd? (unix-access? cd '(read))))
            (cond
              ((not (or disc? cd?))
               '())
              (else
                (let* ((c (capacity disc))
                       (id (hw-make-id type h b t l dir))
                       (fd? (= c 2880))
                       (m (cond
                            (fd? 'fd)
                            (cd? 'cd)
                            ((< c 0) 'unknown)
                            (else 'disc))))
                  (if fd? (set! scsi-fd (cons id scsi-fd)))
                  (list (list id (hw-make-model type h dir) c type m h b t l)))))))
        ((not (eq? #f t))
          (apply append (map (lambda (x) (check type h b t x))
                             (getdir (format #f "/dev/~a/host~a/bus~a/target~a" type h b t)))))
        ((not (eq? #f b))
          (apply append (map (lambda (x) (check type h b x #f))
                             (getdir (format #f "/dev/~a/host~a/bus~a" type h b)))))
        ((not (eq? #f h))
          (apply append (map (lambda (x) (check type h x #f #f))
                             (getdir (format #f "/dev/~a/host~a" type h)))))
        (else
          (apply append (map (lambda (x) (check type x #f #f #f))
                             (getdir (format #f "/dev/~a" type)))))))
    
    (define (check-raid type)
      ;(format #t "~a\n" type)
      (map
        (lambda (n)
          (let* ((dir (format #f "/dev/~a/disc~a" type n))
                 (disc (format #f "~a/disc" dir))
                 (disc? (unix-access? disc '(read)))
                 (c (ioctl-getblocksize disc)))
            (list (hw-make-id type n 0 0 0 dir) (hw-make-model type n dir)
                  c type 'disc n 0 0 0)))
        (getdir (format #f "/dev/~a" type))))
    
    (define (check-raid-ida)
      (define (make-dir c d)
        (format #f "/dev/ida/c~ad~a/disc" c d))
      
      (define (check c d)
        (unix-access? (make-dir c d) '(read)))
        
      (map (lambda (x)
             (let* ((c (car x))
                    (d (cadr x))
                    (dir (make-dir c d))
                    (disc (format #f "~a/disc" dir))
                    (cap (ioctl-getblocksize disc)))
               (list (hw-make-id 'ida c d 0 0 dir) (hw-make-model 'ida c dir)
                     cap 'ida 'disc d 0 0 0)))
        (filter
          (lambda (x) (check (car x) (cadr x)))
          (list '(0 0) '(0 1) '(0 2) '(0 3) '(1 0) '(1 1) '(1 2) '(1 3)))))
    
    (case context
      ; ((inst1)
      ;   #t)
      (else
        (set! hw-list
              (append
                (check 'ide #f #f #f #f)
                (check 'scsi #f #f #f #f)
                (check-raid 'rd)
                (check-raid-ida)
                (check-raid 'ataraid)))
        
        (set! fd-drive (append (map devfsname scsi-fd)
                               (if (or (read-openable? "/dev/fd0")
                                       (read-openable? "/dev/floppy/0"))
                                 (list "/dev/floppy/0")
                                 '())))
        
        (set! bios-order
              (list-uniq (map (lambda (x) (list (list-ref x 3) (list-ref x 5)))
                              (hw-disc))))
        (set! default-group bios-order)))
    )
  
  (define (write-devicegroup)
    (fprintf "/var/lib/ogl/etc/devicegroup"
      (apply string-append
        (map (lambda (x) (format #f "~a ~a\n" (car x) (cadr x)))
             bios-order))))
  
  (define (load-devicegroup)
    (let ((r (parse-awk #\space #t "/var/lib/ogl/etc/devicegroup")))
      (cond
        ((eq? #f r)
          #f)
        ((not (= (length (filter (lambda (x) (= 2 (length x)))
                                 r))
                 (length r)))
          #f)
        (else
          (let ((s (map (lambda (x)
                          (list (string->symbol (car x))
                                (string->number (cadr x))))
                        r))
                (d<? (lambda (x y)
                        (cond
                          ((equal? (car x) (car y))
                            (< (cadr x) (cadr y)))
                          (else
                            (symbol<? (car x) (car y)))))))
            (cond
              ((equal? (easy-sort d<? s) (easy-sort d<? bios-order))
                (set! bios-order s)
                #t)
              (else
                #f)))))))
  
  ; part  (<did:str> <obj:comp> <dirty?:bool>) Υꥹ
  (define (check-part)
    (map (lambda (x)
           (case context
             ((inst1)
               (list (car x) #f #f))
             (else
               (let ((o (conf-fdisk)))
                 (o 'init (devfsname (car x)))
                 (inst-log "check-part : ~a\n" (o 'get-partition))
                 (cons (car x) o)))))
         (filter (lambda (x) (equal? 'disc (list-ref x 4)))
                 hw-list)))
  
  (define (part-obj did)
    (let ((r (assoc did part)))
      (cond
        ((eq? #f r)
          r)
        (else
          (cdr r)))))
  
  (define (hw-update)
    (hw-check-ide)
    (hw-check-scsi)
    (hw-check-did)
    (set! part (check-part))
    #t)
  
  (define (hw-partition-valid? x) (= 6 (length x)))
  
  (define (oldname . l)
    (define (num->char n)
      (integer->char (+ (char->integer #\a) n)))
    ;(define (ide h b t)
    ;  (format #f "/dev/hd~a"
    ;          (num->char (+ (* 4 h) (* 2 b) t))))
    (define (ide h b t)
      (format #f "/dev/hd~a"
              (num->char (+ (* 4 (count-smaller-ide-bus h)) (* 2 b) t))))
    (define (search-scsi d sd sr h b t l)
      (cond
        ((null? d) "unknown")
        (else
          (let ((x (car d)))
            (cond
              ((not (equal? 'scsi (list-ref x 3)))
                (search-scsi (cdr d) sd sr h b t l))
              ((and (eq? h (list-ref x 5))
                    (eq? b (list-ref x 6))
                    (eq? t (list-ref x 7))
                    (eq? l (list-ref x 8)))
                (case (list-ref x 4)
                  ((disc)
                    (format #f "/dev/sd~a" (num->char sd)))
                  ((cd)
                    (format #f "/dev/sr~a" sr))
                  (else
                    "unknown")))
              (else
                (case (list-ref x 4) 
                  ((disc)
                    (search-scsi (cdr d) (1+ sd) sr h b t l))
                  ((cd)
                    (search-scsi (cdr d) sd (1+ sr) h b t l))
                  (else
                    (search-scsi (cdr d) sd sr h b t l)))))))))
    (cond
      ((and (not (= 2 (length l)))
            (not (= 1 (length l))))
        "unknown")
      (else
        (let* ((did (car l))
               (p (if (= 1 (length l)) "" (format #f "~a" (cadr l))))
               (r (assoc did hw-list)))
          (cond
            ((eq? #f r)
              "unknown")
            (else
              (case (list-ref r 3)
                ((ide)
                  (format #f "~a~a"
                    (ide (list-ref r 5) (list-ref r 6) (list-ref r 7))
                    p))
                ((scsi)
                  (format #f "~a~a"
                    (search-scsi hw-list 0 0 (list-ref r 5) (list-ref r 6) (list-ref r 7) (list-ref r 8))
                    p))
                ((rd ida ataraid)
                  (apply devfsname l))
                (else
                  "unknown"))))))))
  
  (define (hexname . l)
    (cond
      ((and (not (= 2 (length l)))
            (not (= 1 (length l))))
        "unknown")
      (else
        (let* ((did (car l))
               (p (if (= 1 (length l)) "" (format #f "~a" (cadr l))))
               (r (assoc did hw-list)))
          (cond
            ((eq? #f r)
              "unknown")
            (else
              (case (list-ref r 3)
                ((ataraid)
                  (format #f "0x~a"
                    (number->string (+ (* 114 16 16)
                                       (* 16 (list-ref r 5))
                                       (if (= 2 (length l)) (cadr l) 0))
                                    16)))
                (else
                  "unknown"))))))))
  
  (define (parse-name s)
    (let ((len (string-length s)))
      (define (get did dev)
        (let ((l (string-length dev)))
          (cond
            ((< l len)
              (let* ((p (string->number (substring s l len))))
                (if (number? p)
                  (list did p)
                  '())))
            (else
              (list did)))))
      (define (search l)
        (cond
          ((null? l)
            '())
          (else
            (let* ((d (caar l))
                   (n0 (devfsname d))
                   (n1 (oldname d))
                   (y0 (string-match s n0))
                   (y1 (string-match s n1)))
              (cond
                ((not (null? y0))
                  (get d n0))
                ((not (null? y1))
                  (get d n1))
                (else
                  (search (cdr l))))))))
      (search hw-list)))
  
  (define (devfsname . l)
    (cond
      ((and (not (= 1 (length l)))
            (not (= 2 (length l))))
        "unknown(1)")
    (else
      (let ((part (lambda (a)
                    (cond
                      ((= 2 (length l))
                        (format #f "part~a" (cadr l)))
                      ((or (equal? 'unknown a) (equal? 'fd a))
                        "disc")
                      (else
                        a))))
            (r (assoc (car l) hw-list)))
        (cond
          ((eq? #f r)
            "unknown(2)")
          (else
            (case (list-ref r 3)
              ((ide scsi)
                (format #f "/dev/~a/host~a/bus~a/target~a/lun~a/~a"
                  (list-ref r 3) (list-ref r 5) (list-ref r 6) (list-ref r 7) (list-ref r 8)
                  (part (list-ref r 4))))
              ((ida)
                (format #f "/dev/ida/c~ad~a/~a" (list-ref r 5) (list-ref r 6) (part "disc")))
              ((rd ida ataraid)
                (format #f "/dev/~a/disc~a/~a" (list-ref r 3) (list-ref r 5) (part "disc")))
              (else
                "unknown(3)"))))))))
  
  (define (did->biosnum did)
    (define (group type h)
      (length
        (filter (lambda (x)
                  (and (equal? type (list-ref x 3))
                       (equal? h (list-ref x 5))
                       (equal? 'disc (list-ref x 4))))
                hw-list)))
    (define (search-in-group n l x)
      ;(format #t "search-in-group ~a ~a ~a\n" n l x)
      (cond
        ((null? l) -1)
        (else
          (let ((y (car l)))
            (cond
              ((not (and (equal? (list-ref y 3) (list-ref x 3))
                         (equal? (list-ref y 5) (list-ref x 5))
                         (equal? 'disc (list-ref y 4))))
                (search-in-group n (cdr l) x))
              ((and (equal? (list-ref y 6) (list-ref x 6))
                    (equal? (list-ref y 7) (list-ref x 7))
                    (equal? (list-ref y 8) (list-ref x 8)))
                n)
              (else
                (search-in-group (1+ n) (cdr l) x)))))))
    
    (define (count n bl x)
      ;(format #t "count ~a ~a ~a\n" n bl x)
      (cond
        ((null? bl) -1)
        (else
          (let ((b (car bl)))
            (cond
              ((and (equal? (car b) (list-ref x 3))
                    (equal? (cadr b) (list-ref x 5)))
                (search-in-group n hw-list x))
              (else
                (count (+ n (group (car b) (cadr b))) (cdr bl) x)))))))
    
    (let ((r (assoc did hw-list)))
      (cond
        ((eq? #f r)
          -1)
        (else
          (count 0 bios-order r)))))
  
  (define (mnt->did m)
    (let ((r (filter (lambda (x) (equal? m (list-ref x 4)))
                     mountp)))
      (cond
        ((not (= 1 (length r)))
          "")
        (else
          (caar r)))))
  
  (define (mountp->biosnum m)
    (let ((r (mnt->did m)))
      (cond
        ((equal? "" r)
          -1)
        (else
          (did->biosnum r)))))
  
  ;
  ;   Next cylinder
  ;
  (define (hw-s-next n)
    (1+ n))
  
  ;
  ;   Previous Cylinder
  ;
  (define (hw-s-prev n)
    (1- n))
  
  ;
  ;   wheter it is an extended partition
  ;
  (define (hw-s-ext? p)
    (or (= (list-ref p 5) 5)
        (= (list-ref p 5) 15)
        (= (list-ref p 5) 133)))
  
  (define (hw-s-empty n e l)
    (cond
      ((< e n) '())
      (else
        (let ((pl1 (filter (lambda (x) (= (caddr x) n)) l)))
          (cond
            ((null? pl1)
              (let ((pl2 (filter (lambda (x) (< n (caddr x))) l)))
                (cond
                  ((null? pl2)
                    (if (= n e)
                        '()
                        (list (list 'empty n e))))
                  (else
                    (let ((p (car pl2)))
                      (cons (list 'empty n (hw-s-prev (caddr p)))
                            (cons p
                                  (cond
                                    ((hw-s-ext? p)
                                      (hw-s-empty-ext (caddr p) (cadddr p) e l))
                                    (else
                                      (hw-s-empty (hw-s-next (cadddr p)) e l))))))))))
            (else
              (let ((p (car pl1)))
                (cons p
                      (if (hw-s-ext? p)
                          (hw-s-empty-ext (caddr p) (cadddr p) e l)
                          (hw-s-empty (hw-s-next (cadddr p)) e l))))))))))
  
  ;
  ;   Search empty region inside extened partition
  ;
  ;  n    : start cylinder
  ;  ee   : end cylinder of extended partition
  ;  e    : end cylinder
  ;  l    : list of partition
  ; 
  (define (hw-s-empty-ext n ee e l)
    (cond
      ((< ee n) (hw-s-empty (1+ ee) e l))
      (else
        (let ((pl1 (filter (lambda (x) (and (not (hw-s-ext? x))
                                                 (= (caddr x) n)))
                                l)))
          (cond
            ((null? pl1)
              (let ((pl2 (filter (lambda (x) (< n (caddr x)))
                                      l)))
                (cond
                  ((null? pl2)
                    (cond
                      ((< ee e)
                        (cons (list 'e-empty n ee)
                              (list (list 'empty (1+ ee) e))))
                      (else
                        (list (list 'e-empty n ee)))))
                  (else
                    (let* ((p (car pl2))
                          (st (caddr p))
                          (ed (cadddr p)))
                      (cond
                        ((< 1 (- st ee))
                          (cons (list 'e-empty n ee)
                                (cons (list 'empty (1+ ee) (1- st))
                                      (cons p (hw-s-empty (1+ ed) e l)))))
                        ((< ee st)
                          (cons (list 'e-empty n ee)
                                (hw-s-empty (1+ ee) e l)))
                        (else
                          (cons (list 'e-empty n (1- st))
                                (cons p
                                      (hw-s-empty-ext (1+ ed) ee e l))))))))))
            (else
              (let ((p (car pl1)))
                (cons p
                    (hw-s-empty-ext (1+ (cadddr p)) ee e l)))))))))
  
  (define (search-no n l)
    (filter (lambda (x) (and (not (eq? 'empty (car x)))
                             (= n (list-ref x 3))))
            l))
  
  (define (search-not-no n l)
    (filter (lambda (x) (not (and (not (eq? 'empty (car x)))
                                  (= n (list-ref x 3)))))
            l))
  
  (define (conf-path d)
    (format #f "/var/lib/ogl/etc/part-~a"
               (string-replace d #\/ #\-)))
  
  (define (conf-check d)
    (let ((p (conf-path d)))
      (cond
       ((not (read-openable? p))
         #f)
       (else
         (let* ((f (parse-awk #\space #t p))
                (f' (map (lambda (x)
                           (if (< (length x) 9)
                             #f
                             (let ((l (map string->number (list-sub x 2 7))))
                               (cond
                                 ((not (andmap real-integer? l))
                                   #f)
                                 (else
                                   (cons (string->symbol (car x))
                                     (cons (cadr x) l)))))))
                         f)))
            (if (ormap (lambda (x) (eq? #f x)) f')
                #f
                f'))))))
  
  (define (part-count/ s)
    (define (rep l)   
      (cond
        ((null? l) 0)
        ((eq? #\/ (car l))
          (1+ (rep (cdr l))))
        (else
          (rep (cdr l)))))
    (cond
      ((string=? "swap" s)
        -1)
      ((string=? "/" s)
        0)
      (else
        (rep (string->list s)))))
  
  
  
  ;;
  ;;  methods
  ;;
  (define (init x)
    (set! context x)
    (set! mountp '())
    (set! to-format '())
    (case x
      ((inst2)
        (sh "modprobe xfs")
        (sh "modprobe reiserfs")
        (sh "modprobe jfs")))
    (hw-update)
    #t)
  
  (define (make-extra-dev root)
    (map (lambda (n)
           (sh "mkdir -p ~a/dev/rd/disc~a" root n)
           (sh "mknod ~a/dev/rd/disc~a/disc b 48 ~a" root n (* n 8))
           (sh "mkdir -p ~a/dev/ida/disc~a" root n)
           (sh "mknod ~a/dev/ida/disc~a/disc b 72 ~a" root n (* n 16))
           (map (lambda (m)
                  (sh "mknod ~a/dev/rd/disc~a/part~a b 48 ~a" root n m (+ (* n 8) m))
                  (sh "mknod ~a/dev/rd/disc~a/disc~a b 48 ~a" root n m (+ (* n 8) m)))
                '(1 2 3 4 5 6 7))
           (map (lambda (m)
                  (sh "mknod ~a/dev/ida/disc~a/part~a b 72 ~a" root n m (+ (* n 16) m))
                  (sh "mknod ~a/dev/ida/disc~a/disc~a b 72 ~a" root n m (+ (* n 16) m)))
                '(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15)))
         '(0 1 2 3)))
  ; disc<i> κ grub  setup() ХкǤ
  ; 줬褵פǤ

  (define (info-cdrom)
    (append hw-ide-cdrom hw-scsi-cdrom))
  
  (define (info-removable)
    (append hw-scsi-opt))
  
  (define (create-part did fs n s e)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o)
          (inst-log "create-part : could not find device.\n")
          #f)
        (else
          (let ((id (fs->id fs))
                (n' (case n
                      ((-1)
                        (let ((p (rest-primary did)))
                          (if (null? p)
                            n
                            (car p))))
                      (else
                        n)))
                (l (map car (o 'get-partition))))
            (cond
              ((< e s)
                (inst-log "create-part : illegal region(0).\n")
                #f)
              ((not (ormap (lambda (x)
                             (and (eq? (car x) 'empty)
                                  (<= (list-ref x 4) s)
                                  (<= e (list-ref x 5))))
                           (list-part did)))
                (inst-log "create-part : region not at empty.\n")
                #f)
              ((= n' -1)
                (inst-log "could not get primary.\n")
                #f)
              ((not (= 0 (case n'
                           ((0)
                             (o 'add-logical id s e))
                           (else
                             (o 'add-dos n' id s e)))))
                #f)
              (else
                ; ext ξϺʬѡƥֹ
                (let* ((l' (map car (o 'get-partition)))
                       (n'' (case n'
                              ((0)
                                (let ((r (list-set- = l' l)))
                                  (if (= 1 (length r))
                                     (car r)
                                     n')))
                              (else
                                n'))))
                  (cond
                    ((= n'' 0)
                      (inst-log "could not find created logical partition.")
                      #f)
                    (else
                      (set! to-format (cons (list did n'' fs) to-format))
                      #t))))))))))
  
  (define (modify-part did n fs)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o)
          #f)
        (else
          (let* ((p (list-part did))
                 (l (search-no n p))
                 (id (fs->id fs)))
            (cond
              ((< 1 (length l))
                (inst-log "partition:modify : broken partiton.\nl:~a\n" l)
                #f)
              ((null? l)
                (inst-log "partition:modify : not partiton ~a\n" n)
                #f)
              ((and (not (= id (list-ref (car l) 8)))
                    (not (o 'change-id n id)))
                (inst-log "lf-change-id failed.\n")
                #f)
              (else
                (set! to-format
                      (cons (list did n fs)
                        (filter (lambda (x) (or (not (equal? did (car x)))
                                                (not (equal? n (cadr x)))))
                                to-format)))
                #t)))))))
  
  (define (delete-part did n)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o)
          #f)
        (else
          (let ((l (map car (o 'get-partition))))
            (cond
              ((not (o 'delete n))
                #f)
              (else
                (let* ((l' (map car (o 'get-partition)))
                       (dif (list-set- = l l')))
                  (set! to-format
                        (filter (lambda (x) (or (not (equal? did (car x)))
                                                (not (set-include? (cadr x) dif))))
                                to-format))
                  #t))))))))
  
  (define (get-part did s e)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o)
          #f)
        (else
          (let* ((p (list-part did))
                 (r (filter (lambda (x)
                              (and (= 9 (length x))
                                   (= s (list-ref x 5))
                                   (= e (list-ref x 6))))
                            p)))
            (cond
              ((= 1 (length r))
                (car r))
              ((null? r)
                #f)
              ((= 2 (length r))
                (let ((r' (filter (lambda (x) (< 4 (list-ref x 3)))
                                  r)))
                  (cond
                    ((= 1 (length r'))
                      (car r'))
                    (else
                      (inst-log "get-part : partition broken? / ~a\n" r)
                      #f))))
              (else
                (inst-log "get-part : partition broken! / ~a\n" r)
                #f)))))))
  
  ; create ǽʻĤΥץ饤ޥֹ
  (define (rest-primary did)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o)
          '())
        (else
          (let* ((p (list-part did)))
            (list-set- = '(1 2 3 4)
              (filter id-primary?
                (map (lambda (x) (list-ref x 3))
                     (filter (lambda (x) (not (eq? (car x) 'empty)))
                             p)))))))))
  
  (define (have-extended did)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o)
          #f)
        (else
          (let* ((p (list-part did)))
            (not (null? (filter (lambda (x) (eq? 'ext (car x)))
                                p))))))))
  
  (define (get-extended did)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o)
          -2)
        (else
          (let* ((p (list-part did))
                 (l (filter (lambda (x) (eq? 'ext (car x)))
                            p)))
            (case (length l)
              ((0) -1)
              ((1) (list-ref (car l) 3))
              (else -3)))))))
  
  (define (have-/boot?)
    (not (null? (filter (lambda (x) (equal? "/boot" (list-ref x 4)))
                        mountp))))
  
  (define (count-smaller-ide-bus n)
    (let ((d (unix-read-directory2 "/dev/ide")))
      (cond
        ((< (length d) 3)
          (inst-log "count-smaller-ide-bus : cound not count.")
          n)
        (else
         (length (filter (lambda (y)
                           (cond
                             ((not (= 5 (string-length y)))
                               #f)
                             (else
                               (let ((s (string->number (substring y 4 5))))
                                 (cond
                                   ((not (number? s))
                                     #f)
                                   (else
                                     (< s n)))))))
                         d))))))
  
  (define (hw-desc x)
    (define (several? g)
      (< 1 (length (filter (lambda (x) (equal? g (car x)))
                           default-group))))
    (define (several-lun? x)
      (< 1 (length (filter (lambda (y)
                             (and (equal? (list-ref x 3) (list-ref y 3))
                                  (equal? (list-ref x 5) (list-ref y 5))
                                  (equal? (list-ref x 6) (list-ref y 6))
                                  (equal? (list-ref x 7) (list-ref y 7))))
                           (hw-info)))))
    (define (several-scsi?)
      (< 1 (length (list-uniq
                     (map (lambda (x) (list (list-ref x 5) (list-ref x 6)))
                       (filter (lambda (x) (equal? 'scsi (list-ref x 3)))
                         (hw-info)))))))
    (cond
      ((or (not (list? x))
           (not (= 9 (length x))))
        "")
      (else
        (let ((device (case (list-ref x 4)
                        ;((disc) (_ "Disc"))
                        ((disc) "")
                        ((cd) (_ "CD-ROM/DVD"))
                        (else (_ "unknown")))))
          (case (list-ref x 3)
            ((ide)
              (let* ((n (+ (* 2 (count-smaller-ide-bus (list-ref x 5)))
                           (list-ref x 6))))
                (sprintf (_ "IDE %10s Bus, %8s")
                  (case n
                    ((0) (_ "Primary"))
                    ((1) (_ "Secondary"))
                    (else (ordinal-string #t n)))
                  (if (eq? 0 (list-ref x 7)) (_ "Master") (_ "Slave")))))
            ((scsi)
              (format #f "SCSI ~a ~aID~a~a"
                device
                (if (several-scsi?)
                  (format #f (_ "Host~a Bus~a") (list-ref x 5) (list-ref x 6))
                  "")
                (list-ref x 7)
                (if (several-lun? x) (format #f "(LUN~a)" (list-ref x 8)) "")))
            (else
              (format #f "~a ~a~a"
                (ifname (list-ref x 3) (list-ref x 5))
                device
                (list-ref x 6))))))))
  
  (define (did-desc . x)
    (let* ((l (length x))
           (1? (= 1 l))
           (2? (= 2 l)))
      (cond
        ((and (not 1?) (not 2?))
          "")
        (else
          (let ((r (assoc (car x) hw-list)))
            (cond
              ((eq? #f r) "")
              (else
                (let ((d (hw-desc r)))
                  (cond
                    (1? d)
                    (else (format #f (_ "~a, partition ~a") d (cadr x))))))))))))
  
  (define (hw-disc)
    (filter (lambda (x) (equal? 'disc (list-ref x 4)))
            hw-list))
  
  (define (hw-ataraid)
    (filter (lambda (x) (equal? 'ataraid (list-ref x 3)))
            hw-list))
  
  (define (load-mountp)
    (cond
      ((not (unix-access? "/var/lib/ogl/etc/mountp" '(read)))
        #t)
      (else
        (let ((r (ttable-read "/var/lib/ogl/etc/mountp"
                              '((str bool int int str int sym)))))
          (cond
            ((eq? #f r)
              #f)
            (else
              (set! mountp r)
              #t))))))
  
  (define (load-it)
    (cond
      ((not (load-mountp))
        (inst-log  "Failed to load mount point setting.\n")
        #t)
      ((begin (inst-log "loaded mountp\n") #f) #f)
      ((not (load-devicegroup))
        (inst-log "Failed to load device group setting.\n")
        #t)
      (else
        #t)))
  
  (define (make-fstab f)
    (fprintf (string-append f)
      (apply string-append
        (cons "proc\t\t/proc\tproc\t\tdefaults\t\t0\t0\n"
          (cons "none\t/proc/bus/usb\tusbdevfs\tdefaults\t\t0\t0\n"
            (append
              (map (lambda (x)
                     (let ((d (car x))
                           (p (list-ref x 4))
                           (n (list-ref x 5))
                           (t (list-ref x 6)))
                       (case t
                         ((linux-xfs linux-ext2 linux-ext3 linux-reiser linux-jfs vfat)
                           (let ((tmp? (equal? p "/mnt/deb")))
                             (if (not (equal? "" p))
                                 (format #f "~a\t~a\t~a\t~a\t\t0\t~a\n"
                                            (devfsname d n) p (fs->mountopt t)
                                            (if tmp? "ro,noauto,user" "defaults")
                                            (if tmp? 0 1))
                                 "")))
                         ((swap)
                           (format #f "~a\tnone\tswap\t\tsw\t\t\t0\t0\n"
                                      (devfsname d n)))
                         ((nfs)
                           (format #f "~a\t~a\tnfs\tro,noauto,nolock\t0\t0\n" d p))
                         ((iso9660)
                           (format #f "~a\t\~a\tiso9660\tro,noauto,user\t0\t0\n"
                                      (devfsname d) p))
                         (else
                           ""))))
                   (list-mnt #f))
              (list (cond
                      ((null? (hw-cdrom))
                        "")
                      (else
                        "/dev/cdroms/cdrom0\t/mnt/cdrom\tiso9660\tnoauto,user\t0\t0\n")))))))))
  
  (define (make-devicemap f)
    (fprintf f
      (apply string-append
        (cons
          (let ((f (get-fdd)))
            (if (equal? "" f) ""
              (format #f "(fd0) ~a\n" f)))
          (map (lambda (x)
                 (case (list-ref x 4)
                   ((disc)
                     (format #f "(hd~a) ~a\n" (did->biosnum (car x)) (devfsname (car x))))
                   (else
                     "")))
               hw-list)))))
  
  (define (write-mountp)
    (ttable-write "/var/lib/ogl/etc/mountp" mountp))
  
  (define (write-drive)
    (fprintf "/var/lib/ogl/etc/drive"
      (apply string-append
        (map (lambda (x)
               (format #f "~a\t~a\t~a\t~a\t~a\t~a\t~a\t~a\t~a\t"
                 (car x) (cadr x) (caddr x) (list-ref x 3) (list-ref x 4)
                 (list-ref x 5) (list-ref x 6) (list-ref x 7) (list-ref x 8)))
             (hw-info)))))
  
  (define (commit-part)
    (case context
      ((inst1) #t)
      (else
        (andmap (lambda (x)
                  (let ((r ((cdr x) 'write/reopen)))
                    (if r r (begin
                              (inst-log "Failed to libfdisk write on ~a\n" (car x))
                              r))))
                part))))
  
  (define (commit)
    (cond
      ((not (write-devicegroup))
        (inst-log "Failed to save /var/lib/ogl/etc/devicegroup .\n")
        #f)
      ((not (write-mountp))
        (inst-log "Failed to save /var/lib/ogl/etc/mountp .\n")
        #f)
      ((not (commit-part))
        (inst-log "Failed to write partition table.\n")
        #f)
      (else
        #t)))
  
  (define (unmount)
    (case context
      ((inst2 recovery)
        (sh "chroot /target /bin/sync")
        (let ((r (map (lambda (x) 
                        (case (list-ref x 6)
                          ((linux-xfs linux-ext2 linux-ext3 linux-reiser linux-jfs)
                            (= 0 (sh "umount /target~a" (list-ref x 4))))
                          (else
                            #t)))
                        (reverse (list-mnt #f)))))
          (inst-log "unmount result : ~a\n" r)
          (andmap (lambda (x) x) r)))
      (else
        #f)))
  
  (define (search-mnt x)
    (let ((r (filter (lambda (y)
                       (and (equal? (car y) (cadr x))
                            (equal? (list-ref y 5) (list-ref x 3))
                            (= (list-ref y 2) (list-ref x 5))
                            (= (list-ref y 3) (list-ref x 6))))
                     mountp)))
      (cond
        ((not (= 1 (length r)))
          "")
        (else
          (list-ref (car r) 4)))))
  
  (define (add-mnt-r did s e p)
    (let ((l (filter (lambda (x)
                       (and (not (eq? 'empty (car x)))
                            (not (id-extended? (list-ref x 8)))
                            (eq? s (list-ref x 5))
                            (eq? e (list-ref x 6))))
                     (list-part did))))
      (inst-log "add-mnt-r : ~a\n" l)
      (cond
        ((not (= 1 (length l)))
          (_ "Could not find partition.\n"))
        (else
          (let* ((q (car l))
                 (f (filter (lambda (x)
                              (and (equal? (car x) (cadr q))
                                   (equal? (cadr x) (list-ref q 3))))
                            to-format)))
            (cond
              ((= 1 (length f))
                (add-mnt (cons (caddr (car f)) (cdr q)) p))
              ((null? f)
                (add-mnt q p))
              (else
                (inst-log "add-mnt-r : internal error. ~s\n" f)
                "Internal error. found several to-be formatted partition.")))))))
  
  (define (add-mnt x p) ; x : partition list / p : path
    (cond
      ((not (and (list? x)
                 (= 9 (length x))))
        (format #f (_ "Illegal argument : ~a") x))
      ((and (not (equal? "swap" p))
            (not (char=? (string-ref p 0) #\/)))
        (_ "Mount point must be absolute path or 'swap'."))
      (else
        (let ((d (cadr x))
              (s (list-ref x 5))
              (e (list-ref x 6)))
          (set! mountp (filter (lambda (y)
                                 (not (and (equal? d (car y))
                                           (equal? s (list-ref y 2))
                                           (equal? e (list-ref y 3)))))
                               mountp))
          (let ((same-area (search-mnt x))
                (same-path (filter (lambda (y) (equal? (list-ref y 4) p))
                                   mountp)))
            (cond
              ((not (string=? "" same-area))
                (_ "Other mount point shares this partition."))
              ((and (not (equal? "swap" p))
                    (not (null? same-path)))
                (_ "Other mount point shares the path."))
              (else
                (let ((newp (list d #f s e p (list-ref x 3) (car x))))
                  (set! mountp (cons newp mountp)))
                #t)))))))
  
  (define (del-mnt p)
    (define (f x) (not (equal? p (list-ref x 4))))
    (set! mountp (filter f mountp))
    #t)
  
  (define (path-mnt p)
    (let ((l (filter (lambda (x) (equal? p (list-ref x 4)))
                     mountp)))
      (cond
        ((null? l) '())
        (else (car l)))))
  
  (define (flag-mnt p f)
    (set! mountp
          (map (lambda (x)
                 (cond
                    ((equal? p (list-ref x 4))
                      (cons (list (car x) f (caddr x) (list-ref x 3) p (list-ref x 5) (list-ref x 6))))
                    (else
                      x)))
               mountp))
    #t)
  
  (define (list-mnt new?)
    (easy-sort (lambda (n m)
                 (< (part-count/ (list-ref n 4))
                    (part-count/ (list-ref m 4))))
               mountp))
  
  (define (check-mnt)
    (cond
      ((null? (filter (lambda (x) (equal? "/" (list-ref x 4)))
                      (list-mnt #t)))
        (_ "No new root partition."))
      (else
        #t)))
  
  (define (list-always-mnt new?)
    (filter (lambda (x)
              (let ((mnt (list-ref x 4)))
                (and (string? mnt)
                     (not (and (< 4 (string-length mnt))
                               (string=? "/mnt" (substring mnt 0 4)))))))
      (list-mnt new?)))
  
  (define (set-fd dev)
    (set! mountp
          (cons (list dev #t -1 -1 "/mnt/floppy" -1 'linux-ext2)
                (filter (lambda (x)
                          (not (equal? "/mnt/floppy" (list-ref x 4))))
                        mountp)))
    #t)
  
  (define (set-media . l)
    (cond
      ((< (length l) 3)
        #f)
      (else
        (let ((p (case (car l)
                   ((cdrom)
                     (list (cadr l) #t -1 -1 "/mnt/deb" -1 'iso9660))
                   ((block)
                     (list (cadr l) #t -1 -1 "/mnt/deb" (list-ref l 4) (list-ref l 3)))
                   ((nfs)
                     (list (format #f "~a:~a" (cadr l) (caddr l))
                           #t -1 -1 "/mnt/deb" -1 'nfs))
                   (else
                     #f))))
          (cond
            ((eq? #f p) #f)
            (else
              (set! mountp
                (append (filter (lambda (x)
                                  (not (equal? "/mnt/deb" (list-ref x 4))))
                                mountp)
                        (list p)))
              #t))))))
  
  (define (domount)
    (define (do x)
      (inst-log (format #f "debug: doing mount of ~s\n" x))
      (case (list-ref x 6)
        ((http ftp) #f)
        (else
          (let ((opt (format #f "-t ~a" (fs->mountopt (list-ref x 6))))
                (dev (case (list-ref x 6)
                       ((nfs) (car x))
                       (else (devfsname (car x) (list-ref x 5)))))
                (p (list-ref x 4)))
            (cond
              ((or (equal? 'swap (list-ref x 6))
                   (equal? "swap" (list-ref x 6)))
                (inst-log "exec : swapon ~a\n" dev)
                (sh "swapon ~a" dev)
                #t)
              (else
                (inst-log "exec : mount ~a /target~a ~a\n" dev p opt)
                (and (= 0 (sh "mkdir -p /target~a" p))
                     (= 0 (sh "mount ~a /target~a ~a" dev p opt)))))))))
    (case context
      ((inst1 inst2 recovery)
        (let ((r (map do (list-always-mnt #f))))
          (inst-log "domount result : ~s\n" r)
          (andmap and r)))
      (else
        #f)))
  
  (define (format-command fs)
    (let ((c (case fs
               ((swap)         "mkswap-progress")
               ((linux-ext2)   "mke2fs")
               ((linux-ext3)   "mke2fs -j")
               ((linux-xfs)    "mkfs.xfs -f")
               ((linux-reiser) "mkreiserfs -f -v 2")
               ((linux-jfs)    "mkfs.jfs -q")
               (else ""))))
               ; ǤϥѥפȤäƤϤʤ
      (cond
        ((equal? "" c)
          c)
        (else
          c))))
          ;(string-append "/usr/sbin/ogl/" c)
  
  (define (whole? did)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o)
          #f)
        (else
          (let* ((p (list-part did))
                 (mount-list (filter (lambda (x) (equal? did (car x)))
                                      mountp))
                 (part-list (filter (lambda (x) (< 9 (length x)))
                                    p)))
            (= (length mount-list) (length part-list)))))))
  
  (define (set-default-fs t)
    (define (replace x)
      (cond
        ((equal? (list-ref x 6) 'linux-unknown)
          (list (car x) (cadr x) (caddr x) (list-ref x 3) (list-ref x 4)
                (list-ref x 5) t))
        (else
          x)))
    (set! mountp (map replace mountp))
    #t)
  
  (define (set-biosorder l)
    (cond
      ((not (list? l))
        #f)
      (else
        (let ((l' (filter (lambda (x)
                            (and (= 2 (length x))
                                 (number? (cadr x))
                                 (case (car x)
                                   ((ide scsi rd ida ataraid) #t)
                                   (else #f))))
                          l)))
          (cond
            ((= (length l) (length l'))
              (set! bios-order l)
              #t)
            (else
              #f))))))
  
  (define (boot-mnt)
    (let* ((lb (filter (lambda (x) (equal? "/boot" (list-ref x 4)))
                       mountp))
           (lr (filter (lambda (x) (equal? "/" (list-ref x 4)))
                       mountp))
           (get (lambda (x)
                  (list (car x) (list-ref x 5) (not (equal? 'linux-xfs (list-ref x 6))))))
           (b (cond
                ((= 1 (length lb))
                  (get (car lb)))
                ((= 1 (length lr))
                  (get (car lr)))
                (else
                  '()))))
      (inst-log "boot-mnt b:~s\n" b)
      (cond
        ((null? b)
          b)
        ((< (cadr b) 5)
          (list (car b) (cadr b) -1 (caddr b)))
        (else
           (let ((e (get-extended (car b))))
             (cond
               ((< e 0)
                 (inst-log "boot-mnt : could not find ext(~a)\n" e)
                 '())
               (else
                 (list (car b) (cadr b) e (caddr b)))))))))
  
  (define (list-did)
    (list-uniq (map car hw-list)))

  (define (list-part did)
    (define (hw-lf->hw d u y)
      (let ((size (lambda (a b) (i/ (* u (1+ (- a b))) 1024))))
        (cons d
              (cond
                ((or (eq? (car y) 'empty)
                      (eq? (car y) 'e-empty))
                  (cons (size (caddr y) (cadr y))
                        y))
                (else
                  (cons (i/ (* u (1+ (- (cadddr y) (caddr y)))) 1024)
                        y))))))
    
    (define (type-map x)
      (case (length x)
        ((5) (cons 'empty x))
        ((8)
          (cons (case (list-ref x 7)
                  ((131)
                    (let* ((n (caddr x))
                           (r (filter (lambda (y) (and (equal? did (car y))
                                                       (equal? n (cadr y))))
                                      to-format)))
                        (cond
                          ((= 1 (length r))
                            (caddr (car r)))
                          (else
                            (fs-by-magic (devfsname did n))))))
                  ((130) 'swap)
                  ((5 15 133) 'ext)
                  (else 'unknown))
                x))
        (else
          (inst-log "some-filter : illegal format ~a\n" x)
          '())))
    (case context
      ((inst1)
        '())
      (else
        (let ((o (part-obj did)))
          (cond
            ((eq? #f o)
              '())
            (else
              (let* ((p (o 'get-partition))
                     (d (o 'get-disk))
                     (u (/ (* (list-ref d 5) (list-ref d 6)) 1024))
                     (c (cadddr d))
                     (l0 (filter hw-partition-valid? p))
                     (l2 (easy-sort (lambda (x y) (< (caddr x) (caddr y))) l0))
                     (l1 (filter (lambda (x) (not (hw-partition-valid? x))) p)))
                (map (lambda (x) (type-map (hw-lf->hw did u x)))
                     (append (hw-s-empty 1 c l2) l1)))))))))
  
  (define (list-all-part dr?)
    (apply append
      (map (lambda (x)
             (let ((l (list-part (car x))))
               (if dr?
                 (cons (list 'dev (car x) (cadr x) (list-ref x 4))
                       l)
                 l)))
           (hw-info))))
  
  (define (did->mnt d)
    (map (lambda (x) (list-ref x 4))
         (filter (lambda (x) (equal? d (car x)))
                 mountp)))
  
  (define (ifname x y)
    (let ((a (case x
               ((ide) "IDE")
               ((scsi) "SCSI")
               ((rd) (_ "RAID (Mylex type)"))
               ((ida) (_ "RAID (Compaq type)"))
               ((ataraid) (_ "RAID (IDE type)"))
               (else (_ "unknown"))))
          (b (case x
               ((ide)
                 (count-smaller-ide-bus y))
               (else
                 y))))
       (format #f "~a(~a)" a b)))
  
  (define (abort-part did)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o) o)
        (else
          (o 'cancel)))))
  
;  (define (abort)
;    (map (lambda (x) (abort-part (car x)))
;         hw-list)
;    (init context)
;    (load-it)
;    #t)
  (define (abort)
    (close-all-part)
    (init context)
    (load-it)
    #t)
  
  (define (close-all-part)
    (map (lambda (x)
           (let ((o (part-obj (car x))))
             (cond
               ((eq? #f o) o)
               (else
                 (o 'abort/close)))))
         hw-list)
    #t)
  
  (define (unit-size did)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o) -1)
        (else
          (o 'unit-size)))))
  
  (define (block-size did)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o) -1)
        (else
          (let ((r (o 'get-disk)))
            (cond
              ((null? r) -1)
              (else
                (list-ref r 6))))))))
  
  (define (get-geom did)
    (let ((o (part-obj did)))
      (cond
        ((eq? #f o) '())
        (else
          (let ((r (o 'get-disk)))
            (cond
              ((null? r) '())
              (else
                (list (list-ref r 3) (cadr r) (caddr r)))))))))
  
  (define (get-fdd)
    (define (search-scsi n)
      (let* ((d (list->string (append (string->list "/dev/sd")
                                      (list (integer->char (+ 97 n))))))
             (s (ioctl-getblocksize d)))
        (cond
          ((= s -1) #f)
          ((= s 2880) d)
          (else (search-scsi (1+ n))))))
    (define (search-unknown)
      (filter (lambda (x) (string? x))
        (map (lambda (x)
               (case (list-ref x 4)
                 ((unknown)
                   (let ((d (devfsname (car x))))
                     (cond
                       ((= 2880 (ioctl-getblocksize d))
                         d)
                       (else
                         #f))))
                 (else
                   #f)))
             hw-list)))
    (cond
      ((equal? 'inst1 context)
        (cond
          ((or (not (read-openable? "/dev/sda"))
               (read-openable? "/dev/fd0"))
            "/dev/fd0")
          (else
            (search-scsi 0))))
      ((not (null? fd-drive))
        (car fd-drive))
      (else
        (let ((r (search-unknown)))
          (cond
            ((not (null? r))
              (car r))
            ((unix-access? "/dev/floppy/0" '(read))
              "/dev/floppy/0")
            (else
              ""))))))
  
  (define (hw-cdrom)
    (filter (lambda (x) (equal? 'cd (list-ref x 4)))
            hw-list))
  
  (define (hw-info)
    (filter (lambda (x) (not (equal? 'fd (list-ref x 4))))
            hw-list))
  
  (define (hw-mid-print limit? l)
    (let* ((mnt (lambda (x)
                 (let ((r (search-mnt x)))
                   (if (string=? "" r)
                       r
                       (string-append ": " r)))))
           (s (cond
                ((eq? 'dev (car l))
                  (sprintf "== %-36s %28s"
                           (did-desc (cadr l))
                           (string-cut (string-append (caddr l) " ==========") 28)))
                ((eq? 'empty (car l))
                  (sprintf " %-17s %7dMB (%5d - %5d Cyl) "
                           (if (eq? 'empty (list-ref l 3))
                             (_ "empty region")
                             (_ "empty in ext"))
                           (caddr l) (list-ref l 4) (list-ref l 5)))
                (else
                  (sprintf (_ "  partition %d      %7dMB (%5d - %5d Cyl) %11s %s ")
                          (list-ref l 3)
                          (caddr l)
                          (list-ref l 5) (list-ref l 6)
                          (let ((r (assoc (list-ref l 8) id-name-db)))
                            (cond
                              ((not (eq? 'unknown (car l)))
                                (symbol->string (car l)))
                              ((eq? #f r)
                                (_ "unknown"))
                              (else
                                (cdr r))))
                          (mnt l)))))
           (len (string-length s)))
      (if (and limit? (< 70 len))
        (substring s 0 70)
        s)))
  
  (define (get-did-by-oldname p)
    (let ((r (filter (lambda (x) (string? x))
               (map (lambda (x)
                      (let ((d (car x)))
                        (if (equal? p (oldname d))
                          d
                          #f)))
                    hw-list))))
      (cond
        ((not (= 1 (length r)))
          "")
        (else
          (car r)))))
  
  (define (sane-table? d)
    (let* ((l (list-part d))
           (g (get-geom d)))
      (cond
        ((null? g)
          #f)
        (else
          (let ((ed (car g)))
            (andmap
              (lambda (x)
                (case (car x)
                  ((empty)
                    #t)
                  (else
                    (and (<= (list-ref x 5) (list-ref x 6))
                         (<= (list-ref x 6) ed)))))
              l))))))
  
  (make-object
    'abort            abort
    'abort-part       abort-part
    'add-mnt          add-mnt
    'add-mnt-r        add-mnt-r
    'block-size       block-size
    'boot-mnt         boot-mnt
    'check-mnt        check-mnt
    'close-all-part   close-all-part
    'commit           commit
    'commit-part      commit-part
    'conf             (lambda () (list (list "/etc/fstab" make-fstab #t)
                                       (list "/boot/grub/device-map" make-devicemap #t)))
    'create-part      create-part
    'del-mnt          del-mnt
    'delete-part      delete-part
    'devfsname        devfsname
    'did-desc         did-desc
    'did->mnt         did->mnt
    'domount          domount
    'flag-mnt         flag-mnt
    'format-command   format-command
    'get-biosnum      did->biosnum
    'get-context      (lambda () context)
    'get-did-by-oldname get-did-by-oldname
    'get-extended     get-extended
    'get-fdd          get-fdd
    'get-geom         get-geom
    'get-part         get-part
    'have-/boot?      have-/boot?
    'have-extended    have-extended
    'hexname          hexname
    'hw-ataraid       hw-ataraid
    'hw-cdrom         hw-cdrom
    'hw-desc          hw-desc
    'hw-disc          hw-disc
    'hw-info          hw-info
    'hw-mid-print     hw-mid-print
    'hw-update        hw-update
    'hw-extra-dev     make-extra-dev
    'hw-get-biosorder (lambda () bios-order)
    'hw-set-biosorder set-biosorder
    'hw-get-ifgroup	  (lambda () default-group)
    'hw-ifname        ifname
    'info-cdrom       info-cdrom
    'info-rem         info-removable
    'init             init
    'list-all-part    list-all-part
    'list-always-mnt  list-always-mnt
    'list-did         list-did
    'list-mnt         (lambda () (list-mnt #f))
    'list-part        list-part
    'load             load-it
    'make-devicemap   make-devicemap
    'mid-conf         (lambda () (list "/var/lib/ogl/etc/devicegroup" "/var/lib/ogl/etc/mountp"))
    'modify-part      modify-part
    'mnt-biosnum      mountp->biosnum
    'oldname          oldname
    'path-mnt         path-mnt
    'parse-name       parse-name
    'mnt->did         mnt->did
    'rest-primary     rest-primary
    'sane-table?      sane-table?
    'search-mnt       search-mnt
    'set-default-fs   set-default-fs
    'set-fd           set-fd
    'set-media        set-media
    'unit-size        unit-size
    'unmount          unmount
    'whole-part?      whole?
    ))
