;
;     Printer Config
;
;                            (C) 2001,2002 Omoikane Inc.
;

(define (conf-print)
  
  ; vars
  (define pdb '())    ; (<name:str> <desc:list> <opts:list> <req:list>) $B$N%j%9%H(B
  (define plist '())  ; (<vendor:str> <model:str> <desc:str> <driver:sym>) $B$N%j%9%H(B
  (define qlist '())
  
  (define filter-head
    (list
      "#!/bin/sh\n"
      "#\n"
      "#   a print filter, generated by ogl-tools.\n"
      "#\n"
      "#                                  (C) 2002 Omoikane Inc.\n"
      "#\n"
      "# features : \n"
      "# - detecting/converting japanese code \n"
      "# - expanding plain text to postscript\n"
      "# - multi queues\n"
      "#\n"
      "\n"
      "while getopts :P: opt\n"
      "do case $opt in\n"
      "  P)\n"
      "    pname=$OPTARG\n"
      "    ;;\n"
      "  *)\n"
      "    ;;\n"
      "esac done\n"
      "\n"
      "if [ \"$pname\" = \"\" ]; then\n"
      "  logger -t 'printer' 'could not get queue name. aborting.'\n"
      "  exit 1\n"
      "fi\n"
      "\n"
      "if [ ! -x \"/usr/bin/kcc\" ]; then\n"
      "  logger -t 'printer' 'could not find kcc.'\n"
      "  exit 1\n"
      "fi\n"
      "\n"
      "if [ ! -x \"/usr/bin/a2psj\" ]; then\n"
      "  logger -t 'printer' 'could not find a2psj.'\n"
      "  exit 1\n"
      "fi\n"
      "\n"
      "if [ ! -x \"/usr/bin/gs\" ]; then\n"
      "  logger -t 'printer' 'could not find gs.'\n"
      "  exit 1\n"
      "fi\n"
      "\n"
      "tmpf=`tempfile`\n"
      "\n"
      "case `dd count=1 2>/dev/null | tee $tmpf | file -b -` in\n"
      "  PostScript*)\n"
      "    logger -t 'printer' 'No pre-filter used. (postscript)'\n"
      "  	filter=\"cat\"\n"
      "  	;;\n"
      "  *text*)\n"
      "    logger -t 'printer' 'using text filter.'\n"
      "    filter=\"kcc -e | a2psj -p -l '' -toc '' -L '' -nh\"\n"
      "  	;;\n"
      "  *)\n"
      "    logger -t 'printer' 'No pre-filter used. (unknown data)'\n"
      "  	filter=\"cat\"\n"
      "    ;;\n"
      "esac\n"
      "\n"
      "tmpout=`tempfile`\n"
      "rm $tmpout\n"
      "mkfifo $tmpout\n"
      "if [ ! \"$?\" = \"0\" ]; then\n"
      "  logger -t 'printer' 'Could not create fifo. aborting.'\n"
      "  rm $tmpout\n"
      "  exit 2\n"
      "fi\n"
      "chmod og-rx $tmpout\n"
      "\n"
      "LANG=ja_JP.ujis\n"
      "export LANG\n"
      "\n"
      "case $pname in\n"))
      
  (define filter-foot
    (list
       "  *)\n"
       "    logger -t 'printer' 'Could not find valid print queue.'\n"
       "  ;;\n"
       "esac\n"
       "\n"
       "rm $tmpf $tmpout\n"))
  
  ; libs
  (define (q->dev q)
    (case (cadr q)
      ((local)
        (format #f "/dev/~a~a"
          (if (equal? 'usb (caddr q)) "usb/lp" "printers/")
          (list-ref q 3)))
      (else
        "")))
  
  (define (bunch-key k x l)
    ;(format #t "x:~s l:~s\n" x l)
    (cond
      ((or (null? l)
           (null? (car l))
           (not (equal? k (caar l))))
        (cons (reverse x) l))
      (else
        (bunch-key k (cons (cdr (car l)) x) (cdr l)))))
  
  (define (block-it l)
    ;(format #t "b\n")
    (cond
      ((null? l)
        #t)
      ((null? (car l))
        (block-it (cdr l)))
      ((not (equal? "name" (caar l)))
        (inst-log "print obj : illegular db line ~s\nsholuld begin with 'name'." (car l))
        #f)
      (else
        (let* ((n (cadr (car l)))
               (d (bunch-key "desc" '() (cdr l)))
               (d' (car d))
               (o (bunch-key "opt" '() (cdr d)))
               (o' (car o))
               (r (bunch-key "req" '() (cdr o)))
               (r' (car r)))
          (cond
            ((null? d') #f)
            (else
              (cons (list (string->symbol n)
                          (cons 'desc d')
                          (cons 'opt o')
                          (cons 'req r'))
                    (cdr r))))))))
   
  (define (rep-block l)
    ;(format #t "c\n")
    (cond
      ((null? l) l)
      (else
        (let ((r (block-it l)))
          (cond
            ((eq? r #t) '())
            ((eq? r #f) #f)
            (else
              (let ((n (rep-block (cdr r))))
                (cond
                  ((eq? #f n) #f)
                  (else
                    (cons (car r) n))))))))))
  
  (define (read-db)
    (let ((r (ttable-read "/usr/lib/ogl/lib/printer-table"
               '(("")
                 ("name" str)
                 ("desc" str str str)
                 ("opt" str str int str str str)
                 ("opt" str str int str str str str str)
                 ("opt" str str int str str str str str str str)
                 ("opt" str str int str str str str str str str str str)
                 ("opt" str str int str str str str str str str str str str str)
                 ("opt" str str int str str str str str str str str str str str str str)
                 ("opt" str str int str str str str str str str str str str str str str str str)
                 ("opt" str str int str str str str str str str str str str str str str str str str str)
                 ("opt" str str int str str str str str str str str str str str str str str str str str str str)
                 ("opt" str str int str str str str str str str str str str str str str str str str str str str str str)
                 ("req" str str)))))
      (cond
        ((eq? #f r)
          (_ "Could not read printer DB. (/usr/lib/ogl/lib/printer-table broken?)"))
        (else
          ;(format #t "~a\n" r)
          (let ((t (rep-block (filter (lambda (x) (not (equal? "" (car x))))
                                      r))))
            (cond
              ((eq? #f t)
                (_ "Parsing printer DB failed."))
              (else
                (set! pdb t)
                #t)))))))
  
  (define (set-plist)
    (set! plist
      (easy-sort
        (lambda (a b)
          (if (string=? (car a) (car b))
            (string<? (cadr a) (cadr b))
            (string<? (car a) (car b))))
        (filter (lambda (x) (not (equal? "unknown" (car x))))
          (apply append
            (map (lambda (x)
                   (map (lambda (y)
                          (list (car y) (cadr y) (caddr y) (car x)))
                        (cdr (assoc 'desc (cdr x)))))
                 pdb))))))
  
  (define (check-queue x)
    (define (check-opt l)
      (cond
        ((null? l) #t)
        ((null? (cdr l))
          (inst-log "print obj : odd number of length of option\n")
          #f)
        ((and (string? (car l))
              (integer? (cadr l)))
          (check-opt (cddr l)))
        (else
          (inst-log "print obj : irregular option\n")
          #f)))
    (cond
      ((not (and (list? x)
                 (< 3 (length x))
                 (string? (car x))
                 (symbol? (cadr x))))
        (inst-log "print obj : irregular queue ~s\n" x)
        #f)
      (else
        (let ((len (length x)))
          (case (cadr x)
            ((local)
              (and (< 4 len)
                   (case (caddr x)
                     ((usb par) #t)
                     (else #f))
                   (integer? (list-ref x 3))
                   (symbol? (list-ref x 4))
                   (check-opt (cddr (cddr (cdr x))))))
            ((lp)
              (and (< 4 len)
                   (string? (caddr x))
                   (string? (list-ref x 3))
                   (symbol? (list-ref x 4))
                   (check-opt (cddr (cddr (cdr x))))))
            (else
              (inst-log "print obj : unsupported type ~a\n" x)
              #f))))))
  
  (define (make-cap f)
    (fprintf f
      (apply string-append
        (apply append
          (map (lambda (l)
                 (cons (format #f "~a:\n" (car l))
                   (case (cadr l)
                     ((local)
                       (list
                         (format #f "  :lp=~a\n" (q->dev l))
                         (format #f "  :sd=/var/spool/lpd/~a\n" (car l))
                         (if (equal? '- (list-ref l 4)) "" "  :if=/etc/printfilter\n")
                         "  :mx#0\n  :sh\n\n"))
                     ((lp)
                       (list
                         (format #f
                           (if (equal? '- (list-ref l 4))
                             "  :lp=~a@~a\n  :sd=/var/spool/lpd/remote\n  :mx#0\n  :sh\n\n"
                             "  :bq=~a@~a\n  :sd=/var/spool/lpd/remote\n  :if=/etc/printfilter\n")
                           (list-ref l 3) (caddr l))))
                     (else
                       (inst-log "make-cap : unknown data : ~s\n" l)
                       (list "")))))
               qlist)))))
  
  (define (make-gsopt l m)
    (inst-log "gsopt : ~s ~s\n" l m)
    (define (rep l)
      (cond
        ((or (null? l) (null? (cdr l)))
          (list ""))
        (else
          (let ((r (assoc (car l) m)))
            (cons 
              (cond
                ((eq? #f r)
                  (inst-log "print obj : illregal option ~s\n" l)
                  "")
                (else
                  (let ((a (1+ (* 2 (cadr l)))))
                    (cond
                      ((<= (length (cddr (cddr r))) a)
                        (inst-log "print obj : illregal option reference ~s\n" l)
                        "")
                      (else
                        (string-append " "
                          (format #f (list-ref r 3)
                            (list-ref (cddr (cddr r)) a))))))))
              (rep (cddr l)))))))
    (apply string-append (rep l)))
  
  (define (make-filter f)
    (and 
      (fprintf f
        (apply string-append
          (append
            filter-head
            (apply append
              (map (lambda (x)
                     (let ((d (list-ref x 4)))
                       (case d
                         ((-)
                           (list ""))
                         (else
                           (let ((db (assoc d pdb)))
                             (cond
                               ((eq? #f db)
                                 (inst-log "could not find ~a in pdb\n" d)
                                 (list "  # an entry could not find.\n"))
                               (else
                                 (let ((req (cdr (assoc 'req (cdr db)))))
                                   (cond
                                     ((null? req)
                                       (list
                                         (format #f "  ~a)\n" (car x))
                                         (format #f "    cat $tmpf - | eval $filter | gs -q -dSAFER -dNOPAUSE -sDEVICE=~a~a\\\n"
                                           d
                                           (make-gsopt (cddr (cddr (cdr x)))
                                                       (cdr (assoc 'opt (cdr db)))))
                                         "      -sOutputFile=$tmpout - -c quit 2>&1 | logger -t 'printer' &\n"
                                         "    cat $tmpout\n"
                                         "  ;;\n"))
                                     ; $B$R$H$^$:(B buggy $B$J(B pips $B$N$_$rA[Dj!#(B
                                     (else
                                       (list
                                         (format #f "  ~a)\n" (car x))
                                                    "    tmpf2=`tempfile`\n"
                                                    "    chmod og-rw $tmpf2\n"
                                                    "    cat $tmpf - | eval $filter >$tmpf2\n"
                                         (format #f "    ~a <$tmpf2 2>/dev/null\n" (cadr (car req)))
                                                    "    rm $tmpf2\n"
                                         "  ;;\n")))))))))))
                   qlist))
            filter-foot)))
      (= 0 (sh "chmod a+x ~a" f))))
  
  ; method
  
  (define (commit)
    (ttable-write "/var/lib/ogl/etc/print" qlist))
  
  (define (init)
    (let ((r0 (read-db)))
      (cond
        ((string? r0)
          r0)
        (else
          (set-plist)
          #t))))
  
  (define (update l)
    (cond
      ((not (check-queue l))
        #f)
      (else
        (let* ((q (car l))
               (r (assoc q qlist)))
          (set! qlist
            (cond
              ((eq? #f r)
                (append qlist (list l)))
              (else
                (map (lambda (x)
                       (if (equal? (car x) q)
                         l
                         x))
                     qlist))))
          #t))))
  
  (define (load-it)
    (cond
      ((not (unix-access? "/var/lib/ogl/etc/print" '(read)))
        #t)
      (else
        (let ((r (ttable-read "/var/lib/ogl/etc/print"
                   '((str "local" sym int sym)
                     (str "local" sym int sym str int)
                     (str "local" sym int sym str int str int)
                     (str "local" sym int sym str int str int str int)
                     (str "local" sym int sym str int str int str int str int)
                     (str "local" sym int sym str int str int str int str int str int)
                     (str "local" sym int sym str int str int str int str int str int str int)
                     (str "local" sym int sym str int str int str int str int str int str int str int)
                     (str "local" sym int sym str int str int str int str int str int str int str int str int)
                     (str "local" sym int sym str int str int str int str int str int str int str int str int str int)
                     (str "local" sym int sym str int str int str int str int str int str int str int str int str int str int)
                     (str "lp"    str str sym)
                     (str "lp"    str str sym str int)
                     (str "lp"    str str sym str int str int)
                     (str "lp"    str str sym str int str int str int)
                     (str "lp"    str str sym str int str int str int str int)
                     (str "lp"    str str sym str int str int str int str int str int)
                     (str "lp"    str str sym str int str int str int str int str int str int)
                     (str "lp"    str str sym str int str int str int str int str int str int str int)
                     (str "lp"    str str sym str int str int str int str int str int str int str int str int)
                     (str "lp"    str str sym str int str int str int str int str int str int str int str int str int)
                     (str "lp"    str str sym str int str int str int str int str int str int str int str int str int str int)
                     ))))
          (cond
            ((eq? #f r) #f)
            (else
              (let ((r' (map (lambda (x)
                               (cons (car x) (cons (string->symbol (cadr x)) (cddr x))))
                             r)))
                (cond
                  ((not (andmap check-queue r'))
                    #f)
                  (else
                    (set! qlist r')
                    #t)))))))))
  
  (define (remove q)
    (let ((r (assoc q qlist)))
      (cond
        ((eq? #f r) #f)
        (else
          (set! qlist (filter (lambda (x) (not (equal? q (car x))))
                              qlist))
          #t))))
  
  (define (descq q)
    (let ((r (assoc q qlist)))
      (sprintf "%-12s : %s\n"
        q
        (cond
          ((eq? #f r) (_ "unknown printer"))
          (else
            (format #f "~a~a printer~a"
              (case (cadr r)
                ((local) (_ "Local"))
                (else (_ "Network")))
              (case (list-ref r 4)
                ((-) " PostScrpt")
                (else ""))
              (case (cadr r)
                ((lp) "(lp)")
                ((smb) "(smb)")
                (else ""))))))))
  
  (define (get-extfilter q)
    (let ((r0 (assoc q qlist)))
      (cond
        ((eq? #f r0) "")
        (else
          (let ((r1 (assoc (list-ref r0 4) pdb)))
            (cond
              ((eq? #f r1) "")
              (else
                (let ((r2 (assoc 'req (cdr r1))))
                  (cond
                    ((null? (cdr r2))
                      "")
                    (else
                      (car (cadr r2))))))))))))
  
  (define (get-gsdb d)
    (let ((r0 (assoc d pdb)))
      (cond
        ((eq? #f r0) '())
        (else
          (let ((r1 (assoc 'opt (cdr r0))))
            (cond
              ((eq? #f r1) '())
              (else (cdr r1))))))))

  (define (pick-odd l)
    (cond
      ((or (null? l) (null? (cdr l)))
        '())
      (else
        (cons (car l) (pick-odd (cddr l))))))
    
  (define (pick-even l)
    (cond
      ((or (null? l) (null? (cdr l)))
        '())
      (else
        (cons (cadr l) (pick-even (cddr l))))))
  
  (define (get-optkey q)
    (let ((l (assoc q qlist)))
      (cond
        ((eq? #f l) '())
        (else (pick-odd (cddr (cddr (cdr l))))))))
  
  (define (get-optval q)
    (let ((l (assoc q qlist)))
      (cond
        ((eq? #f l) '())
        (else (pick-even (cddr (cddr (cdr l))))))))
  
  (define (get-optassoc q)
    (map (lambda (x y) (cons x y))
      (get-optkey q)
      (get-optval q)))
  
  (define (assoc->list l)
    (cond
      ((null? l) l)
      (else
        (let ((h (car l)))
          (cons (car h)
            (cons (cdr h)
              (assoc->list (cdr l))))))))
  
  (define (need-package? q)
    (let ((p (get-extfilter q)))
      (cond
        ((equal? "" p)
          #f)
        (else
          (let ((r (sh "dpkg -l | grep '^ii  ~a'" p)))
            (case r
              ((0) #f)
              ((1) #t)
              (else
                (inst-log "need-package : command failed(dpkg,grep)\n")
                #f)))))))
  
  (define (force-stop)
    (define (kill-it d o)
      (sh "lsof | grep ~a | awk '{print $2}' | xargs kill ~a" d o))
    (cond
      ((not (= 0 (sh "lprm -a")))
        (_ "Removing print queue failed. (ie. lprm failed)"))
      ((not (= 0 (sh "/etc/init.d/lprng stop")))
        (_ "Stopping daemon failed."))
      (else
        (map (lambda (x)
               (case (cadr x)
                 ((local)
                   (let ((d (q->dev x)))
                     (kill-it d "")
                     (unix-sleep 1)
                     (kill-it d "-9"))
                   #t)
                 (else
                   (sh "killall lpr")
                   #t)))
             qlist)
        (map (lambda (x) (sh "rmmod ~a" x))
          '("printer" "lp" "parport_pc" "parport"))
        #t)))
  
  (define (lpd-start)
    (map (lambda (x) (sh "modprobe ~a" x))
      '("printer" "lp"))
    (cond
      ((not (= 0 (sh "/etc/init.d/lprng start")))
        (_ "Starting daemon failed."))
      (else
        #t)))
  
  (define (test-print q)
    (let* ((tmp (unix-tempname))
           (r (assoc q qlist)))
      (cond
        ((eq? #f r)
          (_ "No such a queue."))
        ((not (make-filter tmp))
          (_ "Could not create temporary file.\n"))
        ((not (= 0 
                (case (cadr r)
                  ((local)
                    (sh "~a -P~a </usr/lib/ogl/lib/testprint.ps >~a &" tmp (car r) (q->dev r)))
                  (else
                    (let ((touch? (not (unix-access? "/etc/printcap" '(read)))))
                      (if touch? (sh "touch /etc/printcap"))
                      (let ((n (sh "lpr -P~a@~a /usr/lib/ogl/lib/testprint.ps &" (list-ref r 3) (caddr r))))
                        ;(if touch? (sh "rm /etc/printcap"))
                        n))))))
          (format #f (_ "Failed sending data.")))
        (else
          #t))))
  
  (make-object
    'assoc->list    assoc->list
    'commit         commit
    'conf           (lambda () (list (list "/etc/printcap" make-cap #t)
                                     (list "/etc/printfilter" make-filter #t)))
    'db             (lambda () pdb)
    'descq          descq
    'force-stop     force-stop
    'get-extfilter  get-extfilter
    'get-gsdb       get-gsdb
    'get-optassoc   get-optassoc
    'get-optkey     get-optkey
    'get-optval     get-optval
    'get-plist      (lambda () plist)
    'getq           (lambda (q) (assoc q qlist))
    'init           init
    'info           (lambda () qlist)
    'list-driver    (lambda () (map car pdb))
    'load           load-it
    'make-cap       make-cap
    'make-filter    make-filter
    'mid-conf       (lambda () (list "/var/lib/ogl/etc/print"))
    'need-package?  need-package?
    'pick-odd       pick-odd
    'pick-even      pick-even
    'qlist          (lambda () (map car qlist))
    'remove         remove
    'lpd-start      lpd-start
    'test-print     test-print
    'update         update
    ))


