;
;   object for product type
;
;                                   (C)2002 Omoikane Inc.
;

(define (conf-prod obj-net obj-sv)
  
  ; var
  (define orca-type 'unset)            ; 'primary/secondary/single/client/unset $B$N$$$:$l$+(B
  (define gl '(("" 8000) ("" 8000)))   ; primary/secondary $B$N%[%9%H(B IP/$B%]!<%H!#(B
  (define medid "JPN000000000000")     ; $B0eNE5!4X(B ID
  (define orca-init 0)                 ; $B=i4|2=$N40N;DxEY!#(B
    ;   0 $B=i4|2=L$<B;\(B
    ;  20 $B%5!<%PBT5!(B
    ;  40 DB $B=i4|2=(B
    ;  60 $B0eNE5!4X(B ID $B=i4|2=(B
    ;  80 $B%^%9%?!<%Q%9%o!<%IF~NO:Q(B
    ; 100 $B40N;(B
  
  ; lib
  (define (primary?)
    (equal? orca-type 'primary))
  
  (define (make-glserver.list f)
    (fprintf f
      (apply string-append
        (map (lambda (x)
               (if (equal? "" (car x))
                 ""
                 (format #f "~a ~a\n" (obj-net 'resolv (car x)) (cadr x))))
             gl))))
  
  (define (make-hba.conf f)
    (let ((head "# This file is generated by ogl-tools\n"))
      (fprintf f
        (case orca-type
          ((primary)
            (string-append head
              "local\tall\t\t\treject\n"
              "host\tall\t127.0.0.1\t255.255.255.255\ttrust\n"
              "host\tall\t0.0.0.0\t0.0.0.0\treject\n"))
          ((secondary)
            (string-append head
              "local\tall\t\t\ttrust\n"
              "host\tall\t127.0.0.1\t255.255.255.255\ttrust\n"
              (format #f "host\tall\t~a\t255.255.255.255\ttrust\n" (obj-net 'resolv (caar gl)))
              "host\tall\t0.0.0.0\t0.0.0.0\treject\n"))
          (else
            (string-append head
              "local\tall\t\t\tident sameuser\n"
              "host\tall\t127.0.0.1\t255.255.255.255\ttrust\n"
              "host\tall\t0.0.0.0\t0.0.0.0\treject\n"))))))
  
  (define (make-postgresql.conf f)
    (let ((head "# This file is generated by ogl-tools\n"))
      (fprintf f
        (case orca-type
          ((primary)
            (string-append head
              "#\n"
              "# This file consists of lines of the form\n"
              "#\n"
              "#   name = value\n"
              "#\n"
              "# (The `=' is optional.) White space is collapsed, comments are\n"
              "# introduced by `#' anywhere on a line. The complete list of option\n"
              "# names and allowed values can be found in the PostgreSQL\n"
              "# documentation. Examples are:\n"
              "\n"
              "#log_connections = on\n"
              "#fsync = off\n"
              "#max_connections = 64\n"
              "\n"
              "# Any option can also be given as a command line switch to the\n"
              "# postmaster, e.g., 'postmaster -c log_connections=on'. Some options\n"
              "# can be set at run-time with the 'SET' SQL command.\n"
              "\n"
              "# See /usr/share/doc/postgresql/README.postgresql.conf.gz for a full list\n"
              "# of the allowable options\n"
              "\n"
              "debug_level = 0\n"
              "log_connections = on\n"
              "log_pid = on\n"
              "log_timestamp = on\n"
              "syslog = 2\n"
              "# if syslog is 0, turn silent_mode off!\n"
              "silent_mode = off\n"
              "syslog_facility = LOCAL0\n"
              "trace_notify = off\n"
              "max_connections = 64\n"
              "# shared_buffers must be at least twice max_connections, and not less than 16\n"
              "shared_buffers = 128\n"
              "# TCP/IP access is allowed by default, but the default access given in\n"
              "# pg_hba.conf will permit it only from localhost, not other machines.\n"
              "tcpip_socket = true\n"
              "port = 5434\n"))
          ((secondary single)
            (string-append head
               "#\n"
               "# This file consists of lines of the form\n"
               "#\n"
               "#   name = value\n"
               "#\n"
               "# (The `=' is optional.) White space is collapsed, comments are\n"
               "# introduced by `#' anywhere on a line. The complete list of option\n"
               "# names and allowed values can be found in the PostgreSQL\n"
               "# documentation. Examples are:\n"
               "\n"
               "#log_connections = on\n"
               "#fsync = off\n"
               "#max_connections = 64\n"
               "\n"
               "# Any option can also be given as a command line switch to the\n"
               "# postmaster, e.g., 'postmaster -c log_connections=on'. Some options\n"
               "# can be set at run-time with the 'SET' SQL command.\n"
               "\n"
               "# See /usr/share/doc/postgresql/README.postgresql.conf.gz for a full list\n"
               "# of the allowable options\n"
               "\n"
               "debug_level = 0\n"
               "log_connections = on\n"
               "log_pid = on\n"
               "log_timestamp = on\n"
               "syslog = 2\n"
               "# if syslog is 0, turn silent_mode off!\n"
               "silent_mode = off\n"
               "syslog_facility = LOCAL0\n"
               "trace_notify = off\n"
               "max_connections = 64\n"
               "# shared_buffers must be at least twice max_connections, and not less than 16\n"
               "shared_buffers = 128\n"
               "# TCP/IP access is allowed by default, but the default access given in\n"
               "# pg_hba.conf will permit it only from localhost, not other machines.\n"
               "tcpip_socket = true\n"))
          (else ; same as default
               "#\n"
               "# PostgreSQL configuration file\n"
               "# -----------------------------\n"
               "#\n"
               "# This file consists of lines of the form\n"
               "#\n"
               "#   name = value\n"
               "#\n"
               "# (The `=' is optional.) White space is collapsed, comments are\n"
               "# introduced by `#' anywhere on a line. The complete list of option\n"
               "# names and allowed values can be found in the PostgreSQL\n"
               "# documentation. Examples are:\n"
               "\n"
               "#log_connections = on\n"
               "#fsync = off\n"
               "#max_connections = 64\n"
               "\n"
               "# Any option can also be given as a command line switch to the\n"
               "# postmaster, e.g., 'postmaster -c log_connections=on'. Some options\n"
               "# can be set at run-time with the 'SET' SQL command.\n"
               "\n"
               "# See /usr/share/doc/postgresql/README.postgresql.conf.gz for a full list\n"
               "# of the allowable options\n"
               "\n"
               "debug_level = 0\n"
               "log_connections = on\n"
               "log_pid = on\n"
               "log_timestamp = on\n"
               "syslog = 2\n"
               "# if syslog is 0, turn silent_mode off!\n"
               "silent_mode = off\n"
               "syslog_facility = LOCAL0\n"
               "trace_notify = off\n"
               "max_connections = 64\n"
               "# shared_buffers must be at least twice max_connections, and not less than 16\n"
               "shared_buffers = 128\n"
               "# TCP/IP access is allowed by default, but the default access given in\n"
               "# pg_hba.conf will permit it only from localhost, not other machines.\n"
               "tcpip_socket = 1\n")))))
  
  (define (make-postmaster.conf f)
    (fprintf f
      (string-append
        "# /etc/postgresql/postmaster.conf\n"
        "#\n"
        "# Copyright (c) Oliver Elphick 1997, 2001\n"
        "# Part of the Debian package, postgresql. The Debian packaging is\n"
        "# licensed under GPL v.2\n"
        "#\n"
        "# This is the configurable initialisation of the postgresql package\n"
        "# The defaults are shown, but are commented out.\n"
        "#\n"
        "# As of release 7.1, many parameters may now be found in\n"
        "# /etc/postgresql/postgresql.conf.  To avoid confusion, these can\n"
        "# no longer be set here, even though the command line options that\n"
        "# used to control them do still exist.\n"
        "#\n"
        "\n"
        "POSTGRES_HOME=`getent passwd postgres | awk -F: '{print $6}' | head -1`\n"
        "if [ -z \"$POSTGRES_HOME\" ]\n"
        "then\n"
        "    POSTGRES_HOME=/var/lib/postgres\n"
        "fi\n"
        "\n"
        "# Where to find the PostgreSQL database files, including those that\n"
        "# define PostgresSQL users and permissions.\n"
        "# POSTGRES_DATA=/var/lib/postgres/data\n"
        "\n"
        "# Where to send logging and debugging traces.  By default, very little\n"
        "# should appear here, because SYSLOG is set to 2 in postgresql.conf, so\n"
        "# that all messages are sent to syslog only.\n"
        "# POSTGRES_LOG=/var/log/postgres.log\n"
        "\n"
        "# How (by default) to present dates to the frontend; the user can override\n"
        "# this setting for his own session. The choices are:\n"
        "#   Style      Date            Datetime\n"
        "#   ----------------------------------------------------------------\n"
        "#   ISO        1999-07-17      1999-07-17 07:09:18+01\n"
        "#   SQL        17/07/1999      17/07/1999 07:09:19.00 BST\n"
        "#   POSTGRES   17-07-1999      Sat 17 Jul 07:09:19 1999 BST\n"
        "#   GERMAN     17.07.1999      17.07.1999 07:09:19.00 BST\n"
        "#\n"
        "# It is also possible to specify month-day or day-month ordering in date\n"
        "# input and output.  Americans tend to use month-day; Europeans use\n"
        "# day-month.  Specify European or nonEuropean. Separate the two parameters\n"
        "# by a comma with no spaces\n"
        "# PGDATESTYLE=ISO,European\n"
        "\n"
        "# Any special options to pass to the postmaster through pg_ctl's -o option.\n"
        "# This may include such options as \"-h hostname\", for which there is no\n"
        "# parameter defined.  However most options can be set by editing\n"
        "# postgresql.conf appropriately.  \n"
        (format #f "POSTMASTER_OPTIONS=\"~a\"\n"
          (case orca-type
            ((unset) "")
            (else "-i")))
        "\n"
        "# Minimum number of entries in the kernel file table.  If the table size is\n"
        "# lower, postgresql.startup attempts to increase it by writing this parameter \n"
        "# into /proc/sys/kernel/file-max.  This is only effective if the kernel has\n"
        "# been compiled to support run-time configuration.\n"
        "# KERNEL_FILE_MAX=1032\n"
        (case orca-type
          ((primary)
            (string-append
              "#\n# Ignore PGPORT value  defined in /etc/profile \n#\n"
              "if [ -n \"$PGPORT\" ] \n"
              "then\n"
              "        unset PGPORT\n"
              "fi\n"))
          (else "")))))
  
  (define (make-usorc f)
    (fprintf f
      (string-append
        "#\n"
        "# usogres run command file\n"
        "#\n"
        "\n"
        "# host address that usogres performed\n"
        "host = \"127.0.0.1\"\n"
        "# port address that usogres performed\n"
        "port = 5432\n"
        "\n"
        "# host address that postgres original server performed\n"
        "hostorg = \"127.0.0.1\"\n"
        "# port address that postgres original server performed\n"
        "portorg = 5434\n"
        "\n"
        "# host address that postgres backup server performed\n"
        (format #f "hostcopy = \"~a\"\n"
          (case orca-type
            ((primary) (obj-net 'resolv (car (cadr gl))))
            (else "127.0.0.1")))
        "# port address that postgres backup server performed\n"
        "portcopy = 5432\n"
        "\n"
        "# directory for log files\n"
        "logdir = /var/log/usogres\n"
        "\n"
        "# max number of usogres process\n"
        "max_process = 64\n")))
  
  (define (service-port s)
    (let* ((r (assoc s (append
                         (if (primary?)
                           (list (cons 'postgresql 5434) (cons 'usogres 5432))
                           (list (cons 'postgresql 5432)))
                         (list (cons 'glauth 8001) (cons 'glserver 8000) (cons 'monitor 9000))))))
      (inst-log "r:~a\n" r)
      (cond
        ((eq? #f r) -1)
        (else (cdr r)))))
  
  (define (service-run l)
    (map (lambda (x)
           (cond
             ((and (equal? x "monitor") (not (unix-connect? "127.0.0.1" 5432)))
               #f)
             (else
               (obj-sv 'start x)
               (unix-sleep 1))))
         l)
    (filter string?
      (map (lambda (x)
             (if (unix-connect? "127.0.0.1" (service-port x))
               #t
               x))
           l)))
  
  (define (service-stop l)
    (map (lambda (x)
           (obj-sv 'remove x)
           (unix-sleep 1))
         l)
    (filter string?
      (map (lambda (x)
             (cond
               ((equal? 'postgresql x)
                 #t)
               ((unix-connect? "127.0.0.1" (service-port x))
                 x)
               (else
                 #t)))
           l)))
  
  (define (run-base-server)
    (service-run
      (if (primary?)
        (list 'postgresql 'usogres)
        (list 'postgresql))))
  
  (define (stop-base-server)
    (service-stop
      (if (primary?)
        (list 'usogres 'postgresql)
        (list 'postgresql))))
  
  (define (run-app-server)
    (service-run (list 'glauth 'monitor 'glserver)))
  
  (define (stop-app-server)
    (service-stop (list 'glserver 'monitor 'glauth)))
  
  
  ; method
  (define (commit)
    (and (ttable-write "/var/lib/ogl/etc/orca-type"
           (list (list orca-type orca-init)))
         (ttable-write "/var/lib/ogl/etc/orca-gl" gl)
         (fprintf "/var/lib/ogl/etc/orca-medid" medid)))
  
  (define (load-it)
    (and (let ((r (ttable-read "/var/lib/ogl/etc/orca-type" '((sym int)))))
           (cond
             ((eq? r #f)
               #t)
             ((or (null? r) (< 1 (length r)))
               #f)
             (else
               (let* ((x (car r))
                      (n (cadr x)))
                 (cond
                   ((or (< n 0) (< 100 n))
                     #f)
                   (else
                     (set! orca-type (car x))
                     (set! orca-init (cadr x))
                     #t))))))
         (let ((r (ttable-read "/var/lib/ogl/etc/orca-gl" '((str int)))))
           (cond
             ((eq? #f r) #t)
             ((not (= 2 (length r))) #f)
             (else
               (set! gl r)
               #t)))
         (let ((r (parse-awk #\space #t "/var/lib/ogl/etc/orca-medid")))
           (cond
             ((eq? r #f)
               #t)
             ((or (null? r) (null? (car r)))
               #f)
             (else
               (set! medid (caar r))
               #t)))))
  
  (define (set-orcatype t)
    (set! orca-type t)
    #t)
  
  (define (update-primary h n)
    (set! gl (list (list h n) (cadr gl)))
    #t)
    
  (define (update-secondary h n)
    (set! gl (list (car gl) (list h n)))
    #t)
  
  (define (desc-orcatype)
    (case orca-type
      ((primary) (_ "Primary Server"))
      ((secondary) (_ "Secondary Server"))
      ((client) (_ "Client"))
      (else (_ "Not set yet"))))
  
  (define (stat-server)
    (let ((c0 (unix-connect? "127.0.0.1" 8000))
          (c1 (unix-connect? "127.0.0.1" 5432)))
      (cond
        ((and c0 c1)
          'work)
        (c1
          'wait)
        (c0
          'error)
        ((and (equal? orca-type 'primary)
              (unix-connect? "127.0.0.1" 5434))
          'semi-wait)
        (else
          'stop))))
  
  (define (desc-server)
    (case (stat-server)
      ((work) (_ "Working"))
      ((wait) (_ "Waiting"))
      ((error) (_ "Error"))
      ((semi-wait) (_ "Semi-waiting"))
      ((stop) (_ "Stopped"))
      (else (_ "unknown"))))
  
  (define (connect? h)
    (unix-connect? (obj-net 'resolv h) 5432))
  
  (define (connect-backend? h)
    (unix-connect? (obj-net 'resolv h) 5434))
  
  (define (run-server)
    (append (run-base-server) (run-app-server)))
  
  (define (stop-server)
    (append (stop-app-server) (stop-base-server)))
  
  (define (wait-server)
    (append (stop-app-server) (run-base-server)))
  
  (define (semiwait-server)
    (let ((r1 (stop-app-server))
          (r2 (service-stop (list 'usogres)))
          (r3 (service-run (list 'postgresql))))
      (append r1 r2 r3)))
  
  (define (update-medid m)
    (set! medid m)
    (= 0 (sh "echo '\ny\n' | su postgres /home/orca/orca-hospid-set.sh ~a" m)))
  
  (define (init-orca)
    (cond
      ((not (= 20 orca-init))
        (inst-log
          (if (< 20 orca-init)
            "init-orca already initialized.\n"
            "service doesn't seem to be in wait status.\n"))
        #f)
      ((not (= 0 (sh "/usr/local/orca/init/orca-db-create.sh")))
        (inst-log "init-orca orca-db-create.sh failed.\n")
        #f)
      ((not (= 0 (sh "/usr/local/orca/init/orca-db-install.sh")))
        (inst-log "init-orca orca-db-install.sh failed.\n")
        #f)
      (else
        (set! orca-init 40)
        #t)))
  
  (define (auto-refresh-cmd)
    "/usr/sbin/ogl/orca-auto-refresh")
  
  (define (refresh-cmd)
    (format #f "orcadump-ogl 127.0.0.1 5434 - | orcadumpref-ogl ~a 5432 -" (car (cadr gl))))
  
  (define (recover-secondary)
    (let ((cmd (refresh-cmd)))
      (inst-log "recover-secondary, exec : ~s\n" cmd)
      (sh cmd)))
  
  (define (recover-primary)
    (sh "orcadump-ogl ~a 5432 - | orcadumpref-ogl 127.0.0.1 5434 -" (car (cadr gl))))
  
  (define (secondary-test h)
    (let* ((ip (obj-net 'resolv h))
           (tmp (unix-tempname))
           (tmpdb (format #f "orcatestdb~a" (random)))
           (rm (lambda () (sh "rm -f ~a" tmp))))
      (cond
        ((not (unix-connect? ip 5432))
          (_ "Could not connect to the secondary server. "))
        ((not (= 0 (sh "psql -l -U postgres -h ~a -p 5432 template1 >~a" ip tmp)))
          (rm)
          (_ "Could not execute read SQL (DB access) to the secondary server. "))
        ((not (and (= 0 (sh "createdb -U postgres -h ~a -p 5432 ~a" ip tmp))
                   (= 0 (sh "dropdb -U postgres -h ~a -p 5432 ~a" ip tmp))))
          (rm)
          (_ "Could not execute write access to the secondary server. "))
        (else
          (rm)
          #t))))
  
  (define (ip-or-resolv? h)
    (or (obj-net 'match-add4? h)
        (not (equal? "" (obj-net 'resolv h)))))
  
  ; $B%P%C%/%"%C%WCf$N2DG=@-$rJV$9(B
  (define (secondary-busy?)
    (let* ((h (obj-net 'resolv (caar gl)))
           (l (map string->number (string-match h "[0-9]\\+"))))
      (cond
        ((not (and (= (length l) 4)
                   (andmap number? l)))
          #t)
        (else
          (let ((hex (apply string-append
                       (map (lambda (x) (sprintf "%02x" x))
                          (reverse l)))))
            (inst-log "secondary-busy?, pattern ':1538 ~a:'\n" hex)
            (case (sh "grep -i ':1538 ~a:' /proc/net/tcp" hex)
              ((1) #f)
              (else #t)))))))
  
  (define (have-mail?)
    (or (obj-sv 'start? "qmail")
        (obj-sv 'start? "postfix")))
  
  (define (start-mail)
    (let ((r0 (obj-sv 'start "qmail"))
          (r1 (obj-sv 'start "postfix")))
      (or r0 r1)))
  
  (make-object
    'auto-refresh-cmd  auto-refresh-cmd
    'commit            commit
    'conf              (lambda () (list (list "/etc/glserver.list" make-glserver.list #t)
                                        (list "/etc/postgresql/pg_hba.conf" make-hba.conf #t)
                                        (list "/etc/postgresql/postgresql.conf" make-postgresql.conf #t)
                                        (list "/etc/postgresql/postmaster.conf" make-postmaster.conf #t)
                                        (list "/etc/usogresrc" make-usorc #t)))
    'connect?          connect?
    'connect-backend?  connect-backend?
    'desc-orcatype     desc-orcatype
    'desc-server       desc-server
    'get-gl            (lambda () (map car gl))
    'get-primary       (lambda () (caar gl))
    'get-secondary     (lambda () (car (cadr gl)))
    'get-orcatype      (lambda () orca-type)
    'get-medid         (lambda () medid)
    'get-initstep      (lambda () orca-init)
    'have-mail?        have-mail?
    'init-orca         init-orca
    'load              load-it
    'mid-conf          (lambda () (list "/var/lib/ogl/etc/orca-type" "/var/lib/ogl/etc/orca-gl"))
    'product-type      product-type
    'recover-primary   recover-primary
    'recover-secondary recover-secondary
    'ip-or-resolv?     ip-or-resolv?
    'run-server        run-server
    'secondary-busy?   secondary-busy?
    'secondary-test    secondary-test
    'service-port      service-port
    'set-orcatype      set-orcatype
    'set-initstep      (lambda (n) (set! orca-init (max n orca-init)) #t)
    'stat-server       stat-server
    'stop-server       stop-server
    'wait-server       wait-server
    'semiwait-server   semiwait-server
    'start-mail        start-mail
    'update-medid      update-medid
    'update-primary    update-primary
    'update-secondary  update-secondary
    'refresh-cmd       refresh-cmd
    ))