;
;    'profile' object
;                           (C) 2002 Omoikane Inc.
;

(define (conf-prof)
  
  ; var
  (define lines '())     ; (<key:str> <l:str>)
  (define update? #f)
  
  ; method
  (define (load-it)
    (if (not (unix-access? "/var/lib/ogl/etc/profile" '(read)))
      #t
      (let ((r (ttable-read "/var/lib/ogl/etc/profile" '((str str)))))
        (cond
          ((eq? #f r)
            #f)
          (else
            (set! lines r))))))
  
  (define (commit)
    (ttable-write "/var/lib/ogl/etc/profile" lines))
  
  (define (make-etc f)
    (fprintf f
      (apply string-append
        (cons 
          (string-append "# /etc/profile: system-wide .profile file for the Bourne shell (sh(1))\n"
                         "# and Bourne compatible shells (bash(1), ksh(1), ash(1), ...).\n"
                         "# This file was generated by ogl-admin.\n\n")
          (map (lambda (x) (format #f "~a\n" (cadr x)))
               lines)))))
  
  (define (update-line k l)
    (set! update? #t)
    (let ((r (assoc k lines)))
      (cond
        ((eq? #f r)
          (set! lines
            (append lines (list (list k l)))))
        (else
          (set! lines
            (map (lambda (x)
                   (if (equal? (car x) k)
                     (list k l)
                     x))
                 lines))))))
  
  (define (remove-line k)
    (set! update? #t)
    (set! lines
      (filter (lambda (x) (not (equal? (car x) k)))
              lines)))
  
  (make-object
    'commit         commit
    'conf           (lambda () (list (list "/etc/profile" make-etc #t)))
    'load           load-it
    'mid-conf       (lambda () (list "/var/lib/ogl/etc/profile"))
    'remove-line    remove-line
    'update-line    update-line
    'update?        (lambda () update?)
    ))
    
    