#!/bin/sh
string=?;exec /usr/bin/elk -c -h 3000 -l $0 -p /usr/lib/ogl/scm:/usr/lib/elk/scm:/usr/lib/elk/obj:`pwd` `basename $0` $* 2>/dev/null

(load "obj.scm")
(load "util.scm")
(load "conffile.scm")
(load "part.scm")
(load "boot.scm")
(load "mod.scm")
(load "fdisk.scm")
(load "patch.scm")


(set! sh-log 
  (if (unix-access? "/dev/log" '(read))
    "logger" "/var/log/daemon"))
(set! inst-log-context 'admin)

(define (fail&exit m c)
  (format #t m)
  (exit c))

(define (usage)
  (fail&exit "Usage : regist-kernel <version string>\n" 1))

(define (do o v regist?)
;  (format #t "regist? ~a\n" regist?)
  (o 'remove-default v)
  (cond
    ((and regist?
          (not (eq? #t (o 'add-default v))))
      (fail&exit "Warining : failed to add entry. Configuration file modified. nothing done for boot.\nUse ogl-admin or edit /boot/grub/menu.list manually.\n" 10))
    (else
      (case (o 'commit)
        ((#t success)
          #t)
        (else
          (fail&exit "Error : failed to save boot configuration.\n" 1))))))

(unix-setenv "PATH" "/usr/lib/ogl/bin:/usr/bin:/bin:/usr/bin/X11:/usr/local/bin:/sbin/:/usr/sbin")

(let ((a (command-line-args)))
  (cond
    ((and (not (= 2 (length a)))
          (not (= 3 (length a))))
      (usage))
    ((and (not (equal? "regist-kernel" (car a)))
          (not (equal? "unregist-kernel" (car a))))
      (fail&exit
        (format #t
          "Error : this command should be executed as 'regiser-kernel' or 'unregister-kernel' : ~a\ncheck if you have shellutils package."
          (car a))
        1))
    (else
      (let* ((a' (if (= 2 (length a)) a (cdr a)))
             (regist? (or (equal? "regist-kernel" (car a))
                          (equal? "regist-kernel.scm" (car a))))
             (v (cadr a'))
             (p (configure-part "/mnt/tmp"))
             (obj-mod (configure-module)))
        ;(format #t "regist? : ~a\n" regist?)
        (cond
          ((and (= 3 (length a))
                (not (equal? "-f" (cadr a))))
            (format #t "illegal option : ~a\n" (cadr a))
            (usage))
          ;((begin (format #t "z\n") #f) #f)
          ((not (eq? #t (p 'init 'admin)))
            (fail&exit "Error : failed to initialize partition object.\n" 1))
            
          ;((begin (format #t "a\n") #f) #f)
          
          ((not (p 'load))
            (fail&exit "Error : failed to load partition object.\n" 1))
            
          ;((begin (format #t "b\n") #f) #f)
          
          ((not (eq? #t (obj-mod 'init 'admin)))
            (fail&exit "Error : failed to initialize module object.\n" 1))
            
          ;((begin (format #t "xa\n") #f) #f)
          ((not (eq? #t (obj-mod 'load)))
            (fail&exit "Error : failed to load module object.\n" 1))
          (else
            ;(format #t "aaa\n")
            (let* ((o (configure-boot p obj-mod))
                   (patcher (conf-patch o)))
            ;(format #t "bbb\n")
              (o 'init 'admin)
            ;(format #t "c\n")
              (o 'load)
            ;(format #t "d\n")
              (cond
                ((not (null? (patcher 'list-modify)))
            ;(format #t "e\n")
                  (do o v regist?)
                  (o 'commit)
                  (fail&exit "Warning : Configuration file modified. nothing done for boot.\nUse ogl-admin or edit /boot/grub/menu.list manually.\n" 10))
                (else
            ;(format #t "f\n")
                  (if (and (o 'make-initrd v)
                           (eq? #t (do o v regist?)))
                    (patcher 'commit)
                    #f))))))))))
