;
;       Service Management Object
;                                      (C)2001,2002 Omoikane Inc.
;

(define (configure-service)
  
  ; var
  (define table
    (list
      (list "apache"            91 20 (_ "Apache Web Server"))
      (list "apmd"              20 20 (_ "APM Daemon"))
      (list "atokx-arma"        80 20 (_ "ATOK Server (main)"))
      (list "bind9"             80 20 (_ "Bind (name server)"))
      (list "canna-ogl"         20 20 (_ "Canna Server (sub)"))
      (list "fetchmail"         99 15 (_ "Fetchmail (daemon mode)"))
      ;(list "glauth"            40 20 (_ "ORCA server 1/3"))
      ;(list "glserver"          41 20 (_ "ORCA server 2/3"))
      (list "kdm"               99 1  (_ "Display Manager (for GUI login)"))
      (list "inetd"             20 20 (_ "Internet \'Super Daemon\'"))
      (list "lprng"             20 20 (_ "Printer Spooler"))
      ;(list "monitor"           42 20 (_ "ORCA server 3/3"))
      (list "netatalk"          50 50 (_ "Apple Talk server"))
      ;(list "nscd"              19 19 (_ "Name Service Cache Daemon"))
      (list "nfs-common"        19 81 (_ "RPC statd/lockd"))
      (list "nfs-kernel-server" 20 80 (_ "NFS Server"))
      ;("ntpdate"           22 22 (_ "NTP"))
      (list "pcmcia"            20 20 (_ "PCMCIA"))
      (list "postgresql"        20 20 (_ "PostgreSQL"))
      (list "postfix"           20 20 (_ "Postfix (Mail Tranport Agent)"))
      (list "proftpd"           50 50 (_ "Proftpd (FTP server)"))
      (list "samba"             20 20 (_ "Samba"))
      (list "ssh"               20 20 (_ "Secure Shell"))
      ;(list "usogres"           38 38 (_ "Usogres (Postgres duplicator)"))
      ))
  
  ; method
  (define (remove s)
    (cond
      ((not (= 0 (sh "/etc/init.d/~a stop" s)))
        (_ "Could not stop currently running sercice."))
      ((not (= 0 (sh "update-rc.d  -f ~a remove" s)))
        (_ "Failed to remove rc.d."))
      (else
        #t)))
  
  (define (set-start s)
    (let ((r (assoc s table)))
      (cond
        ((eq? #f r)
          (= 0 (sh "update-rc.d ~a defaults" s)))
        (else
          (= 0 (sh "update-rc.d ~a defaults ~a ~a " s (cadr r) (caddr r)))))))
  
  (define (start s)
    (and (= 0 (sh "/etc/init.d/~a start" s))
         (set-start s)))
  
  (define (restart s)
    (sh "/etc/init.d/~a restart" s))
  
  (define (get-list)
    (let ((tmp (unix-tempname)))
      (sh "ls /etc/init.d >~a" tmp)
      (let ((all_ (parse-awk #\space #t tmp)))
        (cond
          ((eq? #f all_)
            (_ "Could not get /etc/init.d list.\n"))
          (else
            (sh "cd /etc/rc2.d >/dev/null ; ls S* | sed 's/^S[0-9][0-9]//' >~a" tmp)
            (let ((on_ (parse-awk #\space #t tmp)))
              (sh "rm ~a" tmp)
              (cond
                ((eq? #f on_)
                  (_ "Could not get /etc/rc2.d list.\n"))
                (else
                  (let ((all (list-set-and (map car table) (map car all_)))
                        (on (map car on_)))
                    ;(format #t "on:~a\n" on)
                    (map (lambda (x)
                           (let ((r (assoc x table)))
                             (append
                               (list (car r) (cadr r) (caddr r) (_ (list-ref r 3)))
                               (list (set-include? x on)))))
                         all))))))))))
  
  (define (start? s)
    (let* ((l0 (unix-read-directory2 "/etc/rc2.d"))
           (l1 (filter
                 (lambda (x) (and (list? x)
                                  (not (null? x))))
                 (map (lambda (x)
                        (string-match x (format #f "S[0-9][0-9]~a$" s)))
                      l0))))
      (cond
        ((null? l0)
          (inst-log "sevice obj : count not read /etc/rc.2d. this is fatal.\n")
          #f)
        (else
          (if (< 1 (length l1))
            (inst-log "sevice obj : irregular /etc/rc.2d. more than one service matches ~a.\n" s))
          (not (null? l1))))))
  
  (define (default)
    (map (lambda (x) (remove x))
         (map car (get-list)))
    (remove "apache")
    (remove "bind9")
    (remove "fetchmail")
    (remove "glauth")
    (remove "glserver")
    (remove "kdm")
    (remove "netatalk")
    (remove "postfix")
    (remove "postgresql")
    (remove "ppp")
    (remove "proftpd")
    (remove "samba")
    (remove "usogres")
    (start "atokx-arma")
    (start "apmd")
    (start "canna-ogl")
    (start "lprng")
    (start "ssh"))
  
  (make-object
    'list         get-list
    'start        start
    'start?       start?
    'set-start    set-start
    'remove       remove
    'restart      restart
    'default      default))
    
  