;#################################
;   OGL-print executable
;#################################

(define (exe-oprint obj)

  ;snewt
  (define (strcheck l)
    (cond ((null? l) '(""))
          ((string? (car l)) (cons (string-append (car l) "\n") (strcheck (cdr l))))
          (else (cons "not string" (strcheck (cdr l))))))
  
  (define (read-item key l)
    (define (ex x)
      (if (null? x) '()
          (if (< (length (car x)) 2)
              (ex (cdr x))
              (cons (cadar x) (ex (cdr x))))))
    (let ((r (assoc-all key l)))
      (if r (ex r) '())))



;########################  Filter configuration #########################          
;--------------   change driver or not?  ----------------
; in case of changeing the driver or no driver, replace or add filter entry and call driver-select




;+++++++++++++++++++++++ filter-config +++++++++++++++++++++++++++ 
  (define (filter-config print)
      (define fname (car print))
      (define driver-spec '())
; driver-spec: driver configuration list

;------- parse options (NOT "OPTION") ------
      (define (parse-op ls)
        (if (null? ls) '()
            (cond
             ((string=? "FILTER" (caar ls)) (parse-op (cdr ls)))
             ((string=? "DRIVER" (caar ls)) (parse-op (cdr ls)))
             ((string=? "DESCRIPTION" (caar ls)) (parse-op (cdr ls)))
             ((string=? "DETAIL" (caar ls)) (parse-op (cdr ls)))
             ((string=? "TYPE" (caar ls)) (parse-op (cdr ls)))
             ;((string=? "TIPS" (caar ls)) (parse-op (cdr ls)))
             ((string=? "OPTION" (caar ls)) (parse-op (cdr ls)))
             (else (let ((op (assoc (caar ls) driver-spec)))
                     (if (and op (not (null? (cdar ls))))
                         (cons (car ls) (parse-op (cdr ls)))
                         (parse-op (cdr ls))))))))

;-------- new filter ---------
      (define (new-filter)
        (define dname (car (read-item "DRIVER" driver-spec)))
        (obj 'fdelete fname)
        (obj 'fadd (append (list (list "FILTER" fname) 
                                 (let ((t (assoc "TYPE" driver-spec)))
                                   (if (and t (> (length t) 1) (substring? "link to:" (cadr t)))
                                       (if (string=? (cadr print) "SMBN")
                                           (list "TYPE" (string-append "smb" (cadr t)))
                                           t)
                                       (if (string=? (cadr print) "SMBN")
                                           (list "TYPE" "smb")
                                           (list "TYPE" "normal"))))
                                 (list "DRIVER" dname))
                           (map (lambda (x) (list (car x) "")) (parse-op (car (obj 'driver dname)))))))
      
    
;----------------- change driver -------------------

      (define (driver-select)
          (let ((r (snewt-nmenu (_ "Non-PostScript printer")
                                (string-append (_ "Choose the appropriate driver for your printer.\n")
                                               (_ "Followings are supported drivers and their descriptions \n")
                                               (_ "You can see further information by pressing enter.\n"))
                                50 5 5 5
                                (list->vector (map (lambda (x) (string-append (car x) " :" (cdr x))) driver-list))
                                (vector (_ "OK") (_ "Cancel")))))
            
            (case (car r)
              ((0) (let ((det (read-item "DETAIL" (car (obj 'driver (car (list-ref driver-list (cdr r))))))))
                     (if (null? det)
                         (set! det (read-item "DESCRIPTION" (car (obj 'driver (car (list-ref driver-list (cdr r))))))))
                     (if (= 1 (snewt-choice (_ "Printer compatibility")
                                            (apply string-append (map (lambda (x) (string-append x "\n")) (reverse det)))
                                            (_ "OK") (_ "Other printer")))
                         (let ((dname (car (list-ref driver-list (cdr r)))))
                           (set! driver-spec (car (obj 'driver dname)))
                           (new-filter)
                           (filter-setting))
                         (driver-select))))

              ((1) (let ((dname (car (list-ref driver-list (cdr r)))))
                     (set! driver-spec (car (obj 'driver dname)))
                     (new-filter)
                     (filter-setting)))
              ((2) '()))))


;---------------  filter-config main  ----------------
      (define (filter-setting)
        (let loop ((fltr (car (obj 'filter fname))))
;  fltr : filter entry to confugure <list>
          (define (get-option ls) ;(([option] . [explanation]) ...)
            (if (null? ls) '()
                (if (null? (cdar ls))
                    (get-option (cdr ls))
                    (cons (cons (caddar ls) (cadar ls)) (get-option (cdr ls))))))
          (define opcand (if (assoc-all "OPTION" driver-spec)
                             (get-option (assoc-all "OPTION" driver-spec))
                             '()))

          (define (replace-item key new ls)
;  key: item name <str>
;  new: list of new item <list of str>
;  ls : filter entry <list>

            (if (null? ls) 
                (if (null? new) '()
                    (cons (list key (car new)) (replace-item key (cdr new) ls)))
                (if (equal? (caar ls) key)
                    (if (null? new)
                        (replace-item key new (cdr ls))
                        (cons (list key (car new)) (replace-item key (cdr new) (cdr ls))))
                    (cons (car ls) (replace-item key new (cdr ls))))))
        
;------- ask item
          (define (ask-item i)
            (let ((r (snewt-nmenu (cadr (assoc i driver-spec)) 
                                  (_ "Choose from followings")
                                  50 5 5 5
                                  (list->vector (cddr (assoc i driver-spec)))
                                  (vector (_ "OK") (_ "Cancel")))))
              (if (= 2 (car r))
                  (read-item i fltr)
                  (list (list-ref (cddr (assoc i driver-spec)) (cdr r))))))

;------ ask-option
          (define (ask-option)
              (define op (read-item "OPTION" fltr)) ;([option] ...)
            
              (define (mkchkls ls)
                (if (null? ls) '()
                    (if (member (caar ls) op)
                        (cons (cons (cdr (assoc (caar ls) opcand)) #t) (mkchkls (cdr ls)))
                        (cons (cons (cdr (assoc (caar ls) opcand)) #f) (mkchkls (cdr ls))))))

              (define (mkopt bool ls)
                (if (or (null? bool) (null? ls)) '()
                    (if (car bool)
                        (cons (car ls) (mkopt (cdr bool) (cdr ls)))
                        (mkopt (cdr bool) (cdr ls)))))

              (define (manual-option ls)
                (if (null? ls) '()
                    (if (assoc (car ls) opcand)
                        (manual-option (cdr ls))
                        (cons (car ls) (manual-option (cdr ls))))))
          ;main
              (let ((mop (manual-option op))
                    (r (snewt-checkbox (_ "Option settings") 
                                       (if (null? opcand)
                                           (_ "There is no option for this driver.")
                                           (_ "Choose from following(s)."))
                                       50 5 5
                                       (list->vector (mkchkls opcand))
                                       (vector (_ "OK") (_ "Cancel")))))
                (if (zero? (car r))
                    (set! op (mkopt (vector->list (cdr r)) (map car opcand))))
                (let ((other (snewt-entries (_ "Option settings")
                                            (string-append (_ "If you want to add the other GS option,\n")
                                                           (_ "type it"))
                                            50 5 5 20
                                            (list (list (_ "option") (if (not (null? mop)) 
                                                                         (apply string-append mop)
                                                                         "")
                                                        0)))))
                  (if (or (null? other) (string=? "" (car other))) op
                      (append op other)))))

;-------  end of ask-option 

        ; filter-setting main
          (let ((driver-type (assoc "TYPE" fltr)))
            (if (and driver-type (> (length driver-type) 1))
                (cond
                    ((substring? "link to:" (cadr driver-type))
                        (snewt-message (_ "Message")
                                       (string-append (_ "You need ")
                                                      (car (read-item "DRIVER" fltr))
                                                      (_ " to be installed")))
                        (new-filter))
                      
                    ((or (string=? "normal" (cadr driver-type)) (string=? "smb" (cadr driver-type)))
                        (let* ((cur (parse-op fltr))
                               (op-val (map (lambda (x) (string-append (cadr (assoc (car x) driver-spec))
                                                                       ": "
                                                                       (if (string=? "" (cadr x))
                                                                           "NA"
                                                                           (cadr x))))
                                            cur))
                               (r (snewt-nmenu (_ "Filter setting")
                                               (string-append (_ "You can configure following items.\n")
                                                              (_ "   driver         : ") (car (read-item "DRIVER" fltr)) "\n"
                                                              (_ "   Current options:\n")
                                                              (apply string-append 
                                                                     (map (lambda (x) (string-append (make-string 18 #\space)
                                                                                                     (if (assoc x opcand)
                                                                                                         (cdr (assoc x opcand))
                                                                                                         x)
                                                                                                     "\n"))
                                                                          (read-item "OPTION" fltr))))
                                               50 5 5 3
                                               (list->vector (append op-val 
                                                                     (list "Other option: Current options are listed above")))
                                               (vector (_ "OK") (_ "Cancel")))))
                          (case (car r)
                            ((0) (if (= (cdr r) (length op-val))
                                     (loop (replace-item "OPTION" (ask-option) fltr))
                                     (loop (replace-item (car (list-ref cur (cdr r))) 
                                                         (ask-item (car (list-ref cur (cdr r))))
                                                         fltr))))
                            ((1) (obj 'freplace fname 
                                      (if (string=? (cadr print) "SMBN")
                                          (replace-item "TYPE" (list "smb") fltr)
                                          (replace-item "TYPE" (list "normal") fltr))))
                            ((2) '()))))
                    (else (snewt-message (_ "Message")  "unknown 'TYPE' tag")))
                (snewt-message (_ "Message") "no 'TYPE' tag")))))
;------------------- end of filter-setting --------------------
; dispatch part
      (let ((flt (car (obj 'filter fname))))
        (if (and flt (assoc (car (read-item "DRIVER" flt)) driver-list))
            (let ((drv-name (car (read-item "DRIVER" flt))))
              (if (= 1 (snewt-choice (_ "Non-PostScript printer")
                                     (string-append (_ "This entry is for ") drv-name)
                                     (_ "OK") (_ "Other")))
                  (begin (set! driver-spec (car (obj 'driver (car (read-item "DRIVER" flt)))))
                         (filter-setting))
                  (driver-select)))
            (driver-select))))


;##########################   End of filter configuration  ####################


  (define (edit-type ty)  ;

    (define (rotlist l rot)
      (if (list? l)
          (if (> rot 0)
              (rotlist (append (cdr l) (list (car l))) (- rot 1))
              l)))
    
    (let* ((type-list (list "LOCAL" "Non-PS" "REMOTE" "SERVER")); "SMBPS" "SMBN"))
           (num (cond 
                 ((string=? ty "LOCAL") 0) 
                 ((string=? ty "Non-PS") 1)
                 ((string=? ty "REMOTE") 2)
                 ((string=? ty "SERVER") 3)
                 ((string=? ty "SMBPS") 4)
                 ((string=? ty "SMBN") 5)
                 (else 0))))
      (let ((r (snewt-nmenu (_ "Printer type") 
                            (string-append (_ "Choose printer type.\n")
                                           (_ "LOCAL : local PostScript printer\n")
                                           (_ "Non-PS: local non-PostScript printer\n")
                                           (_ "REMOTE: remote printer provided by lpd\n")
                                           (_ "        (PostScript printer or remote has proper filter)\n")
                                           (_ "SERVER: remote non-PostScript printer\n")
                                           (_ "        (use local filter)\n")
                                          ; (_ "SMBPS : SMB printer (PostScript)\n")
                                          ; (_ "SMBN  : SMB printer (Non-PostScript)\n")
                                           )
                            50 5 5 7
                            (list->vector (rotlist type-list num))
                            (vector (_ "OK") (_ "Cancel")))))
        (if (zero? (car r))
            (car (rotlist type-list (+ num (cdr r))))
            '()))))

  (define (edit-local n)
    (snewt-entries (_ "Printer Setting")
                   (string-append  (_ "Name  :  printer name\n")
                                   (_ "Device:  device file under /dev/ or pipe to send output to\n")
                                   (_ "      :  if you send to /dev/lp0, just lp0"))
                   50 7 7 30
                   (list (list (_ "Name") (car n) 0)
                         (list (_ "Device") (if (null? (cddr n)) "" (caddr n)) 0))))
  (define (edit-remote n)
    (snewt-entries (_ "Printer Setting")
                   (string-append  (_ "Name        :  printer name at local\n")
                                   (_ "Printer name:  printer name at remote host\n")
                                   (_ "Host name   :  Host name or IP address"))

                   50 7 7 30
                   (list (list (_ "Name") (car n) 0)
                         (list (_ "Printer name") (if (null? (cddr n)) "" (caddr n)) 0)
                         (list (_ "Host name") (if (null? (cdddr n)) "" (cadddr n)) 0))))

  (define (edit-smb n)
    (snewt-entries (_ "Printer Setting")
                   (string-append (_ "Name    : Printer name at local")
                                  (_ "Server  : Server name\n")
                                  (_ "Service : Service name\n"))
                   50 7 7 30
                   (list (list (_ "Name    :") (car n) 0)
                         (list (_ "Server :") (if (null? (cddr n)) "" (caddr n)) 0)
                         (list (_ "Service :") (if (null? (cdddr n)) "" (cadddr n)) 0))))

;#############  base-setting #############
  (define (base-setting pr)
    (let ((ntype (edit-type (cadr pr))))
      (if (null? ntype) '()
          (cond
           ((or (string=? ntype "LOCAL")
                (string=? ntype "Non-PS"))
            (let ((new (edit-local pr)))
              (if (null? new)
                  (base-setting pr)
                  (if (unix-access? (string-append "/dev/" (cadr new)) '(write)) 
                        (list (car new) ntype (cadr new))
                      (begin (snewt-message (_ "Message")
                                            (string-append (_ "Wrong device file.\n")
                                                           (_ "Please make sure that devfs is mounted")))
                             (base-setting (list (car new) ntype (cadr new))))))))

           ((or (string=? ntype "REMOTE")
                (string=? ntype "SERVER"))
            (let ((new (edit-remote pr)))
              (if (null? new)
                  (base-setting pr)
                  (list (car new) ntype (cadr new) (caddr new)))))

           ((or (string=? ntype "SMBPS")
                (string=? ntype "SMBN"))
            (let ((new (edit-smb pr)))
              (if (null? new)
                  (base-setting pr)
                  (list (car new) ntype (cadr new) (caddr new)))))))))

  ;#############  edit-menu #############
  (define (edit-menu n)
; n: printer entry <list>
                       
    (case (snewt-quaternary (_ "Basic configuration")
                            (string-append 
                             (format #f "Print queue name : ~a\n" (_ (list-ref n 0)))
                             (cond
                              ((string=? (list-ref n 1) "LOCAL")
                               (string-append (_ "Local PostScript printer\n\n")
                                              (_ "Print device     :") (_ (list-ref n 2)) (_ "\n")))
                              ((string=? (list-ref n 1) "Non-PS")
                               (string-append (_ "Local Non-PostScript printer\n\n")
                                              (_ "Print device     :") (_ (list-ref n 2)) (_ "\n")))
                              ((string=? (list-ref n 1) "REMOTE")
                               (string-append (_ "Remote lpd\n\n")
                                              (_ "Remote printer   :") (_ (list-ref n 2)) (_ "\n")
                                              (_ "Host name        :") (_ (list-ref n 3)) (_ "\n")))
                              ((string=? (list-ref n 1) "SERVER")
                               (string-append (_ "Print server\n\n")
                                              (_ "Remote printer   :") (_ (list-ref n 2)) (_ "\n")
                                              (_ "Host name        :") (_ (list-ref n 3)) (_ "\n")))
                              ((string=? (list-ref n 1) "SMBPS")
                               (string-append (_ "SMB printer (PostScript)\n")
                                              (_ "Server           :") (_ (list-ref n 2)) (_ "\n")
                                              (_ "Service          :") (_ (list-ref n 3)) (_ "\n")))
                              ((string=? (list-ref n 1) "SMBN")
                               (string-append (_ "SMB printer (Non-PostScript)\n")
                                              (_ "Server           :") (_ (list-ref n 2)) (_ "\n")
                                              (_ "Service          :") (_ (list-ref n 3)) (_ "\n")))))
                            (_ "Edit") (_ "Delete") (_ "Prev") (_ "Test print"))
      ((1) (let ((new (base-setting n)))
             (if (null? new) (edit-menu n) 
                 (begin 
                   (obj 'preplace (car n) new)
                   (if (or (string=? (cadr new) "Non-PS")
                           (string=? (cadr new) "SERVER")
                           (string=? (cadr new) "SMBN"))
                       (begin (if (car (obj 'filter (car n)))
                                  (obj 'filter-rename (car n) (car new)))
                              (filter-config new))
                       (obj 'fdelete (car new))) 
                   ))))
      ((2) (if (= 1 (snewt-choice (_ "Delete printer")
                                  (string-append (_ "You are deleting ")
                                                 (car n)
                                                 (_ "\nAre you sure?"))
                                  (_ "Delete") (_ "Cancel")))
               (obj 'pdelete (car n))))
      ((3) 'prev)
      ((4) (cond
              ((= 2 (snewt-choice (_ "Test print")
                                  (_ "Test page is going to be printed ")
                                  (_ "OK") (_ "Cancel")))
               '())
              ((equal? (snewt-show-while (_ "Test print")
                                     (_ "Printing ...")
                                     15 3
                                     (lambda () (obj 'test-print n)))
                       'wrong-filter)
               (snewt-message (_ "Test print") (_ "Failed to print")))
              (else (snewt-message (_ "Test print") (_ "Please make sure that a tiger has been printed")))))))


  ;############ exit ############
  (define (exit)
    (let ((r (snewt-choice (_ "Printer setting")
                           (string-append (_ "Save or Quit without saving\n"))
                           (_ "Save") (_ "Quit"))))
      
      (if (= r 1) 
          (let ((rs (obj 'save)))
              (case rs
                  ((success) (snewt-message (_ "Message") (_ "Changes have been saved")))
                  ((ask-patch) (if (= (snewt-choice (_ "Appling the patch file")
                                                    (string-append
                                                     (_ "A patch file was found.\n")
                                                     (_ "Would you like to try?\n")
                                                     (_ "It could apply the modification via the other tools or editors.\n"))
                                                    (_ "Apply")
                                                    (_ "Not apply"))
                                      1)
                                   (if (equal? (obj 'commit) 'success)
                                       (snewt-message (_ "Message") (_ "Manual modification was applied"))
                                       (snewt-message (_ "Message") (_ "Failed to patch!")))))
              
                  ((failed-md5sum) (snewt-message (_ "Message") 
						  (string-append (_ "Something is worng with filter or /etc/printcap.")
								 (_ "Make sure filter package was installed"))))
                  ((cannot-save) (snewt-message (_ "Message") (_ "Could not save. Are you root?")))
                  ((cannot-open) (snewt-message (_ "Message") (_ "Could not save. Are you root?")))
                  ((wrong-printer) (snewt-message (_ "Message") 
						  (string-append (_ "Syntax error in internal configuration file")
								 (_ "This may be a bug"))))
                  (else (snewt-message (_ "Message") (_ "unknown error"))))
              (if (or (equal? rs 'success) (equal? rs 'ask-patch))
                  (if (= 1 (snewt-choice (_ "Restarting LPRng")
                                         (string-append (_ "You need to restart LPRng to apply the change."))
                                         (_ "Restart") (_ "Do not restart")))
                      (obj 'restart)))
              (obj 'clean))
          (if (= 1 (snewt-choice (_ "Quiting without saving")
                                 (string-append (_ "You are quiting without saving.\n")
                                                (_ "Are you sure?"))
                                 (_ "Cancel") (_ "Quit")))
              (exit)
              (obj 'clean)))))
  

  ;############# TOP MENU ##############
  (define (top-menu)

    (define (new-entry)
      (let ((new (base-setting (list "" "LOCAL" ""))))
        (cond
           ((null? new) '()) 
           (else (obj 'padd new)
                 (if (or (string=? (cadr new) "Non-PS")
                         (string=? (cadr new) "SERVER")
                         (string=? (cadr new) "SMBN"))
                     (filter-config new))))))

    (let* ((titles (map car (obj 'printer)))
           (r (snewt-nmenu (_ "TOP MENU")
                           (_ "Plese choose entry or create new one.\n")
                           68 5 5 5
                           (list->vector(if (null? titles)
                                            (list "no print que has been configured")
                                            titles))
                           (vector (_ "edit") (_ "new entry") (_ "exit")))))
      (case (car r)
        ((0 1) (if (null? titles)
                   (new-entry)
                   (edit-menu (car (obj 'printer (list-ref titles (cdr r))))))
               (top-menu))
        ((2) (new-entry) (top-menu))
        ((3) (exit)))))
  
  (define ld-state (obj 'load))
  (define driver-list (obj 'driver-index))

  (cond
        ((equal? ld-state 'md5sum) (if (= (snewt-choice  (_  "Confirmation") 
                                                    (string-append
                                                     (_ "/etc/printcap has been modified.\n")
                                                     (_ "Would you like to continue?\n")
                                                     (_ "Some modifications via the other tools or editors\n")
                                                     (_ "may be omitted\n")) 
                                                    (_ "Continue") (_ "Abort"))
                                     1)
                                  (top-menu)))
        ((equal? ld-state 'success) (top-menu))
        ((equal? ld-state 'no-drvtbl) (snewt-message (_ "Message") (_ "There is no driver table file")))

        ((equal? ld-state 'no-conffile) (snewt-message (_ "Message")
						       (string-append (_ "There was no configuration file")
								      (_ "New file is going to be created")))
	                                (top-menu))
        ((list? ld-state) (snewt-message (_ "Error!") (_ "Failed to load configuration file(s)")
                                  (apply string-append (map (lambda (x) (string-append x ", ")) ld-state))))
        (else (snewt-message (_ "Error!") 
			  (string-append (_ "Failed to load configuration file(s)")
					  (symbol->string ld-state)))))
  
  (snewt-message (_ "Message") 
                 (string-append (_ "Plaese make sure that printer device file such as /dev/lp0 is set lp group.\n")
                                (_ "If not, invoke a command such as \"chown root.lp /dev/lp0\"."))))
  
;################################






















