;
;   ץʲ̴
;
;                       (C) 2001,2002 Omikane Inc.
;

(define (conf-vol)

  ; var
  (define vol '())
  (define context 'admin)
  
  ; lib
  (define (cmd t)
    (let ((r (assoc t vol)))
      (cond
        ((eq? #f r) "")
        (else
          (let ((v (* 10 (real->int (sqrt (cadr r))))))
            (format #f "aumix -d /dev/sound/mixer~a -v ~a -w ~a"
                       t v v))))))
  
  ; method
  (define (init c)
    (set! context c)
    (set! vol (map (lambda (x) (list x 70))
                (filter string?
                  (map (lambda (x)
                         (let ((l (string-length x)))
                           (cond
                             ((or (< l 5)
                                  (not (string=? "mixer" (substring x 0 5))))
                               #f)
                             ((= l 5)
                               "")
                             ((not (= l 6))
                               #f)
                             ;((equal? #\W (string-ref x 3))
                             ;  #f)
                             (else
                               (substring x 5 6)))))
                       (unix-read-directory2 "/dev/sound")))))
    (not (null? vol))
    #t)
  
  (define (load-it)
    (let ((r (parse-awk #\space #t (format #f "/var/lib/ogl/etc/mixer"))))
      (cond
        ((eq? #f r)
          #t)
        ((not (= (length vol) (length r)))
          (inst-log "device length differ. negleting old setting\n")
          #t)
        (else
          (set! vol
                (map (lambda (x y)
                       (cond
                         ((null? x) y)
                         (else
                           (let ((n (string->number (car x))))
                             (cond
                               ((number? n)
                                 (list (car y) n))
                               (else
                                 y))))))
                     r vol))
          #t))))
  
  (define (get n)
    (cond
      ((< (length vol) n)
        -1)
      (else
        (cadr (list-ref vol n)))))
  
  (define (apply-it t)
    (= 0 (sh (cmd t))))
  
  (define (set n v)
    (cond
      ((< (length vol) n)
        #f)
      (else
        (let* ((x (list-ref vol n))
               (t (car x)))
          (set! vol
                (append
                  (list-sub vol 0 n)
                  (list (list t v))
                  (list-sub vol (1+ n) (length vol))))
          (= 0 (sh (cmd t)))))))
  
  (define (commit)
    (and (fprintf "/var/lib/ogl/etc/mixer"
           (apply string-append
             (map (lambda (x) (format #f "~a\n" (cadr x)))
                  vol)))
         (= 0 (sh "update-rc.d -f ogl-mix remove"))
         (= 0 (sh "update-rc.d ogl-mix defaults 21"))))
  
  (define (make-init p)
    (and (let ((s (apply string-append
                    (map (lambda (x)
                           (format #f "         ~a\n" (cmd (car x))))
                         vol))))
           (fprintf p
             (string-append
               "#!/bin/sh\n"
               "# Mixer set script generated by ogl-tools\n\n"
               "case \"$1\" in\n"
               "    start)\n"
               "        echo \"Setting basic volumes ...\"\n"
               s
               "        ;;\n"
               "    stop)\n"
               "        ;;\n"
               "    restart)\n"
               "        echo \"Reloading mixer setting...\"\n"
               s
               "        ;;\n"
               "    *)\n"
               "        echo \"Usage : /etc/init.d/ogl-mix {start|stop|reload}\"\n"
               "        ;;\n"
               "esac\nexit 0\n")))
         (= 0 (sh "chmod 755 ~a" p))))

  (define (test t)
    (= 0 (sh "mpg123 -a /dev/sound/dsp~a /usr/lib/ogl/lib/phone.mp3" t)))
  
  (make-object
    'apply      apply-it
    'commit     commit
    'conf       (lambda ()
                  (list (list "/etc/init.d/ogl-mix" make-init #f)))
    'get        get
    'init       init
    'list       (lambda () vol)
    'load       load-it
    'mid-conf   (lambda () (list "/var/lib/ogl/etc/mixer"))
    'test       test
    'set        set
    ))











